<div align="center">

<img src="./logo.svg" width="130" />

# ngx-fluent-form

一个 Angular 动态表单库，由 Fluent API 或 JSON 驱动。

[![npm version](https://img.shields.io/npm/v/ngx-fluent-form/latest.svg)](https://npmjs.com/package/ngx-fluent-form)
![Node.js CI](https://github.com/HyperLife1119/ngx-fluent-form/workflows/Node.js%20CI/badge.svg)
![License](https://img.shields.io/badge/License-MIT-blue.svg)
[![Angular](https://img.shields.io/badge/Build%20with-Angular%20CLI-red?logo=angular)](https://www.github.com/angular/angular)
[![codecov](https://codecov.io/gh/HyperLife1119/ngx-fluent-form/branch/main/graph/badge.svg?token=070GEU44U0)](https://codecov.io/gh/HyperLife1119/ngx-fluent-form)
[![CodeFactor](https://www.codefactor.io/repository/github/hyperlife1119/ngx-fluent-form/badge)](https://www.codefactor.io/repository/github/hyperlife1119/ngx-fluent-form)

</div>

## 特性

- 支持使用 Fluent API 与 JSON。
- 基于 EmbeddedView，没有 HostElement，支持嵌套布局。
- 按需导入，可摇树。
- 建立在 Angular 响应式表单之上。
- 与 [Ant Design](https://ng.ant.design) 集成。

## 安装

```bash
ng add ngx-fluent-form
```

## 文档

有关文档与示例，请访问 [https://hyperlife1119.github.io/ngx-fluent-form](https://hyperlife1119.github.io/ngx-fluent-form)。

## 用法

```ts
import { FluentFormComponent, button, form, number, input } from 'ngx-fluent-form';

@Component({
  standalone: true,
  imports: [FluentFormComponent],
  template: `<fluent-form [(model)]="model" [schema]="schema"></fluent-form>`
})
export class ExampleComponent {
  schema = form(() => {
    input('text');
    number('count');
    button().content('submit');
  });

  model = {
    text: 'I love ngx-fluent-form',
    count: 10
  };
}
```

## 阶段

目前处于 beta 阶段，期待您的积极尝试，我们将持续积极收集用户意见，快速迭代并不断提升功能和性能。

## 支持

喜欢 `ngx-fluent-form` 吗？为该项目点星 ⭐ ！

## 特别鸣谢

感谢 [JetBrains](https://www.jetbrains.com/?from=ngx-fluent-form) 为我们提供免费开源许可证。

![JetBrains Logo (Main) logo](https://resources.jetbrains.com/storage/products/company/brand/logos/jb_beam.svg)

## License

[MIT](https://github.com/HyperLife1119/ngx-fluent-form/blob/main/LICENSE)
