import { EventEmitter, OnChanges, QueryList, SimpleChanges } from '@angular/core';
import { FormControlStatus, FormGroup } from '@angular/forms';
import { AnyObject } from '@ngify/types';
import { FluentTemplateDirective } from '../../directives';
import { AnySchema, FormGroupSchema } from '../../schemas';
import { SchemaKind } from '../../schemas/interfaces';
import * as i0 from "@angular/core";
export declare class FluentFormComponent<T extends AnyObject> implements OnChanges {
    private readonly destroy$;
    private readonly formUtil;
    private readonly modelUtil;
    private readonly schemaUtil;
    /**
     * 内部的不可变模型，主要有以下用途：
     * - 用来跟公开的模型值进行引用比较，判断变更是内部发出的还是外部传入的，如果引用一致则为内部变更
     */
    private internalModel;
    private _schema;
    protected readonly SchemaKind: typeof SchemaKind;
    protected get schemas(): AnySchema[];
    form: FormGroup;
    set schema(value: FormGroupSchema);
    get schema(): FormGroupSchema;
    model: T;
    formChange: EventEmitter<FormGroup>;
    modelChange: EventEmitter<T>;
    valueChanges: EventEmitter<T>;
    statusChanges: EventEmitter<FormControlStatus>;
    submit: EventEmitter<SubmitEvent>;
    templateDirectives: QueryList<FluentTemplateDirective>;
    ngOnChanges(changes: SimpleChanges): void;
    private createForm;
    private updateForm;
    private onValueChanges;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentFormComponent<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FluentFormComponent<any>, "fluent-form", never, { "schema": { "alias": "schema"; "required": true; }; "model": { "alias": "model"; "required": true; }; }, { "formChange": "formChange"; "modelChange": "modelChange"; "valueChanges": "valueChanges"; "statusChanges": "statusChanges"; "submit": "submit"; }, ["templateDirectives"], never, true, never>;
}
