import { Breakpoints } from '../../../breakpoints';
import { Stringify } from '../../../types';
import * as i0 from "@angular/core";
type Gap = 0 | 1 | 2 | 3 | 4 | 5 | 6;
type Justify = 'start' | 'end' | 'center' | 'space-around' | 'space-between' | 'space-evenly';
type Align = 'start' | 'end' | 'center';
export declare class FluentRowDirective {
    private readonly cdr;
    private _gap;
    private _justify;
    private _align;
    /** 当前匹配的断点 */
    private breakpoints;
    set gap(value: Gap | Stringify<Gap> | [x: Gap, y: Gap] | Partial<Record<keyof Breakpoints, Gap | [x: Gap, y: Gap]>> | null | undefined);
    set justify(value: Justify | null | undefined);
    set align(value: Align | null | undefined);
    constructor();
    protected gapPx: import("@angular/core").Signal<[number, (number | undefined)?]>;
    protected justifyContent: import("@angular/core").Signal<string | null | undefined>;
    protected alignItems: import("@angular/core").Signal<string | null | undefined>;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentRowDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FluentRowDirective, "fluent-row,[fluentRow]", ["fluentRow"], { "gap": { "alias": "gap"; "required": false; }; "justify": { "alias": "justify"; "required": false; }; "align": { "alias": "align"; "required": false; }; }, {}, never, never, true, never>;
}
export {};
