import { AlertComponentSchema, ButtonComponentSchema, HeadingComponentSchema, SingleSchemaKey, TemplateSchema, TextComponentSchema } from '../schemas';
import { UnstableBuilder } from './compose-builder';
import { KindOrKey } from './helper';
export declare function template<Key extends SingleSchemaKey>(key: Key): UnstableBuilder<TemplateSchema<Key>, KindOrKey>;
export declare function text<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<TextComponentSchema<Key>, KindOrKey>;
export declare function button<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<ButtonComponentSchema<Key>, KindOrKey>;
export declare function heading1<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<HeadingComponentSchema<Key>, KindOrKeyOrLevel>;
export declare function heading2<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<HeadingComponentSchema<Key>, KindOrKeyOrLevel>;
export declare function heading3<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<HeadingComponentSchema<Key>, KindOrKeyOrLevel>;
export declare function heading4<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<HeadingComponentSchema<Key>, KindOrKeyOrLevel>;
export declare function heading5<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<HeadingComponentSchema<Key>, KindOrKeyOrLevel>;
export declare function heading6<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<HeadingComponentSchema<Key>, KindOrKeyOrLevel>;
export declare function alert<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<AlertComponentSchema<Key>, KindOrKey>;
type KindOrKeyOrLevel = KindOrKey | 'level';
export {};
