import { SafeAny } from '@ngify/types';
import { AbstractControlContainerSchema, AnySchema, FormArraySchema, FormGroupSchema, SchemaKey, SingleSchemaKey } from '../schemas';
import { StableBuilder, UnstableBuilder } from './compose-builder';
import { KindOrKey } from './helper';
export declare function group(): UnstableBuilder<FormGroupSchema<number>, KindOrKey>;
export declare function group<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<FormGroupSchema<Key>, KindOrKey>;
export declare function array(): UnstableBuilder<FormArraySchema<number>, KindOrKey>;
export declare function array<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<FormArraySchema<Key>, KindOrKey>;
export declare function form(composeFn: FormComposeFn): FormGroupSchema;
export declare function form(schemas: AnySchema[]): FormGroupSchema;
export declare function form(builder: StableBuilder<AbstractControlContainerSchema<SchemaKey>>): FormGroupSchema;
type FormComposeFn = () => SafeAny;
export {};
