import { CascaderControlSchema, CheckboxControlSchema, CheckboxGroupControlSchema, DatePickerControlSchema, DateRangePickerControlSchema, HeadlessControlSchema, InputControlSchema, NumberInputControlSchema, RadioGroupControlSchema, RateControlSchema, SchemaKey, SelectControlSchema, SingleSchemaKey, SliderControlSchema, TextareaControlSchema, TimePickerControlSchema, ToggleControlSchema, TreeSelectControlSchema } from '../schemas';
import { UnstableBuilder } from './compose-builder';
import { KindOrKey } from './helper';
export declare function headless<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<HeadlessControlSchema<Key>, KindOrKey>;
export declare function input(): UnstableBuilder<InputControlSchema<number>, KindOrKey>;
export declare function input<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<InputControlSchema<Key>, KindOrKey>;
export declare function password(): UnstableBuilder<InputControlSchema<number>, KindOrKeyOrType>;
export declare function password<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<InputControlSchema<Key>, KindOrKeyOrType>;
export declare function textarea(): UnstableBuilder<TextareaControlSchema<number>, KindOrKey>;
export declare function textarea<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<TextareaControlSchema<Key>, KindOrKey>;
export declare function number(): UnstableBuilder<NumberInputControlSchema<number>, KindOrKey>;
export declare function number<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<NumberInputControlSchema<Key>, KindOrKey>;
export declare function date(): UnstableBuilder<DatePickerControlSchema<number>, KindOrKey>;
export declare function date<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<DatePickerControlSchema<Key>, KindOrKey>;
export declare function datetime(): UnstableBuilder<DatePickerControlSchema<number>, KindOrKey | TimeOrFormat>;
export declare function datetime<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<DatePickerControlSchema<Key>, KindOrKey | TimeOrFormat>;
export declare function time(): UnstableBuilder<TimePickerControlSchema<number>, KindOrKey>;
export declare function time<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<TimePickerControlSchema<Key>, KindOrKey>;
export declare function toggle(): UnstableBuilder<ToggleControlSchema<number>, KindOrKey>;
export declare function toggle<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<ToggleControlSchema<Key>, KindOrKey>;
export declare function select(): UnstableBuilder<SelectControlSchema<number>, KindOrKey>;
export declare function select<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<SelectControlSchema<Key>, KindOrKey>;
export declare function cascader(): UnstableBuilder<CascaderControlSchema<number>, KindOrKey>;
export declare function cascader<Key extends SchemaKey>(key?: Key): UnstableBuilder<CascaderControlSchema<Key>, KindOrKey>;
export declare function treeSelect(): UnstableBuilder<TreeSelectControlSchema<number>, KindOrKey>;
export declare function treeSelect<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<TreeSelectControlSchema<Key>, KindOrKey>;
export declare function radioGroup(): UnstableBuilder<RadioGroupControlSchema<number>, KindOrKey>;
export declare function radioGroup<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<RadioGroupControlSchema<Key>, KindOrKey>;
export declare function checkbox(): UnstableBuilder<CheckboxControlSchema<number>, KindOrKey>;
export declare function checkbox<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<CheckboxControlSchema<Key>, KindOrKey>;
export declare function checkboxGroup(): UnstableBuilder<CheckboxGroupControlSchema<number>, KindOrKey>;
export declare function checkboxGroup<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<CheckboxGroupControlSchema<Key>, KindOrKey>;
export declare function rate(): UnstableBuilder<RateControlSchema<number>, KindOrKey>;
export declare function rate<Key extends SingleSchemaKey>(key?: Key): UnstableBuilder<RateControlSchema<Key>, KindOrKey>;
export declare function slider(): UnstableBuilder<SliderControlSchema<number>, KindOrKey>;
export declare function slider<Key extends SchemaKey>(key?: Key): UnstableBuilder<SliderControlSchema<Key>, KindOrKey>;
export declare function dateRange(): UnstableBuilder<DateRangePickerControlSchema<number>, KindOrKey>;
export declare function dateRange<Key extends SchemaKey>(key?: Key): UnstableBuilder<DateRangePickerControlSchema<Key>, KindOrKey>;
type KindOrKeyOrType = KindOrKey | 'type';
type TimeOrFormat = 'time' | 'format';
export {};
