import { OnChanges, ProviderToken } from '@angular/core';
import { SafeAny } from '@ngify/types';
import * as i0 from "@angular/core";
type ProviderTokenValue<T> = T extends ProviderToken<infer V> ? V : never;
interface FluentInjectContext<T extends ProviderToken<SafeAny>> {
    fluentInject: ProviderTokenValue<T>;
}
/**
 * @internal
 * ```html
 * <ng-container *fluentInject="token as value"></ng-container>
 * ```
 */
export declare class FluentInjectDirective<T extends ProviderToken<SafeAny>> implements OnChanges {
    private readonly templateRef;
    private readonly viewContainerRef;
    private readonly injector;
    private readonly context;
    fluentInject: T;
    fluentInjectDefault?: ProviderTokenValue<T>;
    fluentInjectHost?: boolean;
    fluentInjectSelf?: boolean;
    fluentInjectSkipSelf?: boolean;
    fluentInjectOptional?: boolean;
    constructor();
    ngOnChanges(): void;
    static ngTemplateContextGuard<T extends ProviderToken<SafeAny>>(_: FluentInjectDirective<T>, ctx: unknown): ctx is FluentInjectContext<T>;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentInjectDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FluentInjectDirective<any>, "[fluentInject]", never, { "fluentInject": { "alias": "fluentInject"; "required": false; }; "fluentInjectDefault": { "alias": "fluentInjectDefault"; "required": false; }; "fluentInjectHost": { "alias": "fluentInjectHost"; "required": false; }; "fluentInjectSelf": { "alias": "fluentInjectSelf"; "required": false; }; "fluentInjectSkipSelf": { "alias": "fluentInjectSkipSelf"; "required": false; }; "fluentInjectOptional": { "alias": "fluentInjectOptional"; "required": false; }; }, {}, never, never, true, never>;
}
export {};
