import { EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { FormControlStatus, FormGroup } from '@angular/forms';
import { AnyArray, AnyObject } from '@ngify/types';
import { AnySchema, FormGroupSchema } from '../../schemas';
import { FluentControlContainerDirective } from './models/control-container';
import * as i0 from "@angular/core";
export declare class FluentFormDirective<T extends AnyObject | AnyArray> extends FluentControlContainerDirective<T> implements OnChanges {
    private readonly destroy$;
    private readonly formUtil;
    private readonly modelUtil;
    /**
     * 内部的不可变模型，主要有以下用途：
     * - 用来跟公开的模型值进行引用比较，判断变更是内部发出的还是外部传入的，如果引用一致则为内部变更
     */
    private internalModel;
    private _schema;
    form: FormGroup;
    get schemas(): AnySchema[];
    set schema(value: FormGroupSchema);
    get schema(): FormGroupSchema;
    model: T;
    formChange: EventEmitter<FormGroup>;
    modelChange: EventEmitter<T>;
    valueChanges: EventEmitter<T>;
    statusChanges: EventEmitter<FormControlStatus>;
    /** The submit event will only be triggered when the host element is a form element */
    submit: EventEmitter<SubmitEvent>;
    ngOnChanges(changes: SimpleChanges): void;
    onSubmit(event: SubmitEvent): boolean;
    private createForm;
    private updateForm;
    private onValueChanges;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentFormDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FluentFormDirective<any>, "[fluent-form]", ["fluentForm"], { "schema": { "alias": "fluentSchema"; "required": true; }; "model": { "alias": "fluentModel"; "required": true; }; }, { "formChange": "fluentFormChange"; "modelChange": "fluentModelChange"; "valueChanges": "fluentValueChanges"; "statusChanges": "fluentStatusChanges"; "submit": "fluentSubmit"; }, never, never, true, never>;
}
