import { AbstractControl } from '@angular/forms';
import { AnyArray, AnyObject } from '@ngify/types';
import { AnyContainerSchema } from '../../../schemas';
import { SchemaUtil } from '../../../utils';
import { FluentOutletDirective } from '../outlet.directive';
import * as i0 from "@angular/core";
/**
 * 抽象的控件容器
 */
export declare abstract class FluentControlContainer<T extends AnyObject | AnyArray> {
    /** 当前图示 */
    abstract schema: AnyContainerSchema;
    /** 当前表单 */
    abstract form: AbstractControl;
    /** 当前模型 */
    abstract model: T;
    /** 当前容器的指令 */
    abstract get directive(): FluentControlContainerDirective<T>;
}
export declare abstract class FluentControlContainerDirective<T extends AnyObject | AnyArray> extends FluentControlContainer<T> {
    protected readonly schemaUtil: SchemaUtil;
    protected outlets: FluentOutletDirective<T>[];
    /** @internal */
    get directive(): FluentControlContainerDirective<T>;
    addOutlet(outlet: FluentOutletDirective<T>): void;
    updateOutlet(outlet: FluentOutletDirective<T>): void;
    removeOutlet(outlet: FluentOutletDirective<T>): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentControlContainerDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FluentControlContainerDirective<any>, never, never, {}, {}, never, never, false, never>;
}
