import { OnChanges, OnDestroy, OnInit } from '@angular/core';
import { AbstractControl } from '@angular/forms';
import { AnyArray, AnyObject } from '@ngify/types';
import { AnyComponentSchema, AnyControlSchema, SingleSchemaKey } from '../../schemas';
import { WidgetTemplateContext } from '../../widgets';
import * as i0 from "@angular/core";
export declare class FluentOutletDirective<T extends AnyObject | AnyArray> implements OnInit, OnChanges, OnDestroy, WidgetTemplateContext<AnyComponentSchema | AnyControlSchema, AbstractControl> {
    private readonly registry;
    private readonly viewContainerRef;
    private readonly controlContainer;
    private _schema;
    /** @internal */
    set schema(value: AnyComponentSchema | AnyControlSchema);
    /** @internal */
    get schema(): AnyComponentSchema | AnyControlSchema;
    /** @internal */
    control: AbstractControl;
    /** @internal */
    get model(): T;
    key: SingleSchemaKey;
    ngOnInit(): void;
    ngOnChanges(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentOutletDirective<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FluentOutletDirective<any>, "fluent-outlet", ["fluentOutlet"], { "key": { "alias": "key"; "required": false; }; }, {}, never, never, true, never>;
}
