import { PipeTransform } from '@angular/core';
import { AnyContainerSchema, AnyControlSchema, AnySchema, FormArraySchema, FormGroupSchema, SchemaKey, SingleSchemaKey } from '../schemas';
import * as i0 from "@angular/core";
/**
 * @internal
 */
export declare class FluentSchemaPipe implements PipeTransform {
    private readonly schemaUtil;
    /**
     * 将 value 作为 key，获取 schemas 中的图示
     * @param value
     * @param schemas
     * @param type 用来重载方法的返回值
     */
    transform(value: SingleSchemaKey | SchemaKey[], schema: AnyContainerSchema, type: 'control'): AnyControlSchema | null;
    transform(value: SingleSchemaKey | SchemaKey[], schema: AnyContainerSchema, type: 'group'): FormGroupSchema | null;
    transform(value: SingleSchemaKey | SchemaKey[], schema: AnyContainerSchema, type: 'array'): FormArraySchema | null;
    transform(value: SingleSchemaKey | SchemaKey[], schema: AnyContainerSchema): AnySchema | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<FluentSchemaPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<FluentSchemaPipe, "schema", true>;
}
