import { ValidatorFn } from '@angular/forms';
import { AnyComponentContainerSchema, AnyComponentSchema, AnyComponentWrapperSchema, AnyContainerSchema, AnyControlContainerSchema, AnyControlSchema, AnyControlWrapperSchema, AnySchema, SchemaKey, SingleSchemaKey } from '../schemas';
import { SchemaLike, SchemaType } from '../schemas/interfaces';
import * as i0 from "@angular/core";
export declare class SchemaUtil {
    private readonly schemaMap;
    private readonly schemaPatchers;
    patch<T extends AnySchema>(schema: T): T;
    /**
     * 过滤出首层控件/控件容器图示
     * @param schemas
     */
    filterControls(schemas: AnySchema[]): (AnyControlSchema | AnyControlContainerSchema)[];
    isControlContainer(schema: SchemaLike): schema is AnyControlContainerSchema;
    isControlWrapper(schema: SchemaLike): schema is AnyControlWrapperSchema;
    isControl(schema: SchemaLike): schema is AnyControlSchema;
    isComponentContainer(schema: SchemaLike): schema is AnyComponentContainerSchema;
    isComponentWrapper(schema: SchemaLike): schema is AnyComponentWrapperSchema;
    isComponent(schema: SchemaLike): schema is AnyComponentSchema;
    /**
     * 是否为多字段图示
     * @param schema
     */
    isMultiKeySchema(schema: SchemaLike): boolean;
    /**
     * 是否为路径字段图示
     * @param schema
     */
    isPathKeySchema(schema: SchemaLike): boolean;
    /**
     * 非控件图示，表示其本身或其子节点不会包含控件图示
     * @param schema
     */
    isNonControl(schema: SchemaLike): schema is AnyComponentSchema | AnyComponentWrapperSchema;
    typeOf(schema: SchemaLike): SchemaType | undefined;
    validatorsOf(schema: AnyControlSchema): ValidatorFn[];
    parsePathKey(key: string): string[];
    find(schema: AnyContainerSchema, key: SingleSchemaKey): AnySchema | null;
    find(schema: AnyContainerSchema, key: SchemaKey[]): AnySchema | null;
    find(schema: AnyContainerSchema, path: SingleSchemaKey | SchemaKey[]): AnySchema | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<SchemaUtil, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SchemaUtil>;
}
