import { TemplateRef } from '@angular/core';
import { AbstractControl, FormControl } from '@angular/forms';
import { AnyObject } from '@ngify/types';
import { NzFormNoStatusService } from 'ng-zorro-antd/core/form';
import { AbstractTextControlSchema, AnySchema } from '../schemas';
import * as i0 from "@angular/core";
export interface WidgetTemplateContext<S extends AnySchema, C extends AbstractControl = FormControl> {
    schema: S;
    control: C;
    model: AnyObject;
}
/**
 * @internal
 */
export declare abstract class AbstractWidget<C> {
    protected readonly contextGuard: C;
    templateRef: TemplateRef<C>;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbstractWidget<any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AbstractWidget<any>, never, never, {}, {}, never, never, false, never>;
}
export declare abstract class AbstractTextControlWidget<C> extends AbstractWidget<C> {
    protected readonly InputGroup: typeof NzFormNoStatusService;
    protected readonly helper: {
        readonly length: {
            readonly min: (length: AbstractTextControlSchema['length']) => number | undefined;
            readonly max: (length: AbstractTextControlSchema['length']) => number | undefined;
        };
        readonly autocomplete: {
            readonly compare: (autocomplete: AbstractTextControlSchema['autocomplete']) => (o1: unknown, o2: unknown) => boolean;
        };
    };
}
