import { CdkDragDrop } from '@angular/cdk/drag-drop';
import { FormArray } from '@angular/forms';
import { AbstractSchema, AddableButton, FormArraySchema, SchemaKind, WithOutSchemaReactiveFn } from '../../schemas';
import { AbstractWidget, WidgetTemplateContext } from '../abstract.widget';
import * as i0 from "@angular/core";
type FormArrayWidgetTemplateContext = WidgetTemplateContext<FormArraySchema, FormArray>;
/**
 * @internal
 */
export declare class FormArrayWidget extends AbstractWidget<FormArrayWidgetTemplateContext> {
    private readonly schemaUtil;
    private readonly formUtil;
    protected readonly SchemaKind: typeof SchemaKind;
    protected push(control: FormArray, schema: FormArraySchema): void;
    protected drop(control: FormArray, event: CdkDragDrop<unknown>): void;
    protected readonly helper: {
        readonly length: {
            readonly min: (length: FormArraySchema['length']) => number;
            readonly max: (length: FormArraySchema['length']) => number;
        };
        readonly addable: (addable: WithOutSchemaReactiveFn<FormArraySchema['addable']>) => AddableButton;
    };
    withIndex(index: number, schema: AbstractSchema): AbstractSchema;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormArrayWidget, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FormArrayWidget, "ng-component", never, {}, {}, never, never, true, never>;
}
export {};
