import { NgTemplateOutlet, NgIf, NgSwitch, NgSwitchCase, NgSwitchDefault, NgClass, NgFor, NgStyle } from '@angular/common';
import * as i0 from '@angular/core';
import { Injectable, Directive, Input, runInInjectionContext, inject, TemplateRef, ViewContainerRef, Injector, InjectionToken, EnvironmentInjector, createComponent, EventEmitter, forwardRef, Output, HostListener, NgModule, DestroyRef, Component, ViewEncapsulation, Renderer2, ElementRef, ChangeDetectorRef, signal, computed, Pipe, ChangeDetectionStrategy, ContentChildren, ViewChild, makeEnvironmentProviders } from '@angular/core';
import * as i2 from 'ng-zorro-antd/form';
import { NzFormModule } from 'ng-zorro-antd/form';
import { NzDestroyService } from 'ng-zorro-antd/core/services';
import { takeUntil, fromEvent, map, tap, Subject, filter } from 'rxjs';
import * as i1$1 from '@angular/forms';
import { Validators, FormControl, FormGroup, FormArray, ReactiveFormsModule } from '@angular/forms';
import { BreakpointObserver } from '@angular/cdk/layout';
import { toSignal } from '@angular/core/rxjs-interop';
import * as i1 from 'ng-zorro-antd/grid';
import { NzFormNoStatusService } from 'ng-zorro-antd/core/form';
import * as i1$2 from 'ng-zorro-antd/alert';
import { NzAlertModule } from 'ng-zorro-antd/alert';
import * as i1$3 from 'ng-zorro-antd/button';
import { NzButtonModule } from 'ng-zorro-antd/button';
import * as i2$1 from 'ng-zorro-antd/core/transition-patch';
import * as i3$1 from 'ng-zorro-antd/core/outlet';
import { NzOutletModule } from 'ng-zorro-antd/core/outlet';
import * as i4 from 'ng-zorro-antd/icon';
import { NzIconModule } from 'ng-zorro-antd/icon';
import * as i3 from 'ng-zorro-antd/core/wave';
import * as i2$2 from 'ng-zorro-antd/cascader';
import { NzCascaderModule } from 'ng-zorro-antd/cascader';
import * as i2$3 from 'ng-zorro-antd/checkbox';
import { NzCheckboxModule } from 'ng-zorro-antd/checkbox';
import * as i2$4 from 'ng-zorro-antd/date-picker';
import { NzDatePickerModule } from 'ng-zorro-antd/date-picker';
import * as i1$4 from '@angular/cdk/drag-drop';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import * as i1$5 from 'ng-zorro-antd/typography';
import { NzTypographyModule } from 'ng-zorro-antd/typography';
import * as i2$5 from 'ng-zorro-antd/input';
import { NzInputModule } from 'ng-zorro-antd/input';
import * as i4$1 from 'ng-zorro-antd/auto-complete';
import { NzAutocompleteModule } from 'ng-zorro-antd/auto-complete';
import * as i1$6 from 'ng-zorro-antd/input-number';
import { NzInputNumberModule } from 'ng-zorro-antd/input-number';
import * as i2$6 from 'ng-zorro-antd/radio';
import { NzRadioModule } from 'ng-zorro-antd/radio';
import * as i2$7 from 'ng-zorro-antd/rate';
import { NzRateModule } from 'ng-zorro-antd/rate';
import * as i2$8 from 'ng-zorro-antd/select';
import { NzSelectModule } from 'ng-zorro-antd/select';
import * as i2$9 from 'ng-zorro-antd/slider';
import { NzSliderModule } from 'ng-zorro-antd/slider';
import * as i1$7 from 'ng-zorro-antd/steps';
import { NzStepsModule } from 'ng-zorro-antd/steps';
import * as i1$8 from 'ng-zorro-antd/tabs';
import { NzTabsModule } from 'ng-zorro-antd/tabs';
import * as i2$a from 'ng-zorro-antd/time-picker';
import { NzTimePickerModule } from 'ng-zorro-antd/time-picker';
import * as i2$b from 'ng-zorro-antd/switch';
import { NzSwitchModule } from 'ng-zorro-antd/switch';
import * as i2$c from 'ng-zorro-antd/tree-select';
import { NzTreeSelectModule } from 'ng-zorro-antd/tree-select';

function isEventListener(value) {
    return 'listeners' in value;
}
function isPropertyPatcher(value) {
    return 'properties' in value;
}
// TODO：改为 NzDestroyService 会导致 select option 联动有问题，这里更换一个 token 来解决
class DestroyService extends NzDestroyService {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DestroyService, deps: null, target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DestroyService }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DestroyService, decorators: [{
            type: Injectable
        }] });
/**
 * @internal
 */
class FluentBindingDirective {
    set fluentBinding(value) {
        const { component, schema, control, model } = value;
        const host = component ?? this.elementRef.nativeElement;
        this.destory$.next();
        if (isPropertyPatcher(schema) && schema.properties) {
            for (const [property, value] of Object.entries(schema.properties)) {
                host[property] = value;
            }
        }
        if (isEventListener(schema) && schema.listeners) {
            const context = { control, schema, model };
            for (const [eventName, listener] of Object.entries(schema.listeners)) {
                if (eventName === 'valueChange') {
                    control.valueChanges.pipe(takeUntil(this.destory$)).subscribe(value => {
                        listener(value, context);
                    });
                    continue;
                }
                if (eventName === 'statusChange') {
                    control.statusChanges.pipe(takeUntil(this.destory$)).subscribe(status => {
                        listener(status, context);
                    });
                    continue;
                }
                if (host instanceof HTMLElement) {
                    fromEvent(host, eventName).pipe(takeUntil(this.destory$)).subscribe(event => {
                        listener(event, context);
                    });
                    continue;
                }
                host[eventName].pipe(takeUntil(this.destory$)).subscribe(event => {
                    listener(event, context);
                });
            }
        }
    }
    constructor(elementRef, destory$) {
        this.elementRef = elementRef;
        this.destory$ = destory$;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentBindingDirective, deps: [{ token: i0.ElementRef }, { token: DestroyService }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentBindingDirective, isStandalone: true, selector: "[fluentBinding]", inputs: { fluentBinding: "fluentBinding" }, providers: [DestroyService], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentBindingDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fluentBinding]',
                    standalone: true,
                    providers: [DestroyService],
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: DestroyService }]; }, propDecorators: { fluentBinding: [{
                type: Input
            }] } });

/**
 * @internal
 */
class FluentContextGuardDirective {
    static ngTemplateContextGuard(_, context) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentContextGuardDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentContextGuardDirective, isStandalone: true, selector: "ng-template[fluentContextGuard]", inputs: { fluentContextGuard: "fluentContextGuard" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentContextGuardDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'ng-template[fluentContextGuard]',
                    standalone: true
                }]
        }], propDecorators: { fluentContextGuard: [{
                type: Input
            }] } });

/**
 * @internal
 */
class FluentContextDirective {
    set fluentContext(value) {
        runInInjectionContext(this.injector, () => {
            this.context.fluentContext = new value();
        });
    }
    constructor() {
        this.templateRef = inject((TemplateRef));
        this.viewContainerRef = inject(ViewContainerRef);
        this.injector = inject(Injector);
        this.context = { fluentContext: null };
        this.viewContainerRef.createEmbeddedView(this.templateRef, this.context);
    }
    static ngTemplateContextGuard(_, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentContextDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentContextDirective, isStandalone: true, selector: "[fluentContext]", inputs: { fluentContext: "fluentContext" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentContextDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fluentContext]',
                    standalone: true
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { fluentContext: [{
                type: Input
            }] } });

/**
 * @internal
 * ```html
 * <ng-container *fluentInject="token as value"></ng-container>
 * ```
 */
class FluentInjectDirective {
    constructor() {
        this.templateRef = inject(TemplateRef);
        this.viewContainerRef = inject(ViewContainerRef);
        this.injector = inject(Injector);
        this.context = { fluentInject: null };
        this.viewContainerRef.createEmbeddedView(this.templateRef, this.context);
    }
    ngOnChanges() {
        this.context.fluentInject = this.injector.get(this.fluentInject, this.fluentInjectDefault, {
            host: this.fluentInjectHost,
            self: this.fluentInjectSelf,
            skipSelf: this.fluentInjectSkipSelf,
            optional: this.fluentInjectOptional,
        });
    }
    static ngTemplateContextGuard(_, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentInjectDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentInjectDirective, isStandalone: true, selector: "[fluentInject]", inputs: { fluentInject: "fluentInject", fluentInjectDefault: "fluentInjectDefault", fluentInjectHost: "fluentInjectHost", fluentInjectSelf: "fluentInjectSelf", fluentInjectSkipSelf: "fluentInjectSkipSelf", fluentInjectOptional: "fluentInjectOptional" }, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentInjectDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fluentInject]',
                    standalone: true
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { fluentInject: [{
                type: Input
            }], fluentInjectDefault: [{
                type: Input
            }], fluentInjectHost: [{
                type: Input
            }], fluentInjectSelf: [{
                type: Input
            }], fluentInjectSkipSelf: [{
                type: Input
            }], fluentInjectOptional: [{
                type: Input
            }] } });

const resolvedPromise = Promise.resolve();
function runMicrotask(callback) {
    return resolvedPromise.then(callback);
}

/**
 * @public
 */
var SchemaType;
(function (SchemaType) {
    SchemaType[SchemaType["Control"] = 0] = "Control";
    SchemaType[SchemaType["ControlContainer"] = 1] = "ControlContainer";
    SchemaType[SchemaType["ControlWrapper"] = 2] = "ControlWrapper";
    SchemaType[SchemaType["Component"] = 3] = "Component";
    SchemaType[SchemaType["ComponentContainer"] = 4] = "ComponentContainer";
    SchemaType[SchemaType["ComponentWrapper"] = 5] = "ComponentWrapper";
})(SchemaType || (SchemaType = {}));
/**
 * @public
 */
var SchemaKind;
(function (SchemaKind) {
    SchemaKind["Headless"] = "headless";
    SchemaKind["Input"] = "input";
    SchemaKind["Textarea"] = "textarea";
    SchemaKind["Number"] = "number";
    SchemaKind["Date"] = "date";
    SchemaKind["DateRange"] = "date-range";
    SchemaKind["Time"] = "time";
    SchemaKind["Toggle"] = "toggle";
    SchemaKind["Select"] = "select";
    SchemaKind["Cascader"] = "cascader";
    SchemaKind["Slider"] = "slider";
    SchemaKind["RadioGroup"] = "radio-group";
    SchemaKind["Checkbox"] = "checkbox";
    SchemaKind["CheckboxGroup"] = "checkbox-group";
    SchemaKind["Rate"] = "rate";
    SchemaKind["TreeSelect"] = "tree-select";
    SchemaKind["InputGroup"] = "input-group";
    SchemaKind["NumberGroup"] = "number-group";
    SchemaKind["Group"] = "group";
    SchemaKind["Array"] = "array";
    SchemaKind["Template"] = "template";
    SchemaKind["Text"] = "text";
    SchemaKind["Button"] = "button";
    SchemaKind["Heading"] = "heading";
    SchemaKind["Alert"] = "alert";
    SchemaKind["ButtonGroup"] = "button-group";
    SchemaKind["Steps"] = "steps";
    SchemaKind["Step"] = "step";
    SchemaKind["Tabs"] = "tabs";
    SchemaKind["Tab"] = "tab";
    SchemaKind["Row"] = "row";
})(SchemaKind || (SchemaKind = {}));

const RETURN_STR = 'return ';
const STATIC_EXPRESSION_PATTERN = /^{{.+}}$/;
const INTERPOLATION_PATTERN = /^{{|}}$/g;
class CodeEvaluator {
}
function isStaticExpression(str) {
    return STATIC_EXPRESSION_PATTERN.test(str);
}
/**
 * @internal
 */
class DynamicCodeEvaluator {
    evaluate(code, context) {
        code = RETURN_STR + code.replace(INTERPOLATION_PATTERN, '');
        const fn = new Function('o', `with(o){${code}}`);
        const proxy = new Proxy(Object.freeze(context), {
            // 拦截所有属性，防止到 Proxy 对象以外的作用域链查找。
            has() {
                return true;
            },
            get(target, key, receiver) {
                if (key === Symbol.unscopables) {
                    return undefined;
                }
                return Reflect.get(target, key, receiver);
            },
        });
        return fn(proxy);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DynamicCodeEvaluator, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DynamicCodeEvaluator }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DynamicCodeEvaluator, decorators: [{
            type: Injectable
        }] });

/**
 * @internal
 */
class ValueTransformer {
    constructor() {
        this.evaluator = inject(CodeEvaluator, { optional: true });
    }
    transform(value, context = {}) {
        if (isFunction(value)) {
            return value(context);
        }
        if (isString(value) && this.evaluator && isStaticExpression(value)) {
            return this.evaluator.evaluate(value, context);
        }
        return value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueTransformer, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueTransformer, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueTransformer, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

function throwWidgetNotFoundError(name) {
    throw new Error(`The '${name}' widget was not found`);
}
function throwCustomTemplateNotFoundError(name) {
    throw new Error(`The custom '${name}' template was not found`);
}

const WIDGET_MAP = new InjectionToken('WidgetMap');
const SCHEMA_MAP = new InjectionToken('SchemaMap');
const TEMPLATE_DIRECTIVES = new InjectionToken('TemplateDirectives');

/**
 * @internal
 */
class WidgetTemplateRegistry extends Map {
    constructor() {
        super(...arguments);
        this.envInjector = inject(EnvironmentInjector);
        this.map = inject(WIDGET_MAP);
    }
    get(kind) {
        return super.get(kind) ?? this.register(kind);
    }
    register(kind) {
        const component = this.map.get(kind);
        if (!component) {
            throwWidgetNotFoundError(kind);
        }
        const { instance } = createComponent(component, {
            environmentInjector: this.envInjector
        });
        this.set(kind, instance.templateRef);
        return instance.templateRef;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: WidgetTemplateRegistry, deps: null, target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: WidgetTemplateRegistry, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: WidgetTemplateRegistry, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

const isObject = (o) => typeof o === 'object';
const isNumber = (o) => typeof o === 'number';
const isString = (o) => typeof o === 'string';
const isFunction = (o) => typeof o === 'function';
const isBoolean = (o) => typeof o === 'boolean';
const isUndefined = (o) => typeof o === 'undefined';
const isArray = (o) => Array.isArray(o);

const SCHEMA_PATCHERS = new InjectionToken('SchemaPatchers');
function provideSchemaPatcher(patcher) {
    return {
        provide: SCHEMA_PATCHERS,
        useValue: patcher,
        multi: true
    };
}

const ANY_SCHEMA_SELECTOR = '*';
class SchemaUtil {
    constructor() {
        this.schemaMap = inject(SCHEMA_MAP);
        this.schemaPatchers = inject(SCHEMA_PATCHERS, { optional: true }) ?? [];
    }
    patch(schema) {
        if ('schemas' in schema) {
            schema.schemas = schema.schemas.map(schema => this.patch(schema));
        }
        const config = this.schemaMap.get(schema.kind);
        if (!config) {
            throwWidgetNotFoundError(schema.kind);
        }
        const { type } = config;
        return this.schemaPatchers
            .filter(patcher => {
            // 将选择器转为数组统一处理
            const selector = isArray(patcher.selector) ? patcher.selector : [patcher.selector];
            return selector.some(kindOrType => {
                if (isString(kindOrType)) {
                    return kindOrType === ANY_SCHEMA_SELECTOR || kindOrType === schema.kind;
                }
                return kindOrType === type;
            });
        })
            .reduce((patchedSchema, patcher) => {
            return patcher.patch(patchedSchema);
        }, schema);
    }
    /**
     * 过滤出首层控件/控件容器图示
     * @param schemas
     */
    filterControls(schemas) {
        return schemas.reduce((schemas, schema) => {
            if (this.isControlWrapper(schema) || this.isComponentContainer(schema)) {
                schemas = schemas.concat(this.filterControls(schema.schemas));
            }
            else if (this.isControlContainer(schema) || this.isControl(schema)) {
                schemas.push(schema);
            }
            return schemas;
        }, []);
    }
    isControlContainer(schema) {
        return this.typeOf(schema) === SchemaType.ControlContainer;
    }
    isControlWrapper(schema) {
        return this.typeOf(schema) === SchemaType.ControlWrapper;
    }
    isControl(schema) {
        return this.typeOf(schema) === SchemaType.Control;
    }
    isComponentContainer(schema) {
        return this.typeOf(schema) === SchemaType.ComponentContainer;
    }
    isComponentWrapper(schema) {
        return this.typeOf(schema) === SchemaType.ComponentWrapper;
    }
    isComponent(schema) {
        return this.typeOf(schema) === SchemaType.Component;
    }
    /**
     * 是否为多字段图示
     * @param schema
     */
    isMultiKeySchema(schema) {
        return isArray(schema.key);
    }
    /**
     * 是否为路径字段图示
     * @param schema
     */
    isPathKeySchema(schema) {
        return isString(schema.key) && schema.key.includes('.');
    }
    /**
     * 非控件图示，表示其本身或其子节点不会包含控件图示
     * @param schema
     */
    isNonControl(schema) {
        return this.isComponent(schema) || this.isComponentWrapper(schema);
    }
    typeOf(schema) {
        return this.schemaMap.get(schema.kind)?.type;
    }
    validatorsOf(schema) {
        const validators = this.schemaMap.get(schema.kind)?.validators?.(schema) ?? [];
        if (schema.required === true) {
            validators.push(Validators.required);
        }
        return validators;
    }
    parsePathKey(key) {
        return key.split('.');
    }
    find(schema, path) {
        const paths = isArray(path)
            ? path.map(o => isArray(o) ? o.toString() : o)
            : path.toString().split('.');
        let _schema = schema;
        for (const path of paths) {
            _schema = _schema.schemas.find(o => o.key?.toString() === path) ?? null;
            if (_schema === null) {
                return _schema;
            }
        }
        return _schema;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SchemaUtil, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SchemaUtil, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SchemaUtil, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * @internal
 */
class ValueUtil {
    constructor() {
        this.schemaUtil = inject(SchemaUtil);
    }
    valueOfModel(model, schema) {
        let value;
        // 如果从模型中读出来的值为 undefined，说明模型中没有写入该值，这里取图示中提供的默认值
        // 如果是多字段模式，则需要从模型中分别取得这这些字段的值组为一个数组
        if (this.schemaUtil.isMultiKeySchema(schema)) {
            value = schema.key.map((key, index) => {
                const val = model[key];
                return isUndefined(val) ? schema.defaultValue?.[index] ?? null : val;
            });
            // 如果数组元素都是 null，那就直接赋值 null
            if (value.every(o => o === null)) {
                value = null;
            }
        }
        else if (this.schemaUtil.isPathKeySchema(schema)) {
            const paths = this.schemaUtil.parsePathKey(schema.key);
            value = paths.reduce((obj, key) => obj?.[key], model);
        }
        else {
            value = model[schema.key];
        }
        if (isUndefined(value)) {
            value = schema.defaultValue ?? null;
        }
        if (schema.mapper) {
            return schema.mapper.parser(value, schema);
        }
        return value;
    }
    valueOfControl(control, schema) {
        const value = control.value;
        if (schema.mapper) {
            return schema.mapper.formatter(value, schema);
        }
        return value;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueUtil, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueUtil, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ValueUtil, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * @internal
 */
class FormUtil {
    constructor() {
        this.schemaUtil = inject(SchemaUtil);
        this.valueUtil = inject(ValueUtil);
        this.valueTransformer = inject(ValueTransformer);
    }
    createFormControl(schema, model) {
        const validators = this.schemaUtil.validatorsOf(schema);
        const value = this.valueUtil.valueOfModel(model, schema) ?? schema.defaultValue;
        return new FormControl(value, {
            nonNullable: !isUndefined(schema.defaultValue),
            validators: schema.validators ? validators.concat(schema.validators) : validators,
            asyncValidators: schema.asyncValidators,
            updateOn: schema.updateOn
        });
    }
    createFormGroup(schemaOrSchemas, model) {
        let schemas;
        let options = {};
        if (isArray(schemaOrSchemas)) {
            schemas = schemaOrSchemas;
        }
        else {
            schemas = schemaOrSchemas.schemas;
            options = {
                validators: schemaOrSchemas.validators,
                asyncValidators: schemaOrSchemas.asyncValidators,
                updateOn: schemaOrSchemas.updateOn
            };
        }
        return new FormGroup(this.createControlMap(schemas, model), options);
    }
    createControlMap(schemas, model) {
        return schemas.reduce((controls, schema) => {
            if (this.schemaUtil.isNonControl(schema)) {
                return controls;
            }
            if (schema.kind === SchemaKind.Group) {
                const key = schema.key.toString();
                controls[key] = this.createFormGroup(schema, model[key] ?? {});
            }
            else if (schema.kind === SchemaKind.Array) {
                const key = schema.key.toString();
                controls[key] = this.createFormArray(schema, model[key] ?? []);
            }
            else if (this.schemaUtil.isControlWrapper(schema) || this.schemaUtil.isComponentContainer(schema)) {
                Object.assign(controls, this.createControlMap(schema.schemas, model));
            }
            else if (this.schemaUtil.isPathKeySchema(schema)) {
                const paths = this.schemaUtil.parsePathKey(schema.key);
                const key = paths.pop();
                const parent = paths.reduce((previousGroup, path) => {
                    let group = previousGroup.get(path);
                    if (!group) {
                        group = new FormGroup({});
                        previousGroup.addControl(path, group);
                    }
                    return group;
                }, (controls[paths.shift()] ??= new FormGroup({})));
                parent.addControl(key, this.createFormControl(schema, model));
            }
            else {
                controls[schema.key.toString()] = this.createFormControl(schema, model);
            }
            return controls;
        }, {});
    }
    createFormArray(schema, model) {
        const controls = this.createFormArrayElements(schema.schemas, model);
        return new FormArray(controls, {
            validators: schema.validators,
            asyncValidators: schema.asyncValidators,
            updateOn: schema.updateOn
        });
    }
    createFormArrayElements(schemas, model) {
        // 只拿第一个，其他的忽略
        const [schema] = this.schemaUtil.filterControls(schemas);
        if (!schema) {
            throw Error('FormArray element control schema not found');
        }
        return model.map((_, index) => {
            return this.createAnyControl({ ...schema, key: index }, model);
        });
    }
    createAnyControl(schema, model) {
        switch (schema.kind) {
            case SchemaKind.Group:
                return this.createFormGroup(schema, model[schema.key] ?? {});
            case SchemaKind.Array:
                return this.createFormArray(schema, model[schema.key] ?? []);
            default:
                return this.createFormControl(schema, model);
        }
    }
    updateForm(form, model, schemas, completed = true) {
        for (const schema of schemas) {
            // 这些图示不包含控件图示，直接跳过
            if (this.schemaUtil.isNonControl(schema))
                continue;
            if (schema.kind === SchemaKind.Group) {
                const key = schema.key;
                const formGroup = getChildControl(form, key);
                this.updateForm(formGroup, model[key], schema.schemas, false);
                continue;
            }
            if (schema.kind === SchemaKind.Array) {
                const key = schema.key;
                const formArray = getChildControl(form, key);
                const [elementSchema] = this.schemaUtil.filterControls(schema.schemas);
                const elementSchemas = formArray.controls.map((_, index) => ({ ...elementSchema, key: index }));
                this.updateForm(formArray, model[schema.key], elementSchemas, false);
                continue;
            }
            if (this.schemaUtil.isControlWrapper(schema) || this.schemaUtil.isComponentContainer(schema)) {
                this.updateForm(form, model, schema.schemas, false);
                continue;
            }
            const control = getChildControl(form, schema.key);
            // update disabled
            const disabled = this.valueTransformer.transform(schema.disabled, { model, schema, control });
            if (control.enabled !== !disabled) { // 不一致才更新
                if (disabled) {
                    control.disable({ onlySelf: true });
                }
                else {
                    control.enable({ onlySelf: true });
                }
            }
            // update required validator
            const required = this.valueTransformer.transform(schema.required, { model, schema, control });
            if (required) {
                control.addValidators(Validators.required);
            }
            else {
                control.removeValidators(Validators.required);
            }
        }
        completed && form.updateValueAndValidity({ emitEvent: false });
    }
    updateModel(model, form, schemas) {
        for (const schema of schemas) {
            // 这些图示不包含控件图示，直接跳过
            if (this.schemaUtil.isNonControl(schema))
                continue;
            if (schema.kind === SchemaKind.Group) {
                const key = schema.key;
                const formGroup = getChildControl(form, key);
                this.updateModel(model[key] = {}, formGroup, schema.schemas);
                continue;
            }
            if (schema.kind === SchemaKind.Array) {
                const key = schema.key;
                const formArray = getChildControl(form, key);
                const [elementSchema] = this.schemaUtil.filterControls(schema.schemas);
                const elementSchemas = formArray.controls.map((_, index) => ({ ...elementSchema, key: index }));
                this.updateModel(model[key] = [], formArray, elementSchemas);
                continue;
            }
            if (this.schemaUtil.isControlWrapper(schema) || this.schemaUtil.isComponentContainer(schema)) {
                this.updateModel(model, form, schema.schemas);
                continue;
            }
            const key = schema.key.toString();
            const control = getChildControl(form, key);
            const value = this.valueUtil.valueOfControl(control, schema);
            // 多字段情况
            if (this.schemaUtil.isMultiKeySchema(schema)) {
                schema.key.map((prop, idx) => {
                    model[prop] = value?.[idx] ?? null;
                });
            }
            else if (this.schemaUtil.isPathKeySchema(schema)) {
                const paths = this.schemaUtil.parsePathKey(schema.key);
                let _model = model;
                for (let i = 0; i < paths.length - 1; i++) {
                    const path = paths[i];
                    _model = _model[path] ??= {};
                }
                _model[paths.pop()] = value;
            }
            else {
                model[key] = value;
            }
        }
        return model;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FormUtil, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FormUtil, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FormUtil, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });
/**
 * 根据 form 的类型自动选择使用 .get() 还是 .at() 来获取子控件
 * @param form
 * @param key
 * @returns
 */
function getChildControl(form, key) {
    return form instanceof FormArray ? form.at(key) : form.get(key.toString());
}

/**
 * @internal
 */
class ModelUtil {
    constructor() {
        this.schemaUtil = inject(SchemaUtil);
        this.valueUtil = inject(ValueUtil);
        this.formUtil = inject(FormUtil);
    }
    updateForm(form, model, schemas, completed = true) {
        for (const schema of schemas) {
            // 这些图示不包含控件图示，直接跳过
            if (this.schemaUtil.isNonControl(schema))
                continue;
            if (schema.kind === SchemaKind.Group) {
                const key = schema.key;
                const formGroup = getChildControl(form, key);
                this.updateForm(formGroup, model[key] ??= {}, schema.schemas, false);
                continue;
            }
            if (schema.kind === SchemaKind.Array) {
                const key = schema.key;
                const array = model[key] ??= [];
                const formArray = getChildControl(form, key);
                // 如果模型数组的长度与数组控件长度一致，则原地更新表单值，否则直接重建数组控件
                if (array.length === formArray.length) {
                    const [elementSchema] = this.schemaUtil.filterControls(schema.schemas);
                    const elementSchemas = array.map((_, index) => ({ ...elementSchema, key: index }));
                    this.updateForm(formArray, array, elementSchemas, false);
                }
                else {
                    const controls = this.formUtil.createFormArrayElements(schema.schemas, array);
                    formArray.clear({ emitEvent: false });
                    for (const control of controls) {
                        formArray.push(control, { emitEvent: false });
                    }
                    formArray.updateValueAndValidity({ onlySelf: true });
                }
                continue;
            }
            if (this.schemaUtil.isComponentContainer(schema) || this.schemaUtil.isControlWrapper(schema)) {
                this.updateForm(form, model, schema.schemas, false);
                continue;
            }
            const value = this.valueUtil.valueOfModel(model, schema);
            const control = getChildControl(form, schema.key);
            control.setValue(value, { onlySelf: true });
        }
        // 仅在完成全部子更新时，再关闭 onlySelf
        form.updateValueAndValidity({ onlySelf: !completed });
        return form;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ModelUtil, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ModelUtil, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ModelUtil, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * 抽象的控件容器
 */
class FluentControlContainer {
}
class FluentControlContainerDirective extends FluentControlContainer {
    constructor() {
        super(...arguments);
        this.schemaUtil = inject(SchemaUtil);
        this.outlets = [];
    }
    /** @internal */
    get directive() {
        return this;
    }
    addOutlet(outlet) {
        this.outlets.push(outlet);
    }
    updateOutlet(outlet) {
        const schema = this.schemaUtil.find(this.schema, outlet.key);
        if (schema) {
            outlet.control = this.form.get(outlet.key.toString()) ?? this.form;
            outlet.schema = schema;
        }
    }
    removeOutlet(outlet) {
        const index = this.outlets.indexOf(outlet);
        this.outlets.splice(index, 1);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentControlContainerDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentControlContainerDirective, usesInheritance: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentControlContainerDirective, decorators: [{
            type: Directive
        }] });

class FluentFormDirective extends FluentControlContainerDirective {
    constructor() {
        super(...arguments);
        this.destroy$ = inject(NzDestroyService);
        this.formUtil = inject(FormUtil);
        this.modelUtil = inject(ModelUtil);
        this.formChange = new EventEmitter();
        this.modelChange = new EventEmitter();
        this.valueChanges = new EventEmitter();
        this.statusChanges = new EventEmitter();
        /** The submit event will only be triggered when the host element is a form element */
        // eslint-disable-next-line @angular-eslint/no-output-native
        this.submit = new EventEmitter();
    }
    get schemas() {
        return this.schema?.schemas;
    }
    set schema(value) {
        this._schema = this.schemaUtil.patch(value);
    }
    get schema() {
        return this._schema;
    }
    ngOnChanges(changes) {
        const schemaChange = changes['schema'];
        const modelChange = changes['model'];
        if (schemaChange) {
            this.createForm();
        }
        else if (modelChange) {
            // 如果是外部变更，就赋值到表单
            if (this.model !== this.internalModel) {
                this.updateForm();
            }
        }
    }
    onSubmit(event) {
        this.submit.emit(event);
        return event?.target?.method === 'dialog';
    }
    createForm() {
        this.destroy$.next();
        this.formChange.emit(this.form = this.formUtil.createFormGroup(this.schema, this.model));
        this.onValueChanges();
        this.form.valueChanges.pipe(takeUntil(this.destroy$)).subscribe(value => {
            this.onValueChanges();
            this.valueChanges.emit(value);
        });
        this.form.statusChanges.pipe(takeUntil(this.destroy$)).subscribe(o => this.statusChanges.emit(o));
        this.outlets.forEach(outlet => this.updateOutlet(outlet));
    }
    updateForm() {
        this.modelUtil.updateForm(this.form, this.model, this.schemas);
    }
    onValueChanges() {
        // NG0100，防止在更新模型之前在模板中读取模型
        runMicrotask(() => {
            this.formUtil.updateForm(this.form, this.model = this.internalModel = this.formUtil.updateModel({}, this.form, this.schemas), this.schemas);
            this.modelChange.emit(this.model);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormDirective, deps: null, target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentFormDirective, isStandalone: true, selector: "[fluent-form]", inputs: { schema: ["fluentSchema", "schema"], model: ["fluentModel", "model"] }, outputs: { formChange: "fluentFormChange", modelChange: "fluentModelChange", valueChanges: "fluentValueChanges", statusChanges: "fluentStatusChanges", submit: "fluentSubmit" }, host: { listeners: { "submit": "onSubmit($event)" } }, providers: [
            NzDestroyService,
            {
                provide: FluentControlContainer,
                useExisting: forwardRef(() => FluentFormDirective)
            }
        ], exportAs: ["fluentForm"], usesInheritance: true, usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fluent-form]',
                    exportAs: 'fluentForm',
                    standalone: true,
                    providers: [
                        NzDestroyService,
                        {
                            provide: FluentControlContainer,
                            useExisting: forwardRef(() => FluentFormDirective)
                        }
                    ]
                }]
        }], propDecorators: { schema: [{
                type: Input,
                args: [{ alias: 'fluentSchema', required: true }]
            }], model: [{
                type: Input,
                args: [{ alias: 'fluentModel', required: true }]
            }], formChange: [{
                type: Output,
                args: ['fluentFormChange']
            }], modelChange: [{
                type: Output,
                args: ['fluentModelChange']
            }], valueChanges: [{
                type: Output,
                args: ['fluentValueChanges']
            }], statusChanges: [{
                type: Output,
                args: ['fluentStatusChanges']
            }], submit: [{
                type: Output,
                args: ['fluentSubmit']
            }], onSubmit: [{
                type: HostListener,
                args: ['submit', ['$event']]
            }] } });

class FluentOutletDirective {
    constructor() {
        this.registry = inject(WidgetTemplateRegistry);
        this.viewContainerRef = inject(ViewContainerRef);
        this.controlContainer = inject((FluentControlContainer), { host: true, skipSelf: true });
    }
    /** @internal */
    set schema(value) {
        this._schema = value;
        this.viewContainerRef.length && this.viewContainerRef.clear();
        this.viewContainerRef.createEmbeddedView(this.registry.get(value.kind), this);
    }
    /** @internal */
    get schema() {
        return this._schema;
    }
    /** @internal */
    get model() {
        return this.controlContainer.directive.model;
    }
    ngOnInit() {
        this.controlContainer.directive.addOutlet(this);
    }
    ngOnChanges() {
        this.controlContainer.directive.updateOutlet(this);
    }
    ngOnDestroy() {
        this.controlContainer.directive.removeOutlet(this);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentOutletDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentOutletDirective, isStandalone: true, selector: "fluent-outlet", inputs: { key: "key" }, exportAs: ["fluentOutlet"], usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentOutletDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'fluent-outlet',
                    exportAs: 'fluentOutlet',
                    standalone: true
                }]
        }], propDecorators: { key: [{
                type: Input
            }] } });

class FluentFormLayoutModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormLayoutModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentFormLayoutModule, imports: [FluentFormDirective,
            FluentOutletDirective], exports: [FluentFormDirective,
            FluentOutletDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormLayoutModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormLayoutModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        FluentFormDirective,
                        FluentOutletDirective,
                    ],
                    exports: [
                        FluentFormDirective,
                        FluentOutletDirective,
                    ]
                }]
        }] });

/**
 * @internal
 */
class FluentLifeCycleDirective {
    constructor() {
        this.fluentInit = new EventEmitter();
        this.fluentDestroy = new EventEmitter();
    }
    ngOnInit() {
        this.fluentInit.next();
    }
    ngOnDestroy() {
        this.fluentDestroy.next();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentLifeCycleDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentLifeCycleDirective, isStandalone: true, selector: "[fluentInit],[fluentDestroy]", outputs: { fluentInit: "fluentInit", fluentDestroy: "fluentDestroy" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentLifeCycleDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fluentInit],[fluentDestroy]',
                    standalone: true
                }]
        }], propDecorators: { fluentInit: [{
                type: Output
            }], fluentDestroy: [{
                type: Output
            }] } });

const Breakpoints = {
    xs: '(max-width:575px)',
    sm: '(min-width:576px)',
    md: '(min-width:768px)',
    lg: '(min-width:992px)',
    xl: '(min-width:1200px)',
    xxl: '(min-width:1400px)'
};
function createBreakpointInfix(breakpoint) {
    return breakpoint !== 'xs' ? `-${breakpoint}` : '';
}

function withStyle(component) {
    const environmentInjector = inject(EnvironmentInjector);
    const destroyRef = inject(DestroyRef);
    const componentRef = createComponent(component, { environmentInjector });
    destroyRef.onDestroy(() => componentRef.destroy());
}

class FluentColComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentColComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FluentColComponent, isStandalone: true, selector: "fluent-col", ngImport: i0, template: '', isInline: true, styles: [".fluent-col{position:relative;flex:0 0 auto;min-width:auto}.fluent-col-fill{flex:1 0 0}.fluent-col-offset-auto{margin-left:auto}.fluent-col-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-1{margin-left:8.3333333333%}.fluent-col-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-2{margin-left:16.6666666667%}.fluent-col-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-3{margin-left:25%}.fluent-col-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-4{margin-left:33.3333333333%}.fluent-col-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-5{margin-left:41.6666666667%}.fluent-col-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-6{margin-left:50%}.fluent-col-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-7{margin-left:58.3333333333%}.fluent-col-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-8{margin-left:66.6666666667%}.fluent-col-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-9{margin-left:75%}.fluent-col-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-10{margin-left:83.3333333333%}.fluent-col-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-11{margin-left:91.6666666667%}.fluent-col-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-12{margin-left:100%}@media (min-width: 576px){.fluent-col-sm-fill{flex:1 0 0}.fluent-col-offset-sm-auto{margin-left:auto}.fluent-col-sm-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-sm-1{margin-left:8.3333333333%}.fluent-col-sm-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-sm-2{margin-left:16.6666666667%}.fluent-col-sm-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-sm-3{margin-left:25%}.fluent-col-sm-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-sm-4{margin-left:33.3333333333%}.fluent-col-sm-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-sm-5{margin-left:41.6666666667%}.fluent-col-sm-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-sm-6{margin-left:50%}.fluent-col-sm-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-sm-7{margin-left:58.3333333333%}.fluent-col-sm-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-sm-8{margin-left:66.6666666667%}.fluent-col-sm-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-sm-9{margin-left:75%}.fluent-col-sm-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-sm-10{margin-left:83.3333333333%}.fluent-col-sm-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-sm-11{margin-left:91.6666666667%}.fluent-col-sm-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-sm-12{margin-left:100%}}@media (min-width: 768px){.fluent-col-md-fill{flex:1 0 0}.fluent-col-offset-md-auto{margin-left:auto}.fluent-col-md-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-md-1{margin-left:8.3333333333%}.fluent-col-md-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-md-2{margin-left:16.6666666667%}.fluent-col-md-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-md-3{margin-left:25%}.fluent-col-md-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-md-4{margin-left:33.3333333333%}.fluent-col-md-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-md-5{margin-left:41.6666666667%}.fluent-col-md-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-md-6{margin-left:50%}.fluent-col-md-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-md-7{margin-left:58.3333333333%}.fluent-col-md-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-md-8{margin-left:66.6666666667%}.fluent-col-md-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-md-9{margin-left:75%}.fluent-col-md-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-md-10{margin-left:83.3333333333%}.fluent-col-md-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-md-11{margin-left:91.6666666667%}.fluent-col-md-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-md-12{margin-left:100%}}@media (min-width: 992px){.fluent-col-lg-fill{flex:1 0 0}.fluent-col-offset-lg-auto{margin-left:auto}.fluent-col-lg-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-lg-1{margin-left:8.3333333333%}.fluent-col-lg-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-lg-2{margin-left:16.6666666667%}.fluent-col-lg-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-lg-3{margin-left:25%}.fluent-col-lg-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-lg-4{margin-left:33.3333333333%}.fluent-col-lg-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-lg-5{margin-left:41.6666666667%}.fluent-col-lg-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-lg-6{margin-left:50%}.fluent-col-lg-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-lg-7{margin-left:58.3333333333%}.fluent-col-lg-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-lg-8{margin-left:66.6666666667%}.fluent-col-lg-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-lg-9{margin-left:75%}.fluent-col-lg-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-lg-10{margin-left:83.3333333333%}.fluent-col-lg-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-lg-11{margin-left:91.6666666667%}.fluent-col-lg-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-lg-12{margin-left:100%}}@media (min-width: 1200px){.fluent-col-xl-fill{flex:1 0 0}.fluent-col-offset-xl-auto{margin-left:auto}.fluent-col-xl-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-xl-1{margin-left:8.3333333333%}.fluent-col-xl-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-xl-2{margin-left:16.6666666667%}.fluent-col-xl-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-xl-3{margin-left:25%}.fluent-col-xl-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-xl-4{margin-left:33.3333333333%}.fluent-col-xl-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-xl-5{margin-left:41.6666666667%}.fluent-col-xl-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-xl-6{margin-left:50%}.fluent-col-xl-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-xl-7{margin-left:58.3333333333%}.fluent-col-xl-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-xl-8{margin-left:66.6666666667%}.fluent-col-xl-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-xl-9{margin-left:75%}.fluent-col-xl-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-xl-10{margin-left:83.3333333333%}.fluent-col-xl-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-xl-11{margin-left:91.6666666667%}.fluent-col-xl-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-xl-12{margin-left:100%}}@media (min-width: 1400px){.fluent-col-xxl-fill{flex:1 0 0}.fluent-col-offset-xxl-auto{margin-left:auto}.fluent-col-xxl-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-xxl-1{margin-left:8.3333333333%}.fluent-col-xxl-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-xxl-2{margin-left:16.6666666667%}.fluent-col-xxl-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-xxl-3{margin-left:25%}.fluent-col-xxl-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-xxl-4{margin-left:33.3333333333%}.fluent-col-xxl-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-xxl-5{margin-left:41.6666666667%}.fluent-col-xxl-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-xxl-6{margin-left:50%}.fluent-col-xxl-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-xxl-7{margin-left:58.3333333333%}.fluent-col-xxl-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-xxl-8{margin-left:66.6666666667%}.fluent-col-xxl-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-xxl-9{margin-left:75%}.fluent-col-xxl-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-xxl-10{margin-left:83.3333333333%}.fluent-col-xxl-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-xxl-11{margin-left:91.6666666667%}.fluent-col-xxl-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-xxl-12{margin-left:100%}}\n"], encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentColComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fluent-col', standalone: true, template: '', encapsulation: ViewEncapsulation.None, styles: [".fluent-col{position:relative;flex:0 0 auto;min-width:auto}.fluent-col-fill{flex:1 0 0}.fluent-col-offset-auto{margin-left:auto}.fluent-col-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-1{margin-left:8.3333333333%}.fluent-col-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-2{margin-left:16.6666666667%}.fluent-col-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-3{margin-left:25%}.fluent-col-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-4{margin-left:33.3333333333%}.fluent-col-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-5{margin-left:41.6666666667%}.fluent-col-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-6{margin-left:50%}.fluent-col-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-7{margin-left:58.3333333333%}.fluent-col-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-8{margin-left:66.6666666667%}.fluent-col-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-9{margin-left:75%}.fluent-col-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-10{margin-left:83.3333333333%}.fluent-col-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-11{margin-left:91.6666666667%}.fluent-col-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-12{margin-left:100%}@media (min-width: 576px){.fluent-col-sm-fill{flex:1 0 0}.fluent-col-offset-sm-auto{margin-left:auto}.fluent-col-sm-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-sm-1{margin-left:8.3333333333%}.fluent-col-sm-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-sm-2{margin-left:16.6666666667%}.fluent-col-sm-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-sm-3{margin-left:25%}.fluent-col-sm-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-sm-4{margin-left:33.3333333333%}.fluent-col-sm-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-sm-5{margin-left:41.6666666667%}.fluent-col-sm-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-sm-6{margin-left:50%}.fluent-col-sm-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-sm-7{margin-left:58.3333333333%}.fluent-col-sm-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-sm-8{margin-left:66.6666666667%}.fluent-col-sm-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-sm-9{margin-left:75%}.fluent-col-sm-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-sm-10{margin-left:83.3333333333%}.fluent-col-sm-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-sm-11{margin-left:91.6666666667%}.fluent-col-sm-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-sm-12{margin-left:100%}}@media (min-width: 768px){.fluent-col-md-fill{flex:1 0 0}.fluent-col-offset-md-auto{margin-left:auto}.fluent-col-md-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-md-1{margin-left:8.3333333333%}.fluent-col-md-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-md-2{margin-left:16.6666666667%}.fluent-col-md-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-md-3{margin-left:25%}.fluent-col-md-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-md-4{margin-left:33.3333333333%}.fluent-col-md-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-md-5{margin-left:41.6666666667%}.fluent-col-md-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-md-6{margin-left:50%}.fluent-col-md-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-md-7{margin-left:58.3333333333%}.fluent-col-md-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-md-8{margin-left:66.6666666667%}.fluent-col-md-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-md-9{margin-left:75%}.fluent-col-md-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-md-10{margin-left:83.3333333333%}.fluent-col-md-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-md-11{margin-left:91.6666666667%}.fluent-col-md-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-md-12{margin-left:100%}}@media (min-width: 992px){.fluent-col-lg-fill{flex:1 0 0}.fluent-col-offset-lg-auto{margin-left:auto}.fluent-col-lg-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-lg-1{margin-left:8.3333333333%}.fluent-col-lg-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-lg-2{margin-left:16.6666666667%}.fluent-col-lg-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-lg-3{margin-left:25%}.fluent-col-lg-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-lg-4{margin-left:33.3333333333%}.fluent-col-lg-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-lg-5{margin-left:41.6666666667%}.fluent-col-lg-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-lg-6{margin-left:50%}.fluent-col-lg-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-lg-7{margin-left:58.3333333333%}.fluent-col-lg-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-lg-8{margin-left:66.6666666667%}.fluent-col-lg-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-lg-9{margin-left:75%}.fluent-col-lg-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-lg-10{margin-left:83.3333333333%}.fluent-col-lg-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-lg-11{margin-left:91.6666666667%}.fluent-col-lg-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-lg-12{margin-left:100%}}@media (min-width: 1200px){.fluent-col-xl-fill{flex:1 0 0}.fluent-col-offset-xl-auto{margin-left:auto}.fluent-col-xl-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-xl-1{margin-left:8.3333333333%}.fluent-col-xl-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-xl-2{margin-left:16.6666666667%}.fluent-col-xl-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-xl-3{margin-left:25%}.fluent-col-xl-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-xl-4{margin-left:33.3333333333%}.fluent-col-xl-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-xl-5{margin-left:41.6666666667%}.fluent-col-xl-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-xl-6{margin-left:50%}.fluent-col-xl-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-xl-7{margin-left:58.3333333333%}.fluent-col-xl-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-xl-8{margin-left:66.6666666667%}.fluent-col-xl-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-xl-9{margin-left:75%}.fluent-col-xl-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-xl-10{margin-left:83.3333333333%}.fluent-col-xl-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-xl-11{margin-left:91.6666666667%}.fluent-col-xl-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-xl-12{margin-left:100%}}@media (min-width: 1400px){.fluent-col-xxl-fill{flex:1 0 0}.fluent-col-offset-xxl-auto{margin-left:auto}.fluent-col-xxl-1{flex:0 0 auto;width:8.3333333333%;max-width:8.3333333333%}.fluent-col-offset-xxl-1{margin-left:8.3333333333%}.fluent-col-xxl-2{flex:0 0 auto;width:16.6666666667%;max-width:16.6666666667%}.fluent-col-offset-xxl-2{margin-left:16.6666666667%}.fluent-col-xxl-3{flex:0 0 auto;width:25%;max-width:25%}.fluent-col-offset-xxl-3{margin-left:25%}.fluent-col-xxl-4{flex:0 0 auto;width:33.3333333333%;max-width:33.3333333333%}.fluent-col-offset-xxl-4{margin-left:33.3333333333%}.fluent-col-xxl-5{flex:0 0 auto;width:41.6666666667%;max-width:41.6666666667%}.fluent-col-offset-xxl-5{margin-left:41.6666666667%}.fluent-col-xxl-6{flex:0 0 auto;width:50%;max-width:50%}.fluent-col-offset-xxl-6{margin-left:50%}.fluent-col-xxl-7{flex:0 0 auto;width:58.3333333333%;max-width:58.3333333333%}.fluent-col-offset-xxl-7{margin-left:58.3333333333%}.fluent-col-xxl-8{flex:0 0 auto;width:66.6666666667%;max-width:66.6666666667%}.fluent-col-offset-xxl-8{margin-left:66.6666666667%}.fluent-col-xxl-9{flex:0 0 auto;width:75%;max-width:75%}.fluent-col-offset-xxl-9{margin-left:75%}.fluent-col-xxl-10{flex:0 0 auto;width:83.3333333333%;max-width:83.3333333333%}.fluent-col-offset-xxl-10{margin-left:83.3333333333%}.fluent-col-xxl-11{flex:0 0 auto;width:91.6666666667%;max-width:91.6666666667%}.fluent-col-offset-xxl-11{margin-left:91.6666666667%}.fluent-col-xxl-12{flex:0 0 auto;width:100%;max-width:100%}.fluent-col-offset-xxl-12{margin-left:100%}}\n"] }]
        }] });
class FluentColDirective {
    constructor() {
        this.classes = [];
        this.renderer = inject(Renderer2);
        this.elementRef = inject(ElementRef);
        withStyle(FluentColComponent);
    }
    ngOnInit() {
        const span = this.span;
        const offset = this.offset;
        const classes = [];
        // clear old classes
        for (const clazz of this.classes) {
            this.renderer.removeClass(this.elementRef.nativeElement, clazz);
        }
        if (span) {
            if (isObject(span)) {
                for (const [breakpoint, _span] of Object.entries(span)) {
                    classes.push(createColumnClass(_span, breakpoint));
                }
            }
            else {
                classes.push(createColumnClass(span));
            }
        }
        if (offset) {
            if (isObject(offset)) {
                for (const [breakpoint, _offset] of Object.entries(offset)) {
                    classes.push(createColumnOffsetClass(_offset, breakpoint));
                }
            }
            else {
                classes.push(createColumnOffsetClass(offset));
            }
        }
        // apply new classes
        for (const clazz of classes) {
            this.renderer.addClass(this.elementRef.nativeElement, clazz);
        }
        this.classes = classes;
    }
    ngOnChanges() {
        this.ngOnInit();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentColDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentColDirective, isStandalone: true, selector: "fluent-col,[fluentCol]", inputs: { span: "span", flex: "flex", offset: "offset" }, host: { properties: { "style.flex": "flex" }, classAttribute: "fluent-col" }, exportAs: ["fluentCol"], usesOnChanges: true, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentColDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'fluent-col,[fluentCol]',
                    exportAs: 'fluentCol',
                    standalone: true,
                    host: {
                        class: 'fluent-col',
                        '[style.flex]': 'flex'
                    }
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { span: [{
                type: Input
            }], flex: [{
                type: Input
            }], offset: [{
                type: Input
            }] } });
function createColumnClass(span, breakpoint) {
    let clazz = `fluent-col`;
    if (breakpoint) {
        clazz += createBreakpointInfix(breakpoint);
    }
    if (span) {
        clazz += `-${span}`;
    }
    return clazz;
}
function createColumnOffsetClass(offset, breakpoint) {
    let clazz = `fluent-col-offset`;
    if (breakpoint) {
        clazz += createBreakpointInfix(breakpoint);
    }
    clazz += `-${offset}`;
    return clazz;
}

const SPACER = 16;
const GAPS = {
    0: 0,
    1: SPACER * 0.25,
    2: SPACER * 0.5,
    3: SPACER,
    4: SPACER * 1.5,
    5: SPACER * 2,
    6: SPACER * 3, // 48
};
const BREAKPOINTS = [
    Breakpoints.xs,
    Breakpoints.sm,
    Breakpoints.md,
    Breakpoints.lg,
    Breakpoints.xl,
    Breakpoints.xxl,
];
class FluentRowComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentRowComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FluentRowComponent, isStandalone: true, selector: "fluent-row", ngImport: i0, template: '', isInline: true, styles: [".fluent-row{display:flex;flex-wrap:wrap;margin:calc(var(--gap-x) / -2) calc(var(--gap-y) / -2)}.fluent-row>*{padding:calc(var(--gap-x) / 2) calc(var(--gap-y) / 2)}\n"], encapsulation: i0.ViewEncapsulation.None }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentRowComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fluent-row', standalone: true, template: '', encapsulation: ViewEncapsulation.None, styles: [".fluent-row{display:flex;flex-wrap:wrap;margin:calc(var(--gap-x) / -2) calc(var(--gap-y) / -2)}.fluent-row>*{padding:calc(var(--gap-x) / 2) calc(var(--gap-y) / 2)}\n"] }]
        }] });
class FluentRowDirective {
    set gap(value) {
        this._gap.set(value);
    }
    set justify(value) {
        this._justify.set(value);
    }
    set align(value) {
        this._align.set(value);
    }
    constructor() {
        this.cdr = inject(ChangeDetectorRef);
        this._gap = signal(null);
        this._justify = signal(null);
        this._align = signal(null);
        /** 当前匹配的断点 */
        this.breakpoints = toSignal(inject(BreakpointObserver).observe(BREAKPOINTS).pipe(map(state => Object.keys(state.breakpoints)
            .filter(breakpoint => state.breakpoints[breakpoint])
            .sort((a, b) => BREAKPOINTS.indexOf(b) - BREAKPOINTS.indexOf(a))), tap(() => {
            // TODO：zoneless
            this.cdr.markForCheck();
        })), { initialValue: [] });
        this.gapPx = computed(() => {
            const gap = this._gap();
            const breakpoints = this.breakpoints();
            if (!gap) {
                return getGapPixel(0);
            }
            if (isArray(gap) || isNumber(gap) || isString(gap)) {
                return getGapPixel(gap);
            }
            for (const breakpointValue of breakpoints) {
                for (const breakpointName of Object.keys(gap)) {
                    if (Breakpoints[breakpointName] === breakpointValue) {
                        return getGapPixel(gap[breakpointName]);
                    }
                }
            }
            return getGapPixel(0);
        });
        this.justifyContent = computed(() => parseJustifyOrAlign(this._justify()));
        this.alignItems = computed(() => parseJustifyOrAlign(this._align()));
        withStyle(FluentRowComponent);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentRowDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentRowDirective, isStandalone: true, selector: "fluent-row,[fluentRow]", inputs: { gap: "gap", justify: "justify", align: "align" }, host: { properties: { "style.--gap-x.px": "gapPx()[0]", "style.--gap-y.px": "gapPx()[1]", "style.justify-content": "justifyContent()", "style.align-items": "alignItems()" }, classAttribute: "fluent-row" }, exportAs: ["fluentRow"], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentRowDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'fluent-row,[fluentRow]',
                    exportAs: 'fluentRow',
                    standalone: true,
                    host: {
                        class: 'fluent-row',
                        '[style.--gap-x.px]': 'gapPx()[0]',
                        '[style.--gap-y.px]': 'gapPx()[1]',
                        '[style.justify-content]': 'justifyContent()',
                        '[style.align-items]': 'alignItems()',
                    }
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { gap: [{
                type: Input
            }], justify: [{
                type: Input
            }], align: [{
                type: Input
            }] } });
function getGapPixel(level) {
    if (isArray(level)) {
        return [GAPS[level[0]], GAPS[level[1]]];
    }
    return [0, GAPS[level]];
}
function parseJustifyOrAlign(value) {
    if (value === 'start' || value === 'end') {
        return `flex-${value}`;
    }
    return value;
}

class FluentGridModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentGridModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentGridModule, imports: [FluentRowDirective, FluentColDirective], exports: [FluentRowDirective, FluentColDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentGridModule }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentGridModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [FluentRowDirective, FluentColDirective],
                    exports: [FluentRowDirective, FluentColDirective],
                }]
        }] });

/**
 * @internal
 */
class FluentParentRowDirective {
    constructor() {
        this.row = inject(FluentRowDirective, { skipSelf: true, optional: true });
    }
    get gap() { return this.row?.['_gap'](); }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentParentRowDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentParentRowDirective, isStandalone: true, selector: "fluent-row", exportAs: ["fluentParentRow"], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentParentRowDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'fluent-row',
                    standalone: true,
                    exportAs: 'fluentParentRow'
                }]
        }] });

class FluentTemplateDirective {
    constructor() {
        this.templateRef = inject(TemplateRef);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentTemplateDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentTemplateDirective, isStandalone: true, selector: "[fluentTemplate]", inputs: { name: ["fluentTemplate", "name"] }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentTemplateDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fluentTemplate]',
                    standalone: true
                }]
        }], propDecorators: { name: [{
                type: Input,
                args: ['fluentTemplate']
            }] } });

class FluentVarDirective {
    set fluentVar(value) {
        this.context.fluentVar = value;
    }
    constructor() {
        this.templateRef = inject(TemplateRef);
        this.viewContainerRef = inject(ViewContainerRef);
        this.context = { fluentVar: null };
        this.viewContainerRef.createEmbeddedView(this.templateRef, this.context);
    }
    static ngTemplateContextGuard(_, ctx) {
        return true;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentVarDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentVarDirective, isStandalone: true, selector: "[fluentVar]", inputs: { fluentVar: "fluentVar" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentVarDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[fluentVar]',
                    standalone: true
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { fluentVar: [{
                type: Input
            }] } });

/**
 * @internal
 */
class FluentWithInjectorDirective {
    constructor() {
        const outlet = inject(NgTemplateOutlet);
        const { parentInjector } = inject(ViewContainerRef);
        outlet.ngTemplateOutletInjector = parentInjector;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentWithInjectorDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: FluentWithInjectorDirective, isStandalone: true, selector: "[ngTemplateOutlet][fluentWithInjector]", ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentWithInjectorDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[ngTemplateOutlet][fluentWithInjector]',
                    standalone: true
                }]
        }], ctorParameters: function () { return []; } });

function isColumn(value) {
    return 'span' in value || 'flex' in value || 'offset' in value;
}
/**
 * @internal
 */
class FluentColumnPipe {
    transform(value, type) {
        if (!value) {
            return null;
        }
        if (isObject(value) && isColumn(value)) {
            return value[type] ?? null;
        }
        return type === 'span' ? value : null;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentColumnPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentColumnPipe, isStandalone: true, name: "col" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentColumnPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'col',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class FluentControlPipe {
    transform(value, form) {
        if (isUndefined(value))
            return form;
        return getChildControl(form, value) ?? form;
        // 当获取不到对应的控件实例时，通常说明当前的 schema 不是一个 control schema，这里直接返回父级表单实例☝️
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentControlPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentControlPipe, isStandalone: true, name: "control" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentControlPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'control',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class InvokePipe {
    transform(value, ...args) {
        return value(...args);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: InvokePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: InvokePipe, isStandalone: true, name: "invoke" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: InvokePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'invoke',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class FluentReactivePipe {
    constructor() {
        this.transformer = inject(ValueTransformer);
    }
    transform(value, model, schema, control) {
        // 因为有可能是静态表达式，所以无法确定最终类型
        return this.transformer.transform(value, { model, schema, control });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentReactivePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentReactivePipe, isStandalone: true, name: "reactive" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentReactivePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'reactive',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class FluentSchemaTypePipe {
    constructor() {
        this.schemaMap = inject(SCHEMA_MAP);
    }
    transform(value) {
        return this.schemaMap.get(value).type;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentSchemaTypePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentSchemaTypePipe, isStandalone: true, name: "schemaType" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentSchemaTypePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'schemaType',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class FluentSchemaPipe {
    constructor() {
        this.schemaUtil = inject(SchemaUtil);
    }
    transform(value, schema) {
        return this.schemaUtil.find(schema, value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentSchemaPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentSchemaPipe, isStandalone: true, name: "schema" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentSchemaPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'schema',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class FluentTemplatePipe {
    constructor() {
        this.templateDirectives = inject(TEMPLATE_DIRECTIVES, { optional: true });
    }
    transform(value, defaultValue) {
        // 如果是以 # 开头的字符串，则尝试查询外部注册的模板并返回
        if (isString(value) && value.startsWith('#')) {
            const name = value.slice(1); // remove the '#'
            const dir = this.templateDirectives?.find(o => o.name === name);
            if (dir) {
                return dir.templateRef;
            }
        }
        return value ?? defaultValue;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentTemplatePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentTemplatePipe, isStandalone: true, name: "template" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentTemplatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'template',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class TypeofPipe {
    transform(value, type) {
        const result = typeof value;
        if (type) {
            return result === type;
        }
        return result;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TypeofPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: TypeofPipe, isStandalone: true, name: "typeof" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TypeofPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'typeof',
                    standalone: true
                }]
        }] });

/**
 * @internal
 */
class FluentWidgetTemplatePipe {
    constructor() {
        this.registry = inject(WidgetTemplateRegistry);
        this.templateDirectives = inject(TEMPLATE_DIRECTIVES, { optional: true });
    }
    transform(value) {
        const templateDirectives = this.templateDirectives;
        switch (value.kind) {
            case SchemaKind.Template: {
                const dir = templateDirectives?.find(o => o.name === value.key);
                if (!dir) {
                    throwCustomTemplateNotFoundError(value.key);
                }
                return dir.templateRef;
            }
            case SchemaKind.Headless: {
                // 这里假设在外层已经判断 value.template 是否存在了
                const dir = templateDirectives?.find(o => o.name === value.template);
                if (!dir) {
                    throwCustomTemplateNotFoundError(value.template);
                }
                return dir.templateRef;
            }
            default:
                return this.registry.get(value.kind);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentWidgetTemplatePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentWidgetTemplatePipe, isStandalone: true, name: "widgetTemplate" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentWidgetTemplatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'widgetTemplate',
                    standalone: true
                }]
        }] });

const labelHelper = {
    content: (label) => {
        return isString(label) ? label : label?.content;
    },
    span: (label) => {
        return isString(label) ? null : label?.span;
    },
    width: (label) => {
        if (isString(label) || !label?.width) {
            return null;
        }
        if (isNumber(label.width)) {
            return label.width + 'px';
        }
        return label.width;
    },
};
const tooltipHelper = {
    content: (tooltip) => {
        return isString(tooltip) ? tooltip : tooltip?.content;
    },
    icon: (tooltip) => {
        return isString(tooltip) ? null : tooltip?.icon;
    },
};

/**
 * @internal
 */
class FluentFormItemOutletComponent {
    constructor() {
        this.SchemaType = SchemaType;
        this.helper = {
            label: labelHelper,
            tooltip: tooltipHelper
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormItemOutletComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FluentFormItemOutletComponent, isStandalone: true, selector: "fluent-col[schema],[fluentFormItemOutlet]", inputs: { control: "control", schema: "schema", model: "model" }, ngImport: i0, template: "<ng-container *fluentVar=\"schema.kind | schemaType as schemaType\" [ngSwitch]=\"true\">\n  <ng-container\n    *ngSwitchCase=\"schemaType === SchemaType.ComponentContainer\"\n    fluentWithInjector\n    [ngTemplateOutlet]=\"schema | widgetTemplate\"\n    [ngTemplateOutletContext]=\"{ control, schema, model }\">\n  </ng-container>\n\n  <ng-container\n    *ngSwitchDefault\n    fluentWithInjector\n    [ngTemplateOutlet]=\"formItemTemplate\"\n    [ngTemplateOutletContext]=\"{ control, schema, model, schemaType }\">\n  </ng-container>\n</ng-container>\n\n<ng-content />\n\n<ng-template #formItemTemplate let-control=\"control\" let-schema=\"schema\" let-model=\"model\" let-schemaType=\"schemaType\">\n  <!-- \u5728\u63A7\u4EF6\u88AB input-group \u5305\u88F9\u7684\u65F6\u5019\uFF0C\u63A7\u4EF6\u72B6\u6001/\u63D0\u793A/required\u9ED8\u8BA4\u4F7F\u7528\u7684\u662F input-group \u91CC\u7684\u7B2C\u4E00\u4E2A\u63A7\u4EF6 -->\n  <!-- \u5982\u679C\u9700\u8981\u91C7\u7528 input-group \u5185\u5176\u4ED6\u63A7\u4EF6\uFF0C\u5219\u9700\u8981\u4F7F\u7528 input-group \u7684 primary \u53C2\u6570\u660E\u786E\u6307\u5B9A -->\n  <nz-form-item\n    *fluentVar=\"\n      schemaType === SchemaType.ControlWrapper\n        ? (schema.primary ?? schema.schemas[0].key | schema: schema)\n        : schema as currentSchema\n    \"\n    [ngClass]=\"schema.class\"\n    [style.margin-bottom.px]=\"schemaType === SchemaType.ControlContainer ? 0 : null\">\n    <ng-container *ngIf=\"schema.label\">\n      <nz-form-label\n        *ngIf=\"schema.label | reactive: model : schema : control as label\"\n        [nzSpan]=\"(helper.label.span | invoke: label)!\"\n        [nzTooltipTitle]=\"helper.tooltip.content | invoke: schema.tooltip\"\n        [nzTooltipIcon]=\"(helper.tooltip.icon | invoke: schema.tooltip)!\"\n        [nzFor]=\"schema.id\"\n        [nzRequired]=\"currentSchema.required | reactive: model : schema : control\"\n        [style.width]=\"helper.label.width | invoke: label\">\n        {{ helper.label.content | invoke: label }}\n      </nz-form-label>\n    </ng-container>\n\n    <nz-form-control\n      [nzValidateStatus]=\"currentSchema.key | control: control\"\n      [nzHasFeedback]=\"currentSchema.feedback\"\n      [nzValidatingTip]=\"currentSchema.tips?.validating | template\"\n      [nzSuccessTip]=\"currentSchema.tips?.success | template\"\n      [nzWarningTip]=\"currentSchema.tips?.warning | template\"\n      [nzErrorTip]=\"currentSchema.tips?.error | template\"\n      [nzAutoTips]=\"currentSchema.tips?.auto ?? {}\"\n      [nzExtra]=\"currentSchema.hint | template\">\n      <ng-container\n        fluentWithInjector\n        [ngTemplateOutlet]=\"schema | widgetTemplate\"\n        [ngTemplateOutletContext]=\"{ control, schema, model }\"></ng-container>\n    </nz-form-control>\n  </nz-form-item>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: NgSwitchDefault, selector: "[ngSwitchDefault]" }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: NzFormModule }, { kind: "directive", type: i1.NzColDirective, selector: "[nz-col],nz-col,nz-form-control,nz-form-label", inputs: ["nzFlex", "nzSpan", "nzOrder", "nzOffset", "nzPush", "nzPull", "nzXs", "nzSm", "nzMd", "nzLg", "nzXl", "nzXXl"], exportAs: ["nzCol"] }, { kind: "directive", type: i1.NzRowDirective, selector: "[nz-row],nz-row,nz-form-item", inputs: ["nzAlign", "nzJustify", "nzGutter"], exportAs: ["nzRow"] }, { kind: "component", type: i2.NzFormItemComponent, selector: "nz-form-item", exportAs: ["nzFormItem"] }, { kind: "component", type: i2.NzFormLabelComponent, selector: "nz-form-label", inputs: ["nzFor", "nzRequired", "nzNoColon", "nzTooltipTitle", "nzTooltipIcon", "nzLabelAlign", "nzLabelWrap"], exportAs: ["nzFormLabel"] }, { kind: "component", type: i2.NzFormControlComponent, selector: "nz-form-control", inputs: ["nzSuccessTip", "nzWarningTip", "nzErrorTip", "nzValidatingTip", "nzExtra", "nzAutoTips", "nzDisableAutoTips", "nzHasFeedback", "nzValidateStatus"], exportAs: ["nzFormControl"] }, { kind: "directive", type: FluentWithInjectorDirective, selector: "[ngTemplateOutlet][fluentWithInjector]" }, { kind: "directive", type: FluentVarDirective, selector: "[fluentVar]", inputs: ["fluentVar"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentSchemaPipe, name: "schema" }, { kind: "pipe", type: FluentControlPipe, name: "control" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }, { kind: "pipe", type: FluentWidgetTemplatePipe, name: "widgetTemplate" }, { kind: "pipe", type: FluentSchemaTypePipe, name: "schemaType" }, { kind: "pipe", type: InvokePipe, name: "invoke" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormItemOutletComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fluent-col[schema],[fluentFormItemOutlet]', standalone: true, imports: [
                        NgIf,
                        NgSwitch,
                        NgSwitchCase,
                        NgSwitchDefault,
                        NgClass,
                        NgTemplateOutlet,
                        NzFormModule,
                        FluentWithInjectorDirective,
                        FluentVarDirective,
                        FluentReactivePipe,
                        FluentSchemaPipe,
                        FluentControlPipe,
                        FluentTemplatePipe,
                        FluentWidgetTemplatePipe,
                        FluentSchemaTypePipe,
                        InvokePipe
                    ], changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *fluentVar=\"schema.kind | schemaType as schemaType\" [ngSwitch]=\"true\">\n  <ng-container\n    *ngSwitchCase=\"schemaType === SchemaType.ComponentContainer\"\n    fluentWithInjector\n    [ngTemplateOutlet]=\"schema | widgetTemplate\"\n    [ngTemplateOutletContext]=\"{ control, schema, model }\">\n  </ng-container>\n\n  <ng-container\n    *ngSwitchDefault\n    fluentWithInjector\n    [ngTemplateOutlet]=\"formItemTemplate\"\n    [ngTemplateOutletContext]=\"{ control, schema, model, schemaType }\">\n  </ng-container>\n</ng-container>\n\n<ng-content />\n\n<ng-template #formItemTemplate let-control=\"control\" let-schema=\"schema\" let-model=\"model\" let-schemaType=\"schemaType\">\n  <!-- \u5728\u63A7\u4EF6\u88AB input-group \u5305\u88F9\u7684\u65F6\u5019\uFF0C\u63A7\u4EF6\u72B6\u6001/\u63D0\u793A/required\u9ED8\u8BA4\u4F7F\u7528\u7684\u662F input-group \u91CC\u7684\u7B2C\u4E00\u4E2A\u63A7\u4EF6 -->\n  <!-- \u5982\u679C\u9700\u8981\u91C7\u7528 input-group \u5185\u5176\u4ED6\u63A7\u4EF6\uFF0C\u5219\u9700\u8981\u4F7F\u7528 input-group \u7684 primary \u53C2\u6570\u660E\u786E\u6307\u5B9A -->\n  <nz-form-item\n    *fluentVar=\"\n      schemaType === SchemaType.ControlWrapper\n        ? (schema.primary ?? schema.schemas[0].key | schema: schema)\n        : schema as currentSchema\n    \"\n    [ngClass]=\"schema.class\"\n    [style.margin-bottom.px]=\"schemaType === SchemaType.ControlContainer ? 0 : null\">\n    <ng-container *ngIf=\"schema.label\">\n      <nz-form-label\n        *ngIf=\"schema.label | reactive: model : schema : control as label\"\n        [nzSpan]=\"(helper.label.span | invoke: label)!\"\n        [nzTooltipTitle]=\"helper.tooltip.content | invoke: schema.tooltip\"\n        [nzTooltipIcon]=\"(helper.tooltip.icon | invoke: schema.tooltip)!\"\n        [nzFor]=\"schema.id\"\n        [nzRequired]=\"currentSchema.required | reactive: model : schema : control\"\n        [style.width]=\"helper.label.width | invoke: label\">\n        {{ helper.label.content | invoke: label }}\n      </nz-form-label>\n    </ng-container>\n\n    <nz-form-control\n      [nzValidateStatus]=\"currentSchema.key | control: control\"\n      [nzHasFeedback]=\"currentSchema.feedback\"\n      [nzValidatingTip]=\"currentSchema.tips?.validating | template\"\n      [nzSuccessTip]=\"currentSchema.tips?.success | template\"\n      [nzWarningTip]=\"currentSchema.tips?.warning | template\"\n      [nzErrorTip]=\"currentSchema.tips?.error | template\"\n      [nzAutoTips]=\"currentSchema.tips?.auto ?? {}\"\n      [nzExtra]=\"currentSchema.hint | template\">\n      <ng-container\n        fluentWithInjector\n        [ngTemplateOutlet]=\"schema | widgetTemplate\"\n        [ngTemplateOutletContext]=\"{ control, schema, model }\"></ng-container>\n    </nz-form-control>\n  </nz-form-item>\n</ng-template>\n" }]
        }], propDecorators: { control: [{
                type: Input
            }], schema: [{
                type: Input
            }], model: [{
                type: Input
            }] } });

class FluentFormComponent {
    constructor() {
        this.destroy$ = inject(NzDestroyService);
        this.formUtil = inject(FormUtil);
        this.modelUtil = inject(ModelUtil);
        this.schemaUtil = inject(SchemaUtil);
        this.SchemaKind = SchemaKind;
        this.formChange = new EventEmitter();
        this.modelChange = new EventEmitter();
        this.valueChanges = new EventEmitter();
        this.statusChanges = new EventEmitter();
        // eslint-disable-next-line @angular-eslint/no-output-native
        this.submit = new EventEmitter();
    }
    get schemas() {
        return this.schema?.schemas;
    }
    set schema(value) {
        this._schema = this.schemaUtil.patch(value);
    }
    get schema() {
        return this._schema;
    }
    ngOnChanges(changes) {
        const schemaChange = changes['schema'];
        const modelChange = changes['model'];
        if (schemaChange) {
            this.createForm();
        }
        else if (modelChange) {
            // 如果是外部变更，就赋值到表单
            if (this.model !== this.internalModel) {
                this.updateForm();
            }
        }
    }
    createForm() {
        this.destroy$.next();
        this.formChange.emit(this.form = this.formUtil.createFormGroup(this.schema, this.model));
        this.onValueChanges();
        this.form.valueChanges.pipe(takeUntil(this.destroy$)).subscribe(value => {
            this.onValueChanges();
            this.valueChanges.emit(value);
        });
        this.form.statusChanges.pipe(takeUntil(this.destroy$)).subscribe(o => this.statusChanges.emit(o));
    }
    updateForm() {
        return this.modelUtil.updateForm(this.form, this.model, this.schemas);
    }
    onValueChanges() {
        // NG0100，防止在更新模型之前在模板中读取模型
        runMicrotask(() => {
            this.formUtil.updateForm(this.form, this.model = this.internalModel = this.formUtil.updateModel({}, this.form, this.schemas), this.schemas);
            this.modelChange.emit(this.model);
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FluentFormComponent, isStandalone: true, selector: "fluent-form", inputs: { schema: "schema", model: "model" }, outputs: { formChange: "formChange", modelChange: "modelChange", valueChanges: "valueChanges", statusChanges: "statusChanges", submit: "submit" }, providers: [
            NzDestroyService,
            {
                provide: TEMPLATE_DIRECTIVES,
                useFactory: () => inject(FluentFormComponent).templateDirectives
            }
        ], queries: [{ propertyName: "templateDirectives", predicate: FluentTemplateDirective }], usesOnChanges: true, ngImport: i0, template: "<form\n  nz-form\n  fluentRow\n  [gap]=\"schema.gap\"\n  [justify]=\"schema.justify\"\n  [align]=\"schema.align\"\n  [nzLayout]=\"schema.layout!\"\n  [ngClass]=\"schema.class\"\n  [ngStyle]=\"schema.style\"\n  [formGroup]=\"form\"\n  [fluentBinding]=\"{ schema, control: form, model }\"\n  (submit)=\"$event.stopPropagation()\"\n  (ngSubmit)=\"submit.emit($event)\">\n  <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n    <fluent-col\n      *ngIf=\"schema.kind !== SchemaKind.Headless || (schema.kind === SchemaKind.Headless && schema.template)\"\n      [span]=\"schema.col | col: 'span'\"\n      [flex]=\"schema.col | col: 'flex'\"\n      [offset]=\"schema.col | col: 'offset'\"\n      [hidden]=\"schema.hidden | reactive: model : schema : control\"\n      [control]=\"control\"\n      [schema]=\"schema\"\n      [model]=\"model\">\n    </fluent-col>\n  </ng-template>\n\n  <ng-container\n    *ngFor=\"let subschema of schemas\"\n    [ngTemplateOutlet]=\"formColTemplate\"\n    [ngTemplateOutletContext]=\"{\n      control: (subschema.key | control: form),\n      schema: subschema,\n      model: model\n    }\"></ng-container>\n</form>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.ɵNgNoValidate, selector: "form:not([ngNoForm]):not([ngNativeValidate])" }, { kind: "directive", type: i1$1.NgControlStatusGroup, selector: "[formGroupName],[formArrayName],[ngModelGroup],[formGroup],form:not([ngNoForm]),[ngForm]" }, { kind: "directive", type: i1$1.FormGroupDirective, selector: "[formGroup]", inputs: ["formGroup"], outputs: ["ngSubmit"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzFormModule }, { kind: "directive", type: i2.NzFormDirective, selector: "[nz-form]", inputs: ["nzLayout", "nzNoColon", "nzAutoTips", "nzDisableAutoTips", "nzTooltipIcon", "nzLabelAlign", "nzLabelWrap"], exportAs: ["nzForm"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentRowDirective, selector: "fluent-row,[fluentRow]", inputs: ["gap", "justify", "align"], exportAs: ["fluentRow"] }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "component", type: FluentFormItemOutletComponent, selector: "fluent-col[schema],[fluentFormItemOutlet]", inputs: ["control", "schema", "model"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentControlPipe, name: "control" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormComponent, decorators: [{
            type: Component,
            args: [{ selector: 'fluent-form', standalone: true, imports: [
                        NgIf,
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        ReactiveFormsModule,
                        NzFormModule,
                        FluentGridModule,
                        FluentFormItemOutletComponent,
                        FluentBindingDirective,
                        FluentReactivePipe,
                        FluentControlPipe,
                        FluentColumnPipe
                    ], changeDetection: ChangeDetectionStrategy.OnPush, providers: [
                        NzDestroyService,
                        {
                            provide: TEMPLATE_DIRECTIVES,
                            useFactory: () => inject(FluentFormComponent).templateDirectives
                        }
                    ], template: "<form\n  nz-form\n  fluentRow\n  [gap]=\"schema.gap\"\n  [justify]=\"schema.justify\"\n  [align]=\"schema.align\"\n  [nzLayout]=\"schema.layout!\"\n  [ngClass]=\"schema.class\"\n  [ngStyle]=\"schema.style\"\n  [formGroup]=\"form\"\n  [fluentBinding]=\"{ schema, control: form, model }\"\n  (submit)=\"$event.stopPropagation()\"\n  (ngSubmit)=\"submit.emit($event)\">\n  <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n    <fluent-col\n      *ngIf=\"schema.kind !== SchemaKind.Headless || (schema.kind === SchemaKind.Headless && schema.template)\"\n      [span]=\"schema.col | col: 'span'\"\n      [flex]=\"schema.col | col: 'flex'\"\n      [offset]=\"schema.col | col: 'offset'\"\n      [hidden]=\"schema.hidden | reactive: model : schema : control\"\n      [control]=\"control\"\n      [schema]=\"schema\"\n      [model]=\"model\">\n    </fluent-col>\n  </ng-template>\n\n  <ng-container\n    *ngFor=\"let subschema of schemas\"\n    [ngTemplateOutlet]=\"formColTemplate\"\n    [ngTemplateOutletContext]=\"{\n      control: (subschema.key | control: form),\n      schema: subschema,\n      model: model\n    }\"></ng-container>\n</form>\n" }]
        }], propDecorators: { schema: [{
                type: Input,
                args: [{ required: true }]
            }], model: [{
                type: Input,
                args: [{ required: true }]
            }], formChange: [{
                type: Output
            }], modelChange: [{
                type: Output
            }], valueChanges: [{
                type: Output
            }], statusChanges: [{
                type: Output
            }], submit: [{
                type: Output
            }], templateDirectives: [{
                type: ContentChildren,
                args: [FluentTemplateDirective]
            }] } });

const COMPOSE_KEY = 'schemas';
const SCHEMA_STACK = [];
function getCurrentSchema() {
    return SCHEMA_STACK[SCHEMA_STACK.length - 1];
}
function enterSchema(schmea) {
    SCHEMA_STACK.push(schmea);
}
function leaveSchema() {
    SCHEMA_STACK.pop();
}
const IS_BUILDER = Symbol();
const BUILD_KEY = 'build';
function composeBuilder() {
    const target = {};
    const currentSchema = getCurrentSchema();
    // 如果当前已经有了 schema，就直接 push 进去作为 subschema
    currentSchema?.schemas.push(target);
    const builder = new Proxy(target, {
        get(target, property) {
            switch (property) {
                case IS_BUILDER: return true;
                case BUILD_KEY: return () => target;
                case COMPOSE_KEY:
                    return (composeFn) => {
                        target[COMPOSE_KEY] = [];
                        enterSchema(target);
                        try {
                            composeFn();
                        }
                        finally {
                            leaveSchema();
                        }
                        return builder;
                    };
            }
            return (value) => {
                if (value !== target[property]) {
                    target[property] = value;
                }
                return builder;
            };
        }
    });
    return builder;
}
/**
 * 是否为一个构建器
 * @param value
 */
function isBuilder(value) {
    return value[IS_BUILDER] ?? false;
}

function template(key) {
    return composeBuilder().kind('template').key(key);
}
function text(key) {
    return composeBuilder().kind('text').key(key);
}
function button(key) {
    return composeBuilder().kind('button').key(key);
}
function heading(key) {
    return composeBuilder().kind('heading').key(key);
}
function heading1(key) {
    return heading(key).level(1);
}
function heading2(key) {
    return heading(key).level(2);
}
function heading3(key) {
    return heading(key).level(3);
}
function heading4(key) {
    return heading(key).level(4);
}
function heading5(key) {
    return heading(key).level(5);
}
function heading6(key) {
    return heading(key).level(6);
}
function alert(key) {
    return composeBuilder().kind('alert').key(key);
}

function steps(key) {
    return composeBuilder().kind('steps').key(key);
}
function step(key) {
    return composeBuilder().kind('step').key(key);
}
function tabs(key) {
    return composeBuilder().kind('tabs').key(key);
}
function tab(key) {
    return composeBuilder().kind('tab').key(key);
}
function row(key) {
    return composeBuilder().kind('row').key(key);
}

function buttonGroup(key) {
    return composeBuilder().kind('button-group').key(key);
}

function headless(key) {
    return composeBuilder().kind('headless').key(key);
}
function input(key) {
    return composeBuilder().kind('input').key(key);
}
function password(key) {
    return input(key).type('password');
}
function textarea(key) {
    return composeBuilder().kind('textarea').key(key);
}
function number(key) {
    return composeBuilder().kind('number').key(key);
}
function date(key) {
    return composeBuilder().kind('date').key(key);
}
function datetime(key) {
    return date(key).format('yyyy-MM-dd HH:mm:ss').time(true);
}
function time(key) {
    return composeBuilder().kind('time').key(key);
}
function toggle(key) {
    return composeBuilder().kind('toggle').key(key);
}
function select(key) {
    return composeBuilder().kind('select').key(key);
}
function cascader(key) {
    return composeBuilder().kind('cascader').key(key);
}
function treeSelect(key) {
    return composeBuilder().kind('tree-select').key(key);
}
function radioGroup(key) {
    return composeBuilder().kind('radio-group').key(key);
}
function checkbox(key) {
    return composeBuilder().kind('checkbox').key(key);
}
function checkboxGroup(key) {
    return composeBuilder().kind('checkbox-group').key(key);
}
function rate(key) {
    return composeBuilder().kind('rate').key(key);
}
function slider(key) {
    return composeBuilder().kind('slider').key(key);
}
function dateRange(key) {
    return composeBuilder().kind('date-range').key(key);
}

function group(key) {
    return composeBuilder().kind('group').key(key);
}
function array(key) {
    return composeBuilder().kind('array').key(key);
}
function form(fnOrSchemasOrBuilder) {
    if (isArray(fnOrSchemasOrBuilder)) {
        return {
            kind: 'group',
            key: 'root',
            schemas: fnOrSchemasOrBuilder,
        };
    }
    if (isFunction(fnOrSchemasOrBuilder)) {
        return group('root').schemas(fnOrSchemasOrBuilder).build();
    }
    const scheam = fnOrSchemasOrBuilder.build();
    scheam.key = 'root';
    return scheam;
}

function inputGroup(key) {
    return composeBuilder().kind('input-group').key(key);
}
function numberGroup(key) {
    return composeBuilder().kind('number-group').key(key);
}

function makeFluentFeature(kind, providers) {
    return { kind, providers };
}

function withSchemaPatchers(patchers) {
    return makeFluentFeature(2 /* FluentFormFeatureKind.SchemaPatcher */, patchers.map(patcher => provideSchemaPatcher(patcher)));
}

function withStaticExpression() {
    return makeFluentFeature(1 /* FluentFormFeatureKind.StaticExpression */, [
        {
            provide: CodeEvaluator,
            useClass: DynamicCodeEvaluator
        }
    ]);
}

/**
 * @internal
 */
class AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: AbstractWidget, deps: [], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.2.12", type: AbstractWidget, viewQueries: [{ propertyName: "templateRef", first: true, predicate: TemplateRef, descendants: true, static: true }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: AbstractWidget, decorators: [{
            type: Directive
        }], propDecorators: { templateRef: [{
                type: ViewChild,
                args: [TemplateRef, { static: true }]
            }] } });
class AbstractTextControlWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
        this.helper = {
            length: {
                min: (length) => {
                    return isNumber(length) ? length : length?.min;
                },
                max: (length) => {
                    return isNumber(length) ? length : length?.max;
                },
            },
            autocomplete: {
                compare: (autocomplete) => autocomplete?.compare ?? ((o1, o2) => o1 === o2)
            }
        };
    }
}

/**
 * @internal
 */
class AlertWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.helper = {
            icon(icon) {
                return isBoolean(icon) ? null : icon;
            }
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: AlertWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: AlertWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-alert\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzType]=\"schema.type ?? 'info'\"\n    [nzMessage]=\"schema.message | template\"\n    [nzDescription]=\"(schema.description | template)!\"\n    [nzBanner]=\"schema.variants?.banner\"\n    [nzAction]=\"(schema.action | template)!\"\n    [nzCloseable]=\"!!schema.closeable\"\n    [nzIconType]=\"(helper.icon | invoke: schema.icon)!\"\n    [nzShowIcon]=\"!!schema.icon\"></nz-alert>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: NzAlertModule }, { kind: "component", type: i1$2.NzAlertComponent, selector: "nz-alert", inputs: ["nzAction", "nzCloseText", "nzIconType", "nzMessage", "nzDescription", "nzType", "nzCloseable", "nzShowIcon", "nzBanner", "nzNoAnimation", "nzIcon"], outputs: ["nzOnClose"], exportAs: ["nzAlert"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: AlertWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgClass,
                        NgStyle,
                        NzAlertModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentTemplatePipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-alert\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzType]=\"schema.type ?? 'info'\"\n    [nzMessage]=\"schema.message | template\"\n    [nzDescription]=\"(schema.description | template)!\"\n    [nzBanner]=\"schema.variants?.banner\"\n    [nzAction]=\"(schema.action | template)!\"\n    [nzCloseable]=\"!!schema.closeable\"\n    [nzIconType]=\"(helper.icon | invoke: schema.icon)!\"\n    [nzShowIcon]=\"!!schema.icon\"></nz-alert>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class ButtonGroupWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ButtonGroupWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: ButtonGroupWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-button-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSize]=\"schema.size!\">\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      fluentWithInjector\n      [ngTemplateOutlet]=\"subschema | widgetTemplate\"\n      [ngTemplateOutletContext]=\"{ control: control, schema: subschema, model: model }\">\n    </ng-container>\n  </nz-button-group>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: NzButtonModule }, { kind: "component", type: i1$3.NzButtonGroupComponent, selector: "nz-button-group", inputs: ["nzSize"], exportAs: ["nzButtonGroup"] }, { kind: "directive", type: i2$1.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentWithInjectorDirective, selector: "[ngTemplateOutlet][fluentWithInjector]" }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentWidgetTemplatePipe, name: "widgetTemplate" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ButtonGroupWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        NzButtonModule,
                        FluentBindingDirective,
                        FluentWithInjectorDirective,
                        FluentContextGuardDirective,
                        FluentWidgetTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-button-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSize]=\"schema.size!\">\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      fluentWithInjector\n      [ngTemplateOutlet]=\"subschema | widgetTemplate\"\n      [ngTemplateOutletContext]=\"{ control: control, schema: subschema, model: model }\">\n    </ng-container>\n  </nz-button-group>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class ButtonWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.helper = {
            icon: (icon) => {
                if (isUndefined(icon)) {
                    return icon;
                }
                if (isString(icon)) {
                    return { type: icon };
                }
                return icon;
            }
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ButtonWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: ButtonWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *ngIf=\"!(schema.hidden | reactive: model : schema : control)\">\n    <a\n      *ngIf=\"schema.type === 'link'\"\n      nz-button\n      [disabled]=\"schema.disabled | reactive: model : schema : control\"\n      [fluentBinding]=\"{ schema, control, model }\"\n      [ngClass]=\"schema.class\"\n      [ngStyle]=\"schema.style\"\n      [nzBlock]=\"schema.variants?.block\"\n      [nzDanger]=\"schema.variants?.danger\"\n      [nzGhost]=\"schema.variants?.ghost\"\n      [nzLoading]=\"schema.loading | reactive: model : schema : control\"\n      [nzShape]=\"schema.variants?.shape!\"\n      [nzSize]=\"schema.size!\"\n      [nzType]=\"schema.type\">\n      <ng-container [ngTemplateOutlet]=\"buttonContentTemplate\"></ng-container>\n    </a>\n\n    <button\n      *ngIf=\"schema.type !== 'link'\"\n      nz-button\n      [attr.type]=\"schema.mode\"\n      [disabled]=\"schema.disabled | reactive: model : schema : control\"\n      [fluentBinding]=\"{ schema, control, model }\"\n      [ngClass]=\"schema.class\"\n      [ngStyle]=\"schema.style\"\n      [nzBlock]=\"schema.variants?.block\"\n      [nzDanger]=\"schema.variants?.danger\"\n      [nzGhost]=\"schema.variants?.ghost\"\n      [nzLoading]=\"schema.loading | reactive: model : schema : control\"\n      [nzShape]=\"schema.variants?.shape!\"\n      [nzSize]=\"schema.size!\"\n      [nzType]=\"schema.type!\">\n      <ng-container [ngTemplateOutlet]=\"buttonContentTemplate\"></ng-container>\n    </button>\n  </ng-container>\n\n  <ng-template #buttonContentTemplate>\n    <span\n      *ngIf=\"helper.icon | invoke: schema.icon as icon\"\n      nz-icon\n      [nzTheme]=\"icon.theme ?? 'outline'\"\n      [nzType]=\"icon.type\"></span>\n    <ng-container *ngIf=\"schema.content\">\n      <ng-container *nzStringTemplateOutlet=\"schema.content | template\">{{ schema.content }}</ng-container>\n    </ng-container>\n  </ng-template>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: NzButtonModule }, { kind: "component", type: i1$3.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { kind: "directive", type: i2$1.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: i3.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { kind: "ngmodule", type: NzIconModule }, { kind: "directive", type: i4.NzIconDirective, selector: "[nz-icon]", inputs: ["nzSpin", "nzRotate", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { kind: "ngmodule", type: NzOutletModule }, { kind: "directive", type: i3$1.NzStringTemplateOutletDirective, selector: "[nzStringTemplateOutlet]", inputs: ["nzStringTemplateOutletContext", "nzStringTemplateOutlet"], exportAs: ["nzStringTemplateOutlet"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ButtonWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        NzButtonModule,
                        NzIconModule,
                        NzOutletModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentTemplatePipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *ngIf=\"!(schema.hidden | reactive: model : schema : control)\">\n    <a\n      *ngIf=\"schema.type === 'link'\"\n      nz-button\n      [disabled]=\"schema.disabled | reactive: model : schema : control\"\n      [fluentBinding]=\"{ schema, control, model }\"\n      [ngClass]=\"schema.class\"\n      [ngStyle]=\"schema.style\"\n      [nzBlock]=\"schema.variants?.block\"\n      [nzDanger]=\"schema.variants?.danger\"\n      [nzGhost]=\"schema.variants?.ghost\"\n      [nzLoading]=\"schema.loading | reactive: model : schema : control\"\n      [nzShape]=\"schema.variants?.shape!\"\n      [nzSize]=\"schema.size!\"\n      [nzType]=\"schema.type\">\n      <ng-container [ngTemplateOutlet]=\"buttonContentTemplate\"></ng-container>\n    </a>\n\n    <button\n      *ngIf=\"schema.type !== 'link'\"\n      nz-button\n      [attr.type]=\"schema.mode\"\n      [disabled]=\"schema.disabled | reactive: model : schema : control\"\n      [fluentBinding]=\"{ schema, control, model }\"\n      [ngClass]=\"schema.class\"\n      [ngStyle]=\"schema.style\"\n      [nzBlock]=\"schema.variants?.block\"\n      [nzDanger]=\"schema.variants?.danger\"\n      [nzGhost]=\"schema.variants?.ghost\"\n      [nzLoading]=\"schema.loading | reactive: model : schema : control\"\n      [nzShape]=\"schema.variants?.shape!\"\n      [nzSize]=\"schema.size!\"\n      [nzType]=\"schema.type!\">\n      <ng-container [ngTemplateOutlet]=\"buttonContentTemplate\"></ng-container>\n    </button>\n  </ng-container>\n\n  <ng-template #buttonContentTemplate>\n    <span\n      *ngIf=\"helper.icon | invoke: schema.icon as icon\"\n      nz-icon\n      [nzTheme]=\"icon.theme ?? 'outline'\"\n      [nzType]=\"icon.type\"></span>\n    <ng-container *ngIf=\"schema.content\">\n      <ng-container *nzStringTemplateOutlet=\"schema.content | template\">{{ schema.content }}</ng-container>\n    </ng-container>\n  </ng-template>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class CascaderWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CascaderWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: CascaderWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-cascader\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzChangeOnSelect]=\"schema.changeOnSelect\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzExpandIcon]=\"schema.expandIcon | template: ''\"\n        [nzExpandTrigger]=\"schema.trigger!\"\n        [nzLabelProperty]=\"schema.config?.labelProperty ?? 'label'\"\n        [nzLoadData]=\"schema.fetchOptions\"\n        [nzOptions]=\"schema.options! | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzShowArrow]=\"schema.arrow ?? true\"\n        [nzShowSearch]=\"schema.searchable!\"\n        [nzSize]=\"schema.size!\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'down'\"\n        [nzValueProperty]=\"schema.config?.valueProperty ?? 'value'\">\n      </nz-cascader>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-cascader\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzChangeOnSelect]=\"schema.changeOnSelect\"\n        [nzExpandIcon]=\"schema.expandIcon | template: ''\"\n        [nzExpandTrigger]=\"schema.trigger!\"\n        [nzLabelProperty]=\"schema.config?.labelProperty ?? 'label'\"\n        [nzLoadData]=\"schema.fetchOptions\"\n        [nzOptions]=\"schema.options! | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzShowArrow]=\"schema.arrow ?? true\"\n        [nzShowSearch]=\"schema.searchable!\"\n        [nzSize]=\"schema.size!\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'down'\"\n        [nzValueProperty]=\"schema.config?.valueProperty ?? 'value'\">\n      </nz-cascader>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-cascader{width:100%}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzCascaderModule }, { kind: "component", type: i2$2.NzCascaderComponent, selector: "nz-cascader, [nz-cascader]", inputs: ["nzOptionRender", "nzShowInput", "nzShowArrow", "nzAllowClear", "nzAutoFocus", "nzChangeOnSelect", "nzDisabled", "nzColumnClassName", "nzExpandTrigger", "nzValueProperty", "nzLabelRender", "nzLabelProperty", "nzNotFoundContent", "nzSize", "nzBackdrop", "nzShowSearch", "nzPlaceHolder", "nzMenuClassName", "nzMenuStyle", "nzMouseEnterDelay", "nzMouseLeaveDelay", "nzStatus", "nzTriggerAction", "nzChangeOn", "nzLoadData", "nzSuffixIcon", "nzExpandIcon", "nzOptions"], outputs: ["nzVisibleChange", "nzSelectionChange", "nzSelect", "nzClear"], exportAs: ["nzCascader"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CascaderWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzCascaderModule,
                        FluentGridModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-cascader\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzChangeOnSelect]=\"schema.changeOnSelect\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzExpandIcon]=\"schema.expandIcon | template: ''\"\n        [nzExpandTrigger]=\"schema.trigger!\"\n        [nzLabelProperty]=\"schema.config?.labelProperty ?? 'label'\"\n        [nzLoadData]=\"schema.fetchOptions\"\n        [nzOptions]=\"schema.options! | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzShowArrow]=\"schema.arrow ?? true\"\n        [nzShowSearch]=\"schema.searchable!\"\n        [nzSize]=\"schema.size!\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'down'\"\n        [nzValueProperty]=\"schema.config?.valueProperty ?? 'value'\">\n      </nz-cascader>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-cascader\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzChangeOnSelect]=\"schema.changeOnSelect\"\n        [nzExpandIcon]=\"schema.expandIcon | template: ''\"\n        [nzExpandTrigger]=\"schema.trigger!\"\n        [nzLabelProperty]=\"schema.config?.labelProperty ?? 'label'\"\n        [nzLoadData]=\"schema.fetchOptions\"\n        [nzOptions]=\"schema.options! | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzShowArrow]=\"schema.arrow ?? true\"\n        [nzShowSearch]=\"schema.searchable!\"\n        [nzSize]=\"schema.size!\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'down'\"\n        [nzValueProperty]=\"schema.config?.valueProperty ?? 'value'\">\n      </nz-cascader>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-cascader{width:100%}\n"] }]
        }] });

/**
 * @internal
 */
class CheckboxGroupWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CheckboxGroupWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: CheckboxGroupWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-checkbox-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\">\n  </nz-checkbox-group>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzCheckboxModule }, { kind: "component", type: i2$3.NzCheckboxGroupComponent, selector: "nz-checkbox-group", inputs: ["nzDisabled"], exportAs: ["nzCheckboxGroup"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CheckboxGroupWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzCheckboxModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-checkbox-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\">\n  </nz-checkbox-group>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class CheckboxWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CheckboxWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: CheckboxWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <label\n    #component\n    nz-checkbox\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzId]=\"schema.id!\"\n    [nzAutoFocus]=\"schema.autofocus\"\n    [nzIndeterminate]=\"schema.indeterminate\">\n    {{ schema.content }}\n  </label>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzCheckboxModule }, { kind: "component", type: i2$3.NzCheckboxComponent, selector: "[nz-checkbox]", inputs: ["nzValue", "nzAutoFocus", "nzDisabled", "nzIndeterminate", "nzChecked", "nzId"], outputs: ["nzCheckedChange"], exportAs: ["nzCheckbox"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CheckboxWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzCheckboxModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <label\n    #component\n    nz-checkbox\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzId]=\"schema.id!\"\n    [nzAutoFocus]=\"schema.autofocus\"\n    [nzIndeterminate]=\"schema.indeterminate\">\n    {{ schema.content }}\n  </label>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class DateRangeWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DateRangeWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: DateRangeWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-range-picker\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzAllowClear]=\"schema.clearable\"\n        [nzFormat]=\"schema.format!\"\n        [nzId]=\"schema.id!\"\n        [nzInline]=\"schema.inline\"\n        [nzMode]=\"schema.mode\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzShowTime]=\"schema.time\"\n        [nzShowTime]=\"schema.time\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzShowToday]=\"schema.today ?? true\"\n        [nzShowNow]=\"schema.now ?? true\"\n        [nzSeparator]=\"schema.separator\"></nz-range-picker>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-range-picker\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzAllowClear]=\"schema.clearable\"\n        [nzFormat]=\"schema.format!\"\n        [nzId]=\"schema.id!\"\n        [nzInline]=\"schema.inline\"\n        [nzMode]=\"schema.mode\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzShowTime]=\"schema.time\"\n        [nzShowTime]=\"schema.time\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzShowToday]=\"schema.today ?? true\"\n        [nzShowNow]=\"schema.now ?? true\"\n        [nzSeparator]=\"schema.separator\">\n      </nz-range-picker>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-range-picker{width:100%}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzDatePickerModule }, { kind: "component", type: i2$4.NzDatePickerComponent, selector: "nz-date-picker,nz-week-picker,nz-month-picker,nz-year-picker,nz-range-picker", inputs: ["nzAllowClear", "nzAutoFocus", "nzDisabled", "nzBorderless", "nzInputReadOnly", "nzInline", "nzOpen", "nzDisabledDate", "nzLocale", "nzPlaceHolder", "nzPopupStyle", "nzDropdownClassName", "nzSize", "nzStatus", "nzFormat", "nzDateRender", "nzDisabledTime", "nzRenderExtraFooter", "nzShowToday", "nzMode", "nzShowNow", "nzRanges", "nzDefaultPickerValue", "nzSeparator", "nzSuffixIcon", "nzBackdrop", "nzId", "nzPlacement", "nzShowWeekNumber", "nzShowTime"], outputs: ["nzOnPanelChange", "nzOnCalendarChange", "nzOnOk", "nzOnOpenChange"], exportAs: ["nzDatePicker"] }, { kind: "directive", type: i2$4.NzRangePickerComponent, selector: "nz-range-picker", exportAs: ["nzRangePicker"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DateRangeWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzDatePickerModule,
                        FluentGridModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-range-picker\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzAllowClear]=\"schema.clearable\"\n        [nzFormat]=\"schema.format!\"\n        [nzId]=\"schema.id!\"\n        [nzInline]=\"schema.inline\"\n        [nzMode]=\"schema.mode\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzShowTime]=\"schema.time\"\n        [nzShowTime]=\"schema.time\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzShowToday]=\"schema.today ?? true\"\n        [nzShowNow]=\"schema.now ?? true\"\n        [nzSeparator]=\"schema.separator\"></nz-range-picker>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-range-picker\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzAllowClear]=\"schema.clearable\"\n        [nzFormat]=\"schema.format!\"\n        [nzId]=\"schema.id!\"\n        [nzInline]=\"schema.inline\"\n        [nzMode]=\"schema.mode\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzShowTime]=\"schema.time\"\n        [nzShowTime]=\"schema.time\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzShowToday]=\"schema.today ?? true\"\n        [nzShowNow]=\"schema.now ?? true\"\n        [nzSeparator]=\"schema.separator\">\n      </nz-range-picker>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-range-picker{width:100%}\n"] }]
        }] });

/**
 * @internal
 */
class DateWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DateWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: DateWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-date-picker\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzAllowClear]=\"schema.clearable\"\n        [nzFormat]=\"schema.format!\"\n        [nzId]=\"schema.id!\"\n        [nzInline]=\"schema.inline\"\n        [nzMode]=\"schema.mode\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzShowTime]=\"schema.time\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzShowToday]=\"schema.today ?? true\"\n        [nzShowNow]=\"schema.now ?? true\"></nz-date-picker>\n    </ng-container>\n  </ng-container>\n\n  <ng-template #standardTemplate>\n    <nz-date-picker\n      #component\n      [fluentBinding]=\"{ component, schema, control, model }\"\n      [formControl]=\"control\"\n      [ngClass]=\"schema.class\"\n      [ngStyle]=\"schema.style\"\n      [nzAllowClear]=\"schema.clearable\"\n      [nzFormat]=\"schema.format!\"\n      [nzId]=\"schema.id!\"\n      [nzInline]=\"schema.inline\"\n      [nzMode]=\"schema.mode\"\n      [nzPlaceHolder]=\"schema.placeholder!\"\n      [nzShowTime]=\"schema.time\"\n      [nzBackdrop]=\"schema.backdrop!\"\n      [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n      [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n      [nzAutoFocus]=\"schema.autofocus\"\n      [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n      [nzSize]=\"schema.size!\"\n      [nzBorderless]=\"schema.borderless\"\n      [nzShowToday]=\"schema.today ?? true\"\n      [nzShowNow]=\"schema.now ?? true\">\n    </nz-date-picker>\n  </ng-template>\n</ng-template>\n", styles: ["nz-date-picker{width:100%}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzDatePickerModule }, { kind: "component", type: i2$4.NzDatePickerComponent, selector: "nz-date-picker,nz-week-picker,nz-month-picker,nz-year-picker,nz-range-picker", inputs: ["nzAllowClear", "nzAutoFocus", "nzDisabled", "nzBorderless", "nzInputReadOnly", "nzInline", "nzOpen", "nzDisabledDate", "nzLocale", "nzPlaceHolder", "nzPopupStyle", "nzDropdownClassName", "nzSize", "nzStatus", "nzFormat", "nzDateRender", "nzDisabledTime", "nzRenderExtraFooter", "nzShowToday", "nzMode", "nzShowNow", "nzRanges", "nzDefaultPickerValue", "nzSeparator", "nzSuffixIcon", "nzBackdrop", "nzId", "nzPlacement", "nzShowWeekNumber", "nzShowTime"], outputs: ["nzOnPanelChange", "nzOnCalendarChange", "nzOnOk", "nzOnOpenChange"], exportAs: ["nzDatePicker"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DateWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzDatePickerModule,
                        FluentGridModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-date-picker\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzAllowClear]=\"schema.clearable\"\n        [nzFormat]=\"schema.format!\"\n        [nzId]=\"schema.id!\"\n        [nzInline]=\"schema.inline\"\n        [nzMode]=\"schema.mode\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzShowTime]=\"schema.time\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzShowToday]=\"schema.today ?? true\"\n        [nzShowNow]=\"schema.now ?? true\"></nz-date-picker>\n    </ng-container>\n  </ng-container>\n\n  <ng-template #standardTemplate>\n    <nz-date-picker\n      #component\n      [fluentBinding]=\"{ component, schema, control, model }\"\n      [formControl]=\"control\"\n      [ngClass]=\"schema.class\"\n      [ngStyle]=\"schema.style\"\n      [nzAllowClear]=\"schema.clearable\"\n      [nzFormat]=\"schema.format!\"\n      [nzId]=\"schema.id!\"\n      [nzInline]=\"schema.inline\"\n      [nzMode]=\"schema.mode\"\n      [nzPlaceHolder]=\"schema.placeholder!\"\n      [nzShowTime]=\"schema.time\"\n      [nzBackdrop]=\"schema.backdrop!\"\n      [nzPlacement]=\"schema.placement ?? 'bottomLeft'\"\n      [nzSuffixIcon]=\"schema.suffixIcon | template: 'calendar'\"\n      [nzAutoFocus]=\"schema.autofocus\"\n      [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n      [nzSize]=\"schema.size!\"\n      [nzBorderless]=\"schema.borderless\"\n      [nzShowToday]=\"schema.today ?? true\"\n      [nzShowNow]=\"schema.now ?? true\">\n    </nz-date-picker>\n  </ng-template>\n</ng-template>\n", styles: ["nz-date-picker{width:100%}\n"] }]
        }] });

/**
 * @internal
 */
class FormArrayWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.schemaUtil = inject(SchemaUtil);
        this.formUtil = inject(FormUtil);
        this.SchemaKind = SchemaKind;
        this.helper = {
            length: {
                min: (length) => {
                    return isNumber(length) ? length : length?.min ?? 0;
                },
                max: (length) => {
                    return isNumber(length) ? length : length?.max ?? Infinity;
                },
            },
            addable: (addable) => {
                if (isUndefined(addable) || isBoolean(addable)) {
                    return {
                        type: 'dashed',
                        icon: 'plus',
                        disabled: isBoolean(addable) ? !addable : false,
                    };
                }
                return addable;
            }
        };
    }
    push(control, schema) {
        const [elementSchema] = this.schemaUtil.filterControls(schema.schemas);
        control.push(this.formUtil.createAnyControl(elementSchema, {}));
    }
    drop(control, event) {
        moveItemInArray(control.controls, event.previousIndex, event.currentIndex);
        control.updateValueAndValidity();
    }
    withIndex(index, schema) {
        return { ...schema, key: index };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FormArrayWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FormArrayWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-formArray=\"control\" let-formSchema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <fluent-row\n    #row\n    #parentRow=\"fluentParentRow\"\n    nz-form\n    cdkDropList\n    [cdkDropListDisabled]=\"!formSchema.orderable\"\n    [class.cdk-drop-list-disabled]=\"!formSchema.orderable\"\n    [gap]=\"formSchema.gap ?? parentRow.gap\"\n    [align]=\"formSchema.align\"\n    [justify]=\"formSchema.justify\"\n    [nzLayout]=\"formSchema.layout!\"\n    [ngClass]=\"formSchema.class\"\n    [ngStyle]=\"formSchema.style\"\n    [fluentBinding]=\"{ schema: formSchema, control: formArray, model }\"\n    (cdkDropListDropped)=\"drop(formArray, $event)\">\n    <ng-template\n      #formColTemplate\n      let-schema=\"schema\"\n      let-control=\"control\"\n      let-model=\"model\"\n      let-index=\"index\"\n      let-first=\"first\">\n      <fluent-col\n        *ngIf=\"schema.kind !== SchemaKind.Headless || (schema.kind === SchemaKind.Headless && schema.template)\"\n        cdkDrag\n        cdkDragPreviewContainer=\"parent\"\n        [cdkDragBoundary]=\"row\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n        <!-- form array \u7684 schemas \u53EF\u80FD\u4F1A\u6709\u591A\u4E2A\uFF0C\u53EA\u5728\u7B2C\u4E00\u4E2A\u65F6\u6E32\u67D3\u79FB\u9664\u6309\u94AE -->\n        <button\n          *ngIf=\"first && (formSchema.removable ?? true)\"\n          class=\"fluent-array-element-remove-btn\"\n          type=\"button\"\n          nz-button\n          nzShape=\"circle\"\n          nzSize=\"small\"\n          [nzDanger]=\"true\"\n          [disabled]=\"formArray.length <= (helper.length.min | invoke: formSchema.length)\"\n          (click)=\"formArray.removeAt(index)\">\n          <span nz-icon nzType=\"minus\" nzTheme=\"outline\"></span>\n        </button>\n      </fluent-col>\n    </ng-template>\n\n    <ng-container *ngFor=\"let control of formArray.controls; index as index\">\n      <ng-container\n        *ngFor=\"let subschema of formSchema.schemas; first as first\"\n        [ngTemplateOutlet]=\"formColTemplate\"\n        [ngTemplateOutletContext]=\"{\n          control: control,\n          schema: withIndex(index, subschema),\n          model: model[formSchema.key!],\n          index: index,\n          first: first\n        }\">\n      </ng-container>\n    </ng-container>\n\n    <fluent-col span=\"12\">\n      <nz-form-item>\n        <nz-form-control>\n          <button\n            *fluentVar=\"\n              helper.addable | invoke: (formSchema.addable | reactive: model : formSchema : formArray) as addBtn\n            \"\n            type=\"button\"\n            nz-button\n            [nzType]=\"addBtn.type ?? null\"\n            [nzBlock]=\"true\"\n            [nzDanger]=\"addBtn.variants?.danger\"\n            [nzGhost]=\"addBtn.variants?.ghost\"\n            [nzShape]=\"addBtn.variants?.shape!\"\n            [nzSize]=\"addBtn.size!\"\n            [disabled]=\"addBtn.disabled || formArray.length === (helper.length.max | invoke: formSchema.length)\"\n            (click)=\"push(formArray, formSchema)\">\n            <span *ngIf=\"addBtn.icon\" nz-icon nzTheme=\"outline\" [nzType]=\"addBtn.icon\"></span>\n            <ng-template *ngIf=\"addBtn.content\" [nzStringTemplateOutlet]=\"addBtn.content | template\">\n              {{ addBtn.content }}\n            </ng-template>\n          </button>\n        </nz-form-control>\n      </nz-form-item>\n    </fluent-col>\n  </fluent-row>\n</ng-template>\n", styles: [".fluent-array-element-remove-btn{position:absolute;top:4px;left:100%;z-index:1}.cdk-drag-placeholder{opacity:0}.cdk-drop-list-dragging .cdk-drag{transition:transform .25s cubic-bezier(0,0,.2,1)}.cdk-drag-animating{transition:transform .3s cubic-bezier(0,0,.2,1)}.cdk-drop-list:not(.cdk-drop-list-disabled) .cdk-drag:not(.cdk-drop-disabled){cursor:move}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: DragDropModule }, { kind: "directive", type: i1$4.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i1$4.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }, { kind: "ngmodule", type: NzFormModule }, { kind: "directive", type: i1.NzColDirective, selector: "[nz-col],nz-col,nz-form-control,nz-form-label", inputs: ["nzFlex", "nzSpan", "nzOrder", "nzOffset", "nzPush", "nzPull", "nzXs", "nzSm", "nzMd", "nzLg", "nzXl", "nzXXl"], exportAs: ["nzCol"] }, { kind: "directive", type: i1.NzRowDirective, selector: "[nz-row],nz-row,nz-form-item", inputs: ["nzAlign", "nzJustify", "nzGutter"], exportAs: ["nzRow"] }, { kind: "directive", type: i2.NzFormDirective, selector: "[nz-form]", inputs: ["nzLayout", "nzNoColon", "nzAutoTips", "nzDisableAutoTips", "nzTooltipIcon", "nzLabelAlign", "nzLabelWrap"], exportAs: ["nzForm"] }, { kind: "component", type: i2.NzFormItemComponent, selector: "nz-form-item", exportAs: ["nzFormItem"] }, { kind: "component", type: i2.NzFormControlComponent, selector: "nz-form-control", inputs: ["nzSuccessTip", "nzWarningTip", "nzErrorTip", "nzValidatingTip", "nzExtra", "nzAutoTips", "nzDisableAutoTips", "nzHasFeedback", "nzValidateStatus"], exportAs: ["nzFormControl"] }, { kind: "ngmodule", type: NzButtonModule }, { kind: "component", type: i1$3.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { kind: "directive", type: i2$1.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: i3.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { kind: "ngmodule", type: NzIconModule }, { kind: "directive", type: i4.NzIconDirective, selector: "[nz-icon]", inputs: ["nzSpin", "nzRotate", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { kind: "ngmodule", type: NzOutletModule }, { kind: "directive", type: i3$1.NzStringTemplateOutletDirective, selector: "[nzStringTemplateOutlet]", inputs: ["nzStringTemplateOutletContext", "nzStringTemplateOutlet"], exportAs: ["nzStringTemplateOutlet"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentRowDirective, selector: "fluent-row,[fluentRow]", inputs: ["gap", "justify", "align"], exportAs: ["fluentRow"] }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "component", type: FluentFormItemOutletComponent, selector: "fluent-col[schema],[fluentFormItemOutlet]", inputs: ["control", "schema", "model"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "directive", type: FluentParentRowDirective, selector: "fluent-row", exportAs: ["fluentParentRow"] }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }, { kind: "directive", type: FluentVarDirective, selector: "[fluentVar]", inputs: ["fluentVar"] }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FormArrayWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        DragDropModule,
                        NzFormModule,
                        NzButtonModule,
                        NzIconModule,
                        NzOutletModule,
                        FluentGridModule,
                        FluentFormItemOutletComponent,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentParentRowDirective,
                        FluentColumnPipe,
                        FluentReactivePipe,
                        FluentTemplatePipe,
                        FluentVarDirective,
                        InvokePipe
                    ], template: "<ng-template let-formArray=\"control\" let-formSchema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <fluent-row\n    #row\n    #parentRow=\"fluentParentRow\"\n    nz-form\n    cdkDropList\n    [cdkDropListDisabled]=\"!formSchema.orderable\"\n    [class.cdk-drop-list-disabled]=\"!formSchema.orderable\"\n    [gap]=\"formSchema.gap ?? parentRow.gap\"\n    [align]=\"formSchema.align\"\n    [justify]=\"formSchema.justify\"\n    [nzLayout]=\"formSchema.layout!\"\n    [ngClass]=\"formSchema.class\"\n    [ngStyle]=\"formSchema.style\"\n    [fluentBinding]=\"{ schema: formSchema, control: formArray, model }\"\n    (cdkDropListDropped)=\"drop(formArray, $event)\">\n    <ng-template\n      #formColTemplate\n      let-schema=\"schema\"\n      let-control=\"control\"\n      let-model=\"model\"\n      let-index=\"index\"\n      let-first=\"first\">\n      <fluent-col\n        *ngIf=\"schema.kind !== SchemaKind.Headless || (schema.kind === SchemaKind.Headless && schema.template)\"\n        cdkDrag\n        cdkDragPreviewContainer=\"parent\"\n        [cdkDragBoundary]=\"row\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n        <!-- form array \u7684 schemas \u53EF\u80FD\u4F1A\u6709\u591A\u4E2A\uFF0C\u53EA\u5728\u7B2C\u4E00\u4E2A\u65F6\u6E32\u67D3\u79FB\u9664\u6309\u94AE -->\n        <button\n          *ngIf=\"first && (formSchema.removable ?? true)\"\n          class=\"fluent-array-element-remove-btn\"\n          type=\"button\"\n          nz-button\n          nzShape=\"circle\"\n          nzSize=\"small\"\n          [nzDanger]=\"true\"\n          [disabled]=\"formArray.length <= (helper.length.min | invoke: formSchema.length)\"\n          (click)=\"formArray.removeAt(index)\">\n          <span nz-icon nzType=\"minus\" nzTheme=\"outline\"></span>\n        </button>\n      </fluent-col>\n    </ng-template>\n\n    <ng-container *ngFor=\"let control of formArray.controls; index as index\">\n      <ng-container\n        *ngFor=\"let subschema of formSchema.schemas; first as first\"\n        [ngTemplateOutlet]=\"formColTemplate\"\n        [ngTemplateOutletContext]=\"{\n          control: control,\n          schema: withIndex(index, subschema),\n          model: model[formSchema.key!],\n          index: index,\n          first: first\n        }\">\n      </ng-container>\n    </ng-container>\n\n    <fluent-col span=\"12\">\n      <nz-form-item>\n        <nz-form-control>\n          <button\n            *fluentVar=\"\n              helper.addable | invoke: (formSchema.addable | reactive: model : formSchema : formArray) as addBtn\n            \"\n            type=\"button\"\n            nz-button\n            [nzType]=\"addBtn.type ?? null\"\n            [nzBlock]=\"true\"\n            [nzDanger]=\"addBtn.variants?.danger\"\n            [nzGhost]=\"addBtn.variants?.ghost\"\n            [nzShape]=\"addBtn.variants?.shape!\"\n            [nzSize]=\"addBtn.size!\"\n            [disabled]=\"addBtn.disabled || formArray.length === (helper.length.max | invoke: formSchema.length)\"\n            (click)=\"push(formArray, formSchema)\">\n            <span *ngIf=\"addBtn.icon\" nz-icon nzTheme=\"outline\" [nzType]=\"addBtn.icon\"></span>\n            <ng-template *ngIf=\"addBtn.content\" [nzStringTemplateOutlet]=\"addBtn.content | template\">\n              {{ addBtn.content }}\n            </ng-template>\n          </button>\n        </nz-form-control>\n      </nz-form-item>\n    </fluent-col>\n  </fluent-row>\n</ng-template>\n", styles: [".fluent-array-element-remove-btn{position:absolute;top:4px;left:100%;z-index:1}.cdk-drag-placeholder{opacity:0}.cdk-drop-list-dragging .cdk-drag{transition:transform .25s cubic-bezier(0,0,.2,1)}.cdk-drag-animating{transition:transform .3s cubic-bezier(0,0,.2,1)}.cdk-drop-list:not(.cdk-drop-list-disabled) .cdk-drag:not(.cdk-drop-disabled){cursor:move}\n"] }]
        }] });

/**
 * @internal
 */
class FormGroupWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.SchemaKind = SchemaKind;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FormGroupWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FormGroupWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-formGroup=\"control\" let-formSchema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <fluent-row\n    #parentRow=\"fluentParentRow\"\n    nz-form\n    [gap]=\"formSchema.gap ?? parentRow.gap\"\n    [align]=\"formSchema.align\"\n    [justify]=\"formSchema.justify\"\n    [nzLayout]=\"formSchema.layout!\"\n    [ngClass]=\"formSchema.class\"\n    [ngStyle]=\"formSchema.style\"\n    [fluentBinding]=\"{ schema: formSchema, control: formGroup, model }\">\n    <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n      <fluent-col\n        *ngIf=\"schema.kind !== SchemaKind.Headless || (schema.kind === SchemaKind.Headless && schema.template)\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n      </fluent-col>\n    </ng-template>\n\n    <ng-container\n      *ngFor=\"let subschema of formSchema.schemas\"\n      [ngTemplateOutlet]=\"formColTemplate\"\n      [ngTemplateOutletContext]=\"{\n        control: (subschema.key | control: formGroup),\n        schema: subschema,\n        model: model[formSchema.key!]\n      }\">\n    </ng-container>\n  </fluent-row>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: NzFormModule }, { kind: "directive", type: i2.NzFormDirective, selector: "[nz-form]", inputs: ["nzLayout", "nzNoColon", "nzAutoTips", "nzDisableAutoTips", "nzTooltipIcon", "nzLabelAlign", "nzLabelWrap"], exportAs: ["nzForm"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentRowDirective, selector: "fluent-row,[fluentRow]", inputs: ["gap", "justify", "align"], exportAs: ["fluentRow"] }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "component", type: FluentFormItemOutletComponent, selector: "fluent-col[schema],[fluentFormItemOutlet]", inputs: ["control", "schema", "model"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "directive", type: FluentParentRowDirective, selector: "fluent-row", exportAs: ["fluentParentRow"] }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentControlPipe, name: "control" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FormGroupWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        NzFormModule,
                        FluentGridModule,
                        FluentFormItemOutletComponent,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentParentRowDirective,
                        FluentColumnPipe,
                        FluentReactivePipe,
                        FluentControlPipe
                    ], template: "<ng-template let-formGroup=\"control\" let-formSchema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <fluent-row\n    #parentRow=\"fluentParentRow\"\n    nz-form\n    [gap]=\"formSchema.gap ?? parentRow.gap\"\n    [align]=\"formSchema.align\"\n    [justify]=\"formSchema.justify\"\n    [nzLayout]=\"formSchema.layout!\"\n    [ngClass]=\"formSchema.class\"\n    [ngStyle]=\"formSchema.style\"\n    [fluentBinding]=\"{ schema: formSchema, control: formGroup, model }\">\n    <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n      <fluent-col\n        *ngIf=\"schema.kind !== SchemaKind.Headless || (schema.kind === SchemaKind.Headless && schema.template)\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n      </fluent-col>\n    </ng-template>\n\n    <ng-container\n      *ngFor=\"let subschema of formSchema.schemas\"\n      [ngTemplateOutlet]=\"formColTemplate\"\n      [ngTemplateOutletContext]=\"{\n        control: (subschema.key | control: formGroup),\n        schema: subschema,\n        model: model[formSchema.key!]\n      }\">\n    </ng-container>\n  </fluent-row>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class HeadingWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: HeadingWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: HeadingWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container [ngSwitch]=\"schema.level\">\n    <ng-container *ngSwitchCase=\"1\">\n      <h1 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h1>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"2\">\n      <h2 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h2>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"3\">\n      <h3 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h3>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"4\">\n      <h4 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h4>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"5\">\n      <h5 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h5>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"6\">\n      <h6 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h6>\n    </ng-container>\n  </ng-container>\n\n  <ng-template #headingContentTemplate>\n    <ng-container *nzStringTemplateOutlet=\"schema.content | template\">{{ schema.content }}</ng-container>\n  </ng-template>\n</ng-template>\n", styles: ["h1,h2,h3,h4,h5,h6{margin:0}\n"], dependencies: [{ kind: "directive", type: NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: NzTypographyModule }, { kind: "component", type: i1$5.NzTypographyComponent, selector: "  nz-typography,  [nz-typography],  p[nz-paragraph],  span[nz-text],  h1[nz-title], h2[nz-title], h3[nz-title], h4[nz-title]  ", inputs: ["nzCopyable", "nzEditable", "nzDisabled", "nzExpandable", "nzEllipsis", "nzCopyTooltips", "nzCopyIcons", "nzEditTooltip", "nzEditIcon", "nzContent", "nzEllipsisRows", "nzType", "nzCopyText", "nzSuffix"], outputs: ["nzContentChange", "nzCopy", "nzExpandChange", "nzOnEllipsis"], exportAs: ["nzTypography"] }, { kind: "ngmodule", type: NzOutletModule }, { kind: "directive", type: i3$1.NzStringTemplateOutletDirective, selector: "[nzStringTemplateOutlet]", inputs: ["nzStringTemplateOutletContext", "nzStringTemplateOutlet"], exportAs: ["nzStringTemplateOutlet"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: HeadingWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgSwitch,
                        NgSwitchCase,
                        NgIf,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        NzTypographyModule,
                        NzOutletModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container [ngSwitch]=\"schema.level\">\n    <ng-container *ngSwitchCase=\"1\">\n      <h1 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h1>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"2\">\n      <h2 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h2>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"3\">\n      <h3 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h3>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"4\">\n      <h4 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h4>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"5\">\n      <h5 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h5>\n    </ng-container>\n    <ng-container *ngSwitchCase=\"6\">\n      <h6 nz-typography [fluentBinding]=\"{ schema, control, model }\" [ngClass]=\"schema.class\" [ngStyle]=\"schema.style\">\n        <ng-container [ngTemplateOutlet]=\"headingContentTemplate\"></ng-container>\n      </h6>\n    </ng-container>\n  </ng-container>\n\n  <ng-template #headingContentTemplate>\n    <ng-container *nzStringTemplateOutlet=\"schema.content | template\">{{ schema.content }}</ng-container>\n  </ng-template>\n</ng-template>\n", styles: ["h1,h2,h3,h4,h5,h6{margin:0}\n"] }]
        }] });

/**
 * @internal
 */
class InputGroupWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.helper = {
            addon: (addon) => isString(addon) || addon instanceof TemplateRef ? addon : undefined,
            addonIcon: (addon) => isString(addon) || addon instanceof TemplateRef ? undefined : addon?.icon,
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: InputGroupWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: InputGroupWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-input-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSize]=\"schema.size!\"\n    [nzCompact]=\"schema.compact ?? true\"\n    [nzAddOnBefore]=\"helper.addon | invoke: (schema.before | reactive: model : schema : control) | template\"\n    [nzAddOnAfter]=\"helper.addon | invoke: (schema.after | reactive: model : schema : control) | template\"\n    [nzPrefix]=\"helper.addon | invoke: (schema.prefix | reactive: model : schema : control) | template\"\n    [nzSuffix]=\"helper.addon | invoke: (schema.suffix | reactive: model : schema : control) | template\"\n    [nzAddOnBeforeIcon]=\"helper.addonIcon | invoke: (schema.before | reactive: model : schema : control)\"\n    [nzAddOnAfterIcon]=\"helper.addonIcon | invoke: (schema.after | reactive: model : schema : control)\"\n    [nzPrefixIcon]=\"helper.addonIcon | invoke: (schema.prefix | reactive: model : schema : control)\"\n    [nzSuffixIcon]=\"helper.addonIcon | invoke: (schema.suffix | reactive: model : schema : control)\">\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      fluentWithInjector\n      [ngTemplateOutlet]=\"subschema | widgetTemplate\"\n      [ngTemplateOutletContext]=\"{ control: subschema.key | control: control, schema: subschema, model: model }\">\n    </ng-container>\n  </nz-input-group>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "ngmodule", type: NzInputModule }, { kind: "component", type: i2$5.NzInputGroupComponent, selector: "nz-input-group", inputs: ["nzAddOnBeforeIcon", "nzAddOnAfterIcon", "nzPrefixIcon", "nzSuffixIcon", "nzAddOnBefore", "nzAddOnAfter", "nzPrefix", "nzStatus", "nzSuffix", "nzSize", "nzSearch", "nzCompact"], exportAs: ["nzInputGroup"] }, { kind: "directive", type: i2$5.NzInputGroupWhitSuffixOrPrefixDirective, selector: "nz-input-group[nzSuffix], nz-input-group[nzPrefix]" }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "directive", type: FluentWithInjectorDirective, selector: "[ngTemplateOutlet][fluentWithInjector]" }, { kind: "pipe", type: FluentControlPipe, name: "control" }, { kind: "pipe", type: FluentWidgetTemplatePipe, name: "widgetTemplate" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: InputGroupWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        ReactiveFormsModule,
                        NzInputModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentWithInjectorDirective,
                        FluentControlPipe,
                        FluentWidgetTemplatePipe,
                        FluentTemplatePipe,
                        FluentReactivePipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-input-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSize]=\"schema.size!\"\n    [nzCompact]=\"schema.compact ?? true\"\n    [nzAddOnBefore]=\"helper.addon | invoke: (schema.before | reactive: model : schema : control) | template\"\n    [nzAddOnAfter]=\"helper.addon | invoke: (schema.after | reactive: model : schema : control) | template\"\n    [nzPrefix]=\"helper.addon | invoke: (schema.prefix | reactive: model : schema : control) | template\"\n    [nzSuffix]=\"helper.addon | invoke: (schema.suffix | reactive: model : schema : control) | template\"\n    [nzAddOnBeforeIcon]=\"helper.addonIcon | invoke: (schema.before | reactive: model : schema : control)\"\n    [nzAddOnAfterIcon]=\"helper.addonIcon | invoke: (schema.after | reactive: model : schema : control)\"\n    [nzPrefixIcon]=\"helper.addonIcon | invoke: (schema.prefix | reactive: model : schema : control)\"\n    [nzSuffixIcon]=\"helper.addonIcon | invoke: (schema.suffix | reactive: model : schema : control)\">\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      fluentWithInjector\n      [ngTemplateOutlet]=\"subschema | widgetTemplate\"\n      [ngTemplateOutletContext]=\"{ control: subschema.key | control: control, schema: subschema, model: model }\">\n    </ng-container>\n  </nz-input-group>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class InputWidget extends AbstractTextControlWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: InputWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: InputWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"schema.autocomplete as autocomplete; else noAutocompleteTemplate\">\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <input\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <input\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [formControl]=\"control\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-template>\n\n      <nz-autocomplete\n        #autocompleteComponent\n        [compareWith]=\"helper.autocomplete.compare | invoke: autocomplete\"\n        [nzBackfill]=\"autocomplete.backfill\"\n        [nzDataSource]=\"autocomplete.options\"\n        [nzWidth]=\"autocomplete.width\"></nz-autocomplete>\n    </ng-container>\n\n    <ng-template #noAutocompleteTemplate>\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <input\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <input\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [formControl]=\"control\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-template>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzInputModule }, { kind: "directive", type: i2$5.NzInputDirective, selector: "input[nz-input],textarea[nz-input]", inputs: ["nzBorderless", "nzSize", "nzStepperless", "nzStatus", "disabled"], exportAs: ["nzInput"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "ngmodule", type: NzAutocompleteModule }, { kind: "component", type: i4$1.NzAutocompleteComponent, selector: "nz-autocomplete", inputs: ["nzWidth", "nzOverlayClassName", "nzOverlayStyle", "nzDefaultActiveFirstOption", "nzBackfill", "compareWith", "nzDataSource"], outputs: ["selectionChange"], exportAs: ["nzAutocomplete"] }, { kind: "directive", type: i4$1.NzAutocompleteTriggerDirective, selector: "input[nzAutocomplete], textarea[nzAutocomplete]", inputs: ["nzAutocomplete"], exportAs: ["nzAutocompleteTrigger"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: InputWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzInputModule,
                        FluentGridModule,
                        NzAutocompleteModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"schema.autocomplete as autocomplete; else noAutocompleteTemplate\">\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <input\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <input\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [formControl]=\"control\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-template>\n\n      <nz-autocomplete\n        #autocompleteComponent\n        [compareWith]=\"helper.autocomplete.compare | invoke: autocomplete\"\n        [nzBackfill]=\"autocomplete.backfill\"\n        [nzDataSource]=\"autocomplete.options\"\n        [nzWidth]=\"autocomplete.width\"></nz-autocomplete>\n    </ng-container>\n\n    <ng-template #noAutocompleteTemplate>\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <input\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <input\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [formControl]=\"control\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [type]=\"schema.type ?? 'text'\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\" />\n      </ng-template>\n    </ng-template>\n  </ng-container>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class NumberGroupWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.helper = {
            addon: (addon) => isString(addon) || addon instanceof TemplateRef ? addon : undefined,
            addonIcon: (addon) => isString(addon) || addon instanceof TemplateRef ? undefined : addon?.icon,
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: NumberGroupWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: NumberGroupWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-input-number-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSize]=\"schema.size!\"\n    [nzCompact]=\"schema.compact ?? true\"\n    [nzAddOnBefore]=\"helper.addon | invoke: (schema.before | reactive: model : schema : control) | template\"\n    [nzAddOnAfter]=\"helper.addon | invoke: (schema.after | reactive: model : schema : control) | template\"\n    [nzPrefix]=\"helper.addon | invoke: (schema.prefix | reactive: model : schema : control) | template\"\n    [nzSuffix]=\"helper.addon | invoke: (schema.suffix | reactive: model : schema : control) | template\"\n    [nzAddOnBeforeIcon]=\"helper.addonIcon | invoke: (schema.before | reactive: model : schema : control)\"\n    [nzAddOnAfterIcon]=\"helper.addonIcon | invoke: (schema.after | reactive: model : schema : control)\"\n    [nzPrefixIcon]=\"helper.addonIcon | invoke: (schema.prefix | reactive: model : schema : control)\"\n    [nzSuffixIcon]=\"helper.addonIcon | invoke: (schema.suffix | reactive: model : schema : control)\">\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      fluentWithInjector\n      [ngTemplateOutlet]=\"subschema | widgetTemplate\"\n      [ngTemplateOutletContext]=\"{ control: subschema.key | control: control, schema: subschema, model: model }\">\n    </ng-container>\n  </nz-input-number-group>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "ngmodule", type: NzInputNumberModule }, { kind: "component", type: i1$6.NzInputNumberGroupComponent, selector: "nz-input-number-group", inputs: ["nzAddOnBeforeIcon", "nzAddOnAfterIcon", "nzPrefixIcon", "nzSuffixIcon", "nzAddOnBefore", "nzAddOnAfter", "nzPrefix", "nzStatus", "nzSuffix", "nzSize", "nzCompact"], exportAs: ["nzInputNumberGroup"] }, { kind: "directive", type: i1$6.NzInputNumberGroupWhitSuffixOrPrefixDirective, selector: "nz-input-number-group[nzSuffix], nz-input-number-group[nzPrefix]" }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "directive", type: FluentWithInjectorDirective, selector: "[ngTemplateOutlet][fluentWithInjector]" }, { kind: "pipe", type: FluentControlPipe, name: "control" }, { kind: "pipe", type: FluentWidgetTemplatePipe, name: "widgetTemplate" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: NumberGroupWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        ReactiveFormsModule,
                        NzInputNumberModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentWithInjectorDirective,
                        FluentControlPipe,
                        FluentWidgetTemplatePipe,
                        FluentTemplatePipe,
                        FluentReactivePipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-input-number-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSize]=\"schema.size!\"\n    [nzCompact]=\"schema.compact ?? true\"\n    [nzAddOnBefore]=\"helper.addon | invoke: (schema.before | reactive: model : schema : control) | template\"\n    [nzAddOnAfter]=\"helper.addon | invoke: (schema.after | reactive: model : schema : control) | template\"\n    [nzPrefix]=\"helper.addon | invoke: (schema.prefix | reactive: model : schema : control) | template\"\n    [nzSuffix]=\"helper.addon | invoke: (schema.suffix | reactive: model : schema : control) | template\"\n    [nzAddOnBeforeIcon]=\"helper.addonIcon | invoke: (schema.before | reactive: model : schema : control)\"\n    [nzAddOnAfterIcon]=\"helper.addonIcon | invoke: (schema.after | reactive: model : schema : control)\"\n    [nzPrefixIcon]=\"helper.addonIcon | invoke: (schema.prefix | reactive: model : schema : control)\"\n    [nzSuffixIcon]=\"helper.addonIcon | invoke: (schema.suffix | reactive: model : schema : control)\">\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      fluentWithInjector\n      [ngTemplateOutlet]=\"subschema | widgetTemplate\"\n      [ngTemplateOutletContext]=\"{ control: subschema.key | control: control, schema: subschema, model: model }\">\n    </ng-container>\n  </nz-input-number-group>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class NumberWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
        this.infinity = Infinity;
        this.helper = {
            precision: (precision) => isNumber(precision) ? precision : precision?.value,
            precisionMode: (precision) => isNumber(precision) || !precision?.mode ? 'toFixed' : precision.mode,
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: NumberWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: NumberWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-input-number\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzId]=\"schema.id!\"\n        [nzMax]=\"schema.range?.max ?? infinity\"\n        [nzMin]=\"schema.range?.min ?? -infinity\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzPrecision]=\"helper.precision | invoke: schema.precision\"\n        [nzPrecisionMode]=\"helper.precisionMode | invoke: schema.precision\"\n        [nzStep]=\"schema.step ?? 1\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\">\n      </nz-input-number>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-input-number\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzId]=\"schema.id!\"\n        [nzMax]=\"schema.range?.max ?? infinity\"\n        [nzMin]=\"schema.range?.min ?? -infinity\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzPrecision]=\"helper.precision | invoke: schema.precision\"\n        [nzPrecisionMode]=\"helper.precisionMode | invoke: schema.precision\"\n        [nzStep]=\"schema.step ?? 1\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\">\n      </nz-input-number>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-input-number{width:100%}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzInputNumberModule }, { kind: "component", type: i1$6.NzInputNumberComponent, selector: "nz-input-number", inputs: ["nzSize", "nzMin", "nzMax", "nzParser", "nzPrecision", "nzPrecisionMode", "nzPlaceHolder", "nzStatus", "nzStep", "nzInputMode", "nzId", "nzDisabled", "nzReadOnly", "nzAutoFocus", "nzBorderless", "nzFormatter"], outputs: ["nzBlur", "nzFocus"], exportAs: ["nzInputNumber"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: NumberWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzInputNumberModule,
                        FluentGridModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-input-number\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzId]=\"schema.id!\"\n        [nzMax]=\"schema.range?.max ?? infinity\"\n        [nzMin]=\"schema.range?.min ?? -infinity\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzPrecision]=\"helper.precision | invoke: schema.precision\"\n        [nzPrecisionMode]=\"helper.precisionMode | invoke: schema.precision\"\n        [nzStep]=\"schema.step ?? 1\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\">\n      </nz-input-number>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-input-number\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzId]=\"schema.id!\"\n        [nzMax]=\"schema.range?.max ?? infinity\"\n        [nzMin]=\"schema.range?.min ?? -infinity\"\n        [nzPlaceHolder]=\"schema.placeholder ?? ''\"\n        [nzPrecision]=\"helper.precision | invoke: schema.precision\"\n        [nzPrecisionMode]=\"helper.precisionMode | invoke: schema.precision\"\n        [nzStep]=\"schema.step ?? 1\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\">\n      </nz-input-number>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-input-number{width:100%}\n"] }]
        }] });

/**
 * @internal
 */
class RadioGroupWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: RadioGroupWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: RadioGroupWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-radio-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzButtonStyle]=\"schema.variants?.button ?? 'outline'\"\n    [nzSize]=\"schema.size!\">\n    <ng-container *ngFor=\"let option of schema.options\">\n      <label\n        *ngIf=\"schema.variants?.button\"\n        nz-radio-button\n        [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\">\n        {{ option[schema.config?.labelProperty ?? 'label'] }}\n      </label>\n      <label *ngIf=\"!schema.variants?.button\" nz-radio [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\">\n        {{ option[schema.config?.labelProperty ?? 'label'] }}\n      </label>\n    </ng-container>\n  </nz-radio-group>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzRadioModule }, { kind: "component", type: i2$6.NzRadioComponent, selector: "[nz-radio],[nz-radio-button]", inputs: ["nzValue", "nzDisabled", "nzAutoFocus"], exportAs: ["nzRadio"] }, { kind: "directive", type: i2$6.NzRadioButtonDirective, selector: "[nz-radio-button]" }, { kind: "component", type: i2$6.NzRadioGroupComponent, selector: "nz-radio-group", inputs: ["nzDisabled", "nzButtonStyle", "nzSize", "nzName"], exportAs: ["nzRadioGroup"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: RadioGroupWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgFor,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzRadioModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-radio-group\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzButtonStyle]=\"schema.variants?.button ?? 'outline'\"\n    [nzSize]=\"schema.size!\">\n    <ng-container *ngFor=\"let option of schema.options\">\n      <label\n        *ngIf=\"schema.variants?.button\"\n        nz-radio-button\n        [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\">\n        {{ option[schema.config?.labelProperty ?? 'label'] }}\n      </label>\n      <label *ngIf=\"!schema.variants?.button\" nz-radio [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\">\n        {{ option[schema.config?.labelProperty ?? 'label'] }}\n      </label>\n    </ng-container>\n  </nz-radio-group>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class RateWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: RateWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: RateWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-rate\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzAllowClear]=\"schema.clearable ?? true\"\n    [nzAllowHalf]=\"schema.half\"\n    [nzCharacter]=\"schema.character ? character : null!\"\n    [nzCount]=\"schema.count ?? 5\"\n    [nzTooltips]=\"schema.tooltips ?? []\"\n    [nzAutoFocus]=\"schema.autofocus\"></nz-rate>\n\n  <ng-template #character>\n    <ng-container *nzStringTemplateOutlet=\"schema.character | template\">{{ schema.character }}</ng-container>\n  </ng-template>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzRateModule }, { kind: "component", type: i2$7.NzRateComponent, selector: "nz-rate", inputs: ["nzAllowClear", "nzAllowHalf", "nzDisabled", "nzAutoFocus", "nzCharacter", "nzCount", "nzTooltips"], outputs: ["nzOnBlur", "nzOnFocus", "nzOnHoverChange", "nzOnKeyDown"], exportAs: ["nzRate"] }, { kind: "ngmodule", type: NzOutletModule }, { kind: "directive", type: i3$1.NzStringTemplateOutletDirective, selector: "[nzStringTemplateOutlet]", inputs: ["nzStringTemplateOutletContext", "nzStringTemplateOutlet"], exportAs: ["nzStringTemplateOutlet"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: RateWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzRateModule,
                        NzOutletModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentTemplatePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-rate\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzAllowClear]=\"schema.clearable ?? true\"\n    [nzAllowHalf]=\"schema.half\"\n    [nzCharacter]=\"schema.character ? character : null!\"\n    [nzCount]=\"schema.count ?? 5\"\n    [nzTooltips]=\"schema.tooltips ?? []\"\n    [nzAutoFocus]=\"schema.autofocus\"></nz-rate>\n\n  <ng-template #character>\n    <ng-container *nzStringTemplateOutlet=\"schema.character | template\">{{ schema.character }}</ng-container>\n  </ng-template>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class RowWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: RowWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: RowWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <fluent-row\n    #parentRow=\"fluentParentRow\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [align]=\"schema.align\"\n    [justify]=\"schema.justify\"\n    [gap]=\"schema.gap ?? parentRow.gap\"\n    [fluentBinding]=\"{ schema, control, model }\">\n    <ng-template #colTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n      <fluent-col\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n      </fluent-col>\n    </ng-template>\n\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      [ngTemplateOutlet]=\"colTemplate\"\n      [ngTemplateOutletContext]=\"{ control: (subschema.key | control: control), schema: subschema, model: model }\">\n    </ng-container>\n  </fluent-row>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentRowDirective, selector: "fluent-row,[fluentRow]", inputs: ["gap", "justify", "align"], exportAs: ["fluentRow"] }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "component", type: FluentFormItemOutletComponent, selector: "fluent-col[schema],[fluentFormItemOutlet]", inputs: ["control", "schema", "model"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentParentRowDirective, selector: "fluent-row", exportAs: ["fluentParentRow"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentControlPipe, name: "control" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: RowWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        FluentGridModule,
                        FluentFormItemOutletComponent,
                        FluentBindingDirective,
                        FluentParentRowDirective,
                        FluentReactivePipe,
                        FluentContextGuardDirective,
                        FluentColumnPipe,
                        FluentControlPipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <fluent-row\n    #parentRow=\"fluentParentRow\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [align]=\"schema.align\"\n    [justify]=\"schema.justify\"\n    [gap]=\"schema.gap ?? parentRow.gap\"\n    [fluentBinding]=\"{ schema, control, model }\">\n    <ng-template #colTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n      <fluent-col\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n      </fluent-col>\n    </ng-template>\n\n    <ng-container\n      *ngFor=\"let subschema of schema.schemas\"\n      [ngTemplateOutlet]=\"colTemplate\"\n      [ngTemplateOutletContext]=\"{ control: (subschema.key | control: control), schema: subschema, model: model }\">\n    </ng-container>\n  </fluent-row>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class SelectWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
        this.infinity = Infinity;
        this.ctxClass = SelectWidgetTemplatePrivateContext;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SelectWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SelectWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container\n      *fluentContext=\"ctxClass as ctx\"\n      (fluentInit)=\"ctx.init(schema, model, control)\"\n      (fluentDestroy)=\"ctx.destroy()\">\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <nz-select\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          #component\n          fluentCol\n          [fluentBinding]=\"{ component, schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzId]=\"schema.id!\"\n          [nzAllowClear]=\"schema.clearable\"\n          [nzMaxMultipleCount]=\"schema.length?.max ?? infinity\"\n          [nzMode]=\"schema.mode ?? 'default'\"\n          [nzPlaceHolder]=\"schema.placeholder!\"\n          [nzShowSearch]=\"schema.searchable || !!schema.fetchOptions\"\n          [nzBackdrop]=\"schema.backdrop!\"\n          [nzBorderless]=\"schema.borderless\"\n          [nzAutoFocus]=\"schema.autofocus\"\n          [nzShowArrow]=\"(schema.arrow ?? !schema.mode) || schema.mode === 'default'\"\n          [nzSize]=\"schema.size!\"\n          [nzSuffixIcon]=\"(schema.suffixIcon | template)!\"\n          [nzLoading]=\"schema.loading\"\n          [nzServerSearch]=\"!!schema.fetchOptions\"\n          [(nzOpen)]=\"ctx.open\"\n          (nzOnSearch)=\"ctx.trigger($event)\">\n          <nz-option\n            *ngFor=\"let option of schema.options | reactive: model : schema : control\"\n            [nzCustomContent]=\"!!schema.option\"\n            [nzDisabled]=\"option[schema.config?.disabledProperty ?? 'disabled']\"\n            [nzLabel]=\"option[schema.config?.labelProperty ?? 'label']\"\n            [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\"\n            [nzHide]=\"option[schema.config?.hideProperty ?? 'hide']\">\n            <ng-template\n              [nzStringTemplateOutlet]=\"schema.option | template\"\n              [nzStringTemplateOutletContext]=\"{ $implicit: option }\" />\n          </nz-option>\n        </nz-select>\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <nz-select\n          #component\n          [fluentBinding]=\"{ component, schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [nzAllowClear]=\"schema.clearable\"\n          [nzId]=\"schema.id!\"\n          [nzMaxMultipleCount]=\"schema.length?.max ?? infinity\"\n          [nzMode]=\"schema.mode ?? 'default'\"\n          [nzPlaceHolder]=\"schema.placeholder!\"\n          [nzShowSearch]=\"schema.searchable || !!schema.fetchOptions\"\n          [nzBackdrop]=\"schema.backdrop!\"\n          [nzBorderless]=\"schema.borderless\"\n          [nzAutoFocus]=\"schema.autofocus\"\n          [nzShowArrow]=\"(schema.arrow ?? !schema.mode) || schema.mode === 'default'\"\n          [nzSize]=\"schema.size!\"\n          [nzSuffixIcon]=\"(schema.suffixIcon | template)!\"\n          [nzLoading]=\"schema.loading\"\n          [nzServerSearch]=\"!!schema.fetchOptions\"\n          [(nzOpen)]=\"ctx.open\"\n          (nzOnSearch)=\"ctx.trigger($event)\">\n          <nz-option\n            *ngFor=\"let option of schema.options | reactive: model : schema : control\"\n            [nzCustomContent]=\"!!schema.option\"\n            [nzDisabled]=\"option[schema.config?.disabledProperty ?? 'disabled']\"\n            [nzLabel]=\"option[schema.config?.labelProperty ?? 'label']\"\n            [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\"\n            [nzHide]=\"option[schema.config?.hideProperty ?? 'hide']\">\n            <ng-template\n              [nzStringTemplateOutlet]=\"schema.option | template\"\n              [nzStringTemplateOutletContext]=\"{ $implicit: option }\" />\n          </nz-option>\n        </nz-select>\n      </ng-template>\n    </ng-container>\n  </ng-container>\n</ng-template>\n", styles: ["nz-select{width:100%}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzSelectModule }, { kind: "component", type: i2$8.NzOptionComponent, selector: "nz-option", inputs: ["nzTitle", "nzLabel", "nzValue", "nzKey", "nzDisabled", "nzHide", "nzCustomContent"], exportAs: ["nzOption"] }, { kind: "component", type: i2$8.NzSelectComponent, selector: "nz-select", inputs: ["nzId", "nzSize", "nzStatus", "nzOptionHeightPx", "nzOptionOverflowSize", "nzDropdownClassName", "nzDropdownMatchSelectWidth", "nzDropdownStyle", "nzNotFoundContent", "nzPlaceHolder", "nzPlacement", "nzMaxTagCount", "nzDropdownRender", "nzCustomTemplate", "nzSuffixIcon", "nzClearIcon", "nzRemoveIcon", "nzMenuItemSelectedIcon", "nzTokenSeparators", "nzMaxTagPlaceholder", "nzMaxMultipleCount", "nzMode", "nzFilterOption", "compareWith", "nzAllowClear", "nzBorderless", "nzShowSearch", "nzLoading", "nzAutoFocus", "nzAutoClearSearchValue", "nzServerSearch", "nzDisabled", "nzOpen", "nzSelectOnTab", "nzBackdrop", "nzOptions", "nzShowArrow"], outputs: ["nzOnSearch", "nzScrollToBottom", "nzOpenChange", "nzBlur", "nzFocus"], exportAs: ["nzSelect"] }, { kind: "ngmodule", type: NzOutletModule }, { kind: "directive", type: i3$1.NzStringTemplateOutletDirective, selector: "[nzStringTemplateOutlet]", inputs: ["nzStringTemplateOutletContext", "nzStringTemplateOutlet"], exportAs: ["nzStringTemplateOutlet"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "directive", type: FluentContextDirective, selector: "[fluentContext]", inputs: ["fluentContext"] }, { kind: "directive", type: FluentLifeCycleDirective, selector: "[fluentInit],[fluentDestroy]", outputs: ["fluentInit", "fluentDestroy"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SelectWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgFor,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzSelectModule,
                        NzOutletModule,
                        FluentGridModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentContextDirective,
                        FluentLifeCycleDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container\n      *fluentContext=\"ctxClass as ctx\"\n      (fluentInit)=\"ctx.init(schema, model, control)\"\n      (fluentDestroy)=\"ctx.destroy()\">\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <nz-select\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          #component\n          fluentCol\n          [fluentBinding]=\"{ component, schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzId]=\"schema.id!\"\n          [nzAllowClear]=\"schema.clearable\"\n          [nzMaxMultipleCount]=\"schema.length?.max ?? infinity\"\n          [nzMode]=\"schema.mode ?? 'default'\"\n          [nzPlaceHolder]=\"schema.placeholder!\"\n          [nzShowSearch]=\"schema.searchable || !!schema.fetchOptions\"\n          [nzBackdrop]=\"schema.backdrop!\"\n          [nzBorderless]=\"schema.borderless\"\n          [nzAutoFocus]=\"schema.autofocus\"\n          [nzShowArrow]=\"(schema.arrow ?? !schema.mode) || schema.mode === 'default'\"\n          [nzSize]=\"schema.size!\"\n          [nzSuffixIcon]=\"(schema.suffixIcon | template)!\"\n          [nzLoading]=\"schema.loading\"\n          [nzServerSearch]=\"!!schema.fetchOptions\"\n          [(nzOpen)]=\"ctx.open\"\n          (nzOnSearch)=\"ctx.trigger($event)\">\n          <nz-option\n            *ngFor=\"let option of schema.options | reactive: model : schema : control\"\n            [nzCustomContent]=\"!!schema.option\"\n            [nzDisabled]=\"option[schema.config?.disabledProperty ?? 'disabled']\"\n            [nzLabel]=\"option[schema.config?.labelProperty ?? 'label']\"\n            [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\"\n            [nzHide]=\"option[schema.config?.hideProperty ?? 'hide']\">\n            <ng-template\n              [nzStringTemplateOutlet]=\"schema.option | template\"\n              [nzStringTemplateOutletContext]=\"{ $implicit: option }\" />\n          </nz-option>\n        </nz-select>\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <nz-select\n          #component\n          [fluentBinding]=\"{ component, schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [nzAllowClear]=\"schema.clearable\"\n          [nzId]=\"schema.id!\"\n          [nzMaxMultipleCount]=\"schema.length?.max ?? infinity\"\n          [nzMode]=\"schema.mode ?? 'default'\"\n          [nzPlaceHolder]=\"schema.placeholder!\"\n          [nzShowSearch]=\"schema.searchable || !!schema.fetchOptions\"\n          [nzBackdrop]=\"schema.backdrop!\"\n          [nzBorderless]=\"schema.borderless\"\n          [nzAutoFocus]=\"schema.autofocus\"\n          [nzShowArrow]=\"(schema.arrow ?? !schema.mode) || schema.mode === 'default'\"\n          [nzSize]=\"schema.size!\"\n          [nzSuffixIcon]=\"(schema.suffixIcon | template)!\"\n          [nzLoading]=\"schema.loading\"\n          [nzServerSearch]=\"!!schema.fetchOptions\"\n          [(nzOpen)]=\"ctx.open\"\n          (nzOnSearch)=\"ctx.trigger($event)\">\n          <nz-option\n            *ngFor=\"let option of schema.options | reactive: model : schema : control\"\n            [nzCustomContent]=\"!!schema.option\"\n            [nzDisabled]=\"option[schema.config?.disabledProperty ?? 'disabled']\"\n            [nzLabel]=\"option[schema.config?.labelProperty ?? 'label']\"\n            [nzValue]=\"option[schema.config?.valueProperty ?? 'value']\"\n            [nzHide]=\"option[schema.config?.hideProperty ?? 'hide']\">\n            <ng-template\n              [nzStringTemplateOutlet]=\"schema.option | template\"\n              [nzStringTemplateOutletContext]=\"{ $implicit: option }\" />\n          </nz-option>\n        </nz-select>\n      </ng-template>\n    </ng-container>\n  </ng-container>\n</ng-template>\n", styles: ["nz-select{width:100%}\n"] }]
        }] });
class SelectWidgetTemplatePrivateContext {
    constructor() {
        this.keyword$ = new Subject();
        this.cdr = inject(ChangeDetectorRef);
        this.open = false;
    }
    init(schema, model, control) {
        const fetchOptionsFn = schema.fetchOptions;
        if (fetchOptionsFn) {
            this.keyword$.pipe(filter(() => this.open), // 选中后关闭浮层也会触发一次 keyword$，此时 open=false，过滤掉
            tap(() => schema.loading = true), source => fetchOptionsFn(source, { schema, model, control })).subscribe(options => {
                schema.options = options;
                schema.loading = false;
                this.cdr.detectChanges();
            });
        }
    }
    destroy() {
        this.keyword$.complete();
    }
    trigger(keyword) {
        this.keyword$.next(keyword);
    }
}

/**
 * @internal
 */
class SilderWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SilderWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: SilderWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-slider\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzIncluded]=\"schema.included ?? true\"\n    [nzMax]=\"schema.range?.max ?? 100\"\n    [nzMin]=\"schema.range?.min\"\n    [nzRange]=\"schema.type === 'range'\"\n    [nzStep]=\"schema.step ?? 1\"\n    [nzDots]=\"schema.dots\"\n    [nzVertical]=\"schema.vertical\"\n    [nzReverse]=\"schema.reverse\">\n  </nz-slider>\n</ng-template>\n", styles: ["nz-slider{display:block}\n"], dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzSliderModule }, { kind: "component", type: i2$9.NzSliderComponent, selector: "nz-slider", inputs: ["nzDisabled", "nzDots", "nzIncluded", "nzRange", "nzVertical", "nzReverse", "nzDefaultValue", "nzMarks", "nzMax", "nzMin", "nzStep", "nzTooltipVisible", "nzTooltipPlacement", "nzTipFormatter"], outputs: ["nzOnAfterChange"], exportAs: ["nzSlider"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: SilderWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzSliderModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-slider\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzIncluded]=\"schema.included ?? true\"\n    [nzMax]=\"schema.range?.max ?? 100\"\n    [nzMin]=\"schema.range?.min\"\n    [nzRange]=\"schema.type === 'range'\"\n    [nzStep]=\"schema.step ?? 1\"\n    [nzDots]=\"schema.dots\"\n    [nzVertical]=\"schema.vertical\"\n    [nzReverse]=\"schema.reverse\">\n  </nz-slider>\n</ng-template>\n", styles: ["nz-slider{display:block}\n"] }]
        }] });

/**
 * @internal
 */
class StepsWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: StepsWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: StepsWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-steps\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzType]=\"schema.type ?? 'default'\"\n    [nzCurrent]=\"schema.active ?? 0\"\n    [nzLabelPlacement]=\"schema.placement ?? 'horizontal'\"\n    [nzProgressDot]=\"schema.dot\"\n    [nzSize]=\"schema.size ?? 'default'\"\n    [nzStatus]=\"schema.status ?? 'process'\"\n    [nzStartIndex]=\"schema.start ?? 0\"\n    (nzIndexChange)=\"schema.active = $event\">\n    <nz-step\n      *ngFor=\"let subschema of schema.schemas; index as index\"\n      #component\n      [fluentBinding]=\"{ component, schema, control, model }\"\n      [ngClass]=\"subschema.class\"\n      [ngStyle]=\"subschema.style\"\n      [nzTitle]=\"subschema.title | template\"\n      [nzSubtitle]=\"subschema.subtitle | template\"\n      [nzDescription]=\"subschema.description | template\"\n      [nzDisabled]=\"subschema.disabled | reactive: model : subschema : control\"\n      [nzStatus]=\"subschema.status ?? schema.active === index ? 'process' : 'wait'\"\n      [hidden]=\"subschema.hidden | reactive: model : subschema : control\"></nz-step>\n  </nz-steps>\n\n  <fluent-row\n    *ngFor=\"let stepSchema of schema.schemas; index as stepIndex\"\n    #parentRow=\"fluentParentRow\"\n    [gap]=\"parentRow.gap\"\n    [hidden]=\"schema.active !== stepIndex\"\n    [style.margin-top.px]=\"16\">\n    <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n      <fluent-col\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n      </fluent-col>\n    </ng-template>\n\n    <ng-container\n      *ngFor=\"let subschema of stepSchema.schemas\"\n      [ngTemplateOutlet]=\"formColTemplate\"\n      [ngTemplateOutletContext]=\"{ control: (subschema.key | control: control), schema: subschema, model: model }\">\n    </ng-container>\n  </fluent-row>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: NzStepsModule }, { kind: "component", type: i1$7.NzStepsComponent, selector: "nz-steps", inputs: ["nzCurrent", "nzDirection", "nzLabelPlacement", "nzType", "nzSize", "nzStartIndex", "nzStatus", "nzProgressDot"], outputs: ["nzIndexChange"], exportAs: ["nzSteps"] }, { kind: "component", type: i1$7.NzStepComponent, selector: "nz-step", inputs: ["nzTitle", "nzSubtitle", "nzDescription", "nzDisabled", "nzPercentage", "nzSize", "nzStatus", "nzIcon"], exportAs: ["nzStep"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentRowDirective, selector: "fluent-row,[fluentRow]", inputs: ["gap", "justify", "align"], exportAs: ["fluentRow"] }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "component", type: FluentFormItemOutletComponent, selector: "fluent-col[schema],[fluentFormItemOutlet]", inputs: ["control", "schema", "model"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentParentRowDirective, selector: "fluent-row", exportAs: ["fluentParentRow"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentControlPipe, name: "control" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: StepsWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        NzStepsModule,
                        FluentGridModule,
                        FluentFormItemOutletComponent,
                        FluentBindingDirective,
                        FluentParentRowDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentControlPipe,
                        FluentColumnPipe,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-steps\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzType]=\"schema.type ?? 'default'\"\n    [nzCurrent]=\"schema.active ?? 0\"\n    [nzLabelPlacement]=\"schema.placement ?? 'horizontal'\"\n    [nzProgressDot]=\"schema.dot\"\n    [nzSize]=\"schema.size ?? 'default'\"\n    [nzStatus]=\"schema.status ?? 'process'\"\n    [nzStartIndex]=\"schema.start ?? 0\"\n    (nzIndexChange)=\"schema.active = $event\">\n    <nz-step\n      *ngFor=\"let subschema of schema.schemas; index as index\"\n      #component\n      [fluentBinding]=\"{ component, schema, control, model }\"\n      [ngClass]=\"subschema.class\"\n      [ngStyle]=\"subschema.style\"\n      [nzTitle]=\"subschema.title | template\"\n      [nzSubtitle]=\"subschema.subtitle | template\"\n      [nzDescription]=\"subschema.description | template\"\n      [nzDisabled]=\"subschema.disabled | reactive: model : subschema : control\"\n      [nzStatus]=\"subschema.status ?? schema.active === index ? 'process' : 'wait'\"\n      [hidden]=\"subschema.hidden | reactive: model : subschema : control\"></nz-step>\n  </nz-steps>\n\n  <fluent-row\n    *ngFor=\"let stepSchema of schema.schemas; index as stepIndex\"\n    #parentRow=\"fluentParentRow\"\n    [gap]=\"parentRow.gap\"\n    [hidden]=\"schema.active !== stepIndex\"\n    [style.margin-top.px]=\"16\">\n    <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n      <fluent-col\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [hidden]=\"schema.hidden | reactive: model : schema : control\"\n        [control]=\"control\"\n        [schema]=\"schema\"\n        [model]=\"model\">\n      </fluent-col>\n    </ng-template>\n\n    <ng-container\n      *ngFor=\"let subschema of stepSchema.schemas\"\n      [ngTemplateOutlet]=\"formColTemplate\"\n      [ngTemplateOutletContext]=\"{ control: (subschema.key | control: control), schema: subschema, model: model }\">\n    </ng-container>\n  </fluent-row>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class TabsWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TabsWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: TabsWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-tabset\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSelectedIndex]=\"schema.active\"\n    [nzType]=\"schema.type ?? 'line'\"\n    [nzSize]=\"schema.size ?? 'default'\"\n    [nzAnimated]=\"schema.animate ?? schema.type !== 'card'\"\n    [nzTabPosition]=\"schema.position ?? 'top'\"\n    [nzTabBarGutter]=\"schema.gutter\"\n    [nzCentered]=\"schema.center\">\n    <nz-tab\n      *ngFor=\"let tabSchema of schema.schemas\"\n      #component\n      [fluentBinding]=\"{ component, schema, control, model }\"\n      [ngClass]=\"tabSchema.class\"\n      [ngStyle]=\"tabSchema.style\"\n      [nzTitle]=\"tabSchema.title\"\n      [nzDisabled]=\"tabSchema.disabled | reactive: model : tabSchema : control\"\n      [hidden]=\"tabSchema.hidden | reactive: model : tabSchema : control\">\n      <fluent-row #parentRow=\"fluentParentRow\" [gap]=\"parentRow.gap\">\n        <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n          <fluent-col\n            [span]=\"schema.col | col: 'span'\"\n            [flex]=\"schema.col | col: 'flex'\"\n            [offset]=\"schema.col | col: 'offset'\"\n            [hidden]=\"schema.hidden | reactive: model : schema : control\"\n            [control]=\"control\"\n            [schema]=\"schema\"\n            [model]=\"model\">\n          </fluent-col>\n        </ng-template>\n\n        <ng-container\n          *ngFor=\"let subschema of tabSchema.schemas\"\n          [ngTemplateOutlet]=\"formColTemplate\"\n          [ngTemplateOutletContext]=\"{ control: (subschema.key | control: control), schema: subschema, model: model }\">\n        </ng-container>\n      </fluent-row>\n    </nz-tab>\n  </nz-tabset>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgFor, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "directive", type: NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "ngmodule", type: NzTabsModule }, { kind: "component", type: i1$8.NzTabSetComponent, selector: "nz-tabset", inputs: ["nzSelectedIndex", "nzTabPosition", "nzTabBarExtraContent", "nzCanDeactivate", "nzAddIcon", "nzTabBarStyle", "nzType", "nzSize", "nzAnimated", "nzTabBarGutter", "nzHideAdd", "nzCentered", "nzHideAll", "nzLinkRouter", "nzLinkExact"], outputs: ["nzSelectChange", "nzSelectedIndexChange", "nzTabListScroll", "nzClose", "nzAdd"], exportAs: ["nzTabset"] }, { kind: "component", type: i1$8.NzTabComponent, selector: "nz-tab", inputs: ["nzTitle", "nzClosable", "nzCloseIcon", "nzDisabled", "nzForceRender"], outputs: ["nzSelect", "nzDeselect", "nzClick", "nzContextmenu"], exportAs: ["nzTab"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentRowDirective, selector: "fluent-row,[fluentRow]", inputs: ["gap", "justify", "align"], exportAs: ["fluentRow"] }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "component", type: FluentFormItemOutletComponent, selector: "fluent-col[schema],[fluentFormItemOutlet]", inputs: ["control", "schema", "model"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentParentRowDirective, selector: "fluent-row", exportAs: ["fluentParentRow"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentControlPipe, name: "control" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TabsWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgFor,
                        NgClass,
                        NgStyle,
                        NgTemplateOutlet,
                        NzTabsModule,
                        FluentGridModule,
                        FluentFormItemOutletComponent,
                        FluentBindingDirective,
                        FluentParentRowDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentControlPipe,
                        FluentColumnPipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-tabset\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzSelectedIndex]=\"schema.active\"\n    [nzType]=\"schema.type ?? 'line'\"\n    [nzSize]=\"schema.size ?? 'default'\"\n    [nzAnimated]=\"schema.animate ?? schema.type !== 'card'\"\n    [nzTabPosition]=\"schema.position ?? 'top'\"\n    [nzTabBarGutter]=\"schema.gutter\"\n    [nzCentered]=\"schema.center\">\n    <nz-tab\n      *ngFor=\"let tabSchema of schema.schemas\"\n      #component\n      [fluentBinding]=\"{ component, schema, control, model }\"\n      [ngClass]=\"tabSchema.class\"\n      [ngStyle]=\"tabSchema.style\"\n      [nzTitle]=\"tabSchema.title\"\n      [nzDisabled]=\"tabSchema.disabled | reactive: model : tabSchema : control\"\n      [hidden]=\"tabSchema.hidden | reactive: model : tabSchema : control\">\n      <fluent-row #parentRow=\"fluentParentRow\" [gap]=\"parentRow.gap\">\n        <ng-template #formColTemplate let-schema=\"schema\" let-control=\"control\" let-model=\"model\">\n          <fluent-col\n            [span]=\"schema.col | col: 'span'\"\n            [flex]=\"schema.col | col: 'flex'\"\n            [offset]=\"schema.col | col: 'offset'\"\n            [hidden]=\"schema.hidden | reactive: model : schema : control\"\n            [control]=\"control\"\n            [schema]=\"schema\"\n            [model]=\"model\">\n          </fluent-col>\n        </ng-template>\n\n        <ng-container\n          *ngFor=\"let subschema of tabSchema.schemas\"\n          [ngTemplateOutlet]=\"formColTemplate\"\n          [ngTemplateOutletContext]=\"{ control: (subschema.key | control: control), schema: subschema, model: model }\">\n        </ng-container>\n      </fluent-row>\n    </nz-tab>\n  </nz-tabset>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class TextWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TextWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: TextWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-form-text\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\">\n    <ng-container *nzStringTemplateOutlet=\"schema.content | template\">{{ schema.content }}</ng-container>\n  </nz-form-text>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "ngmodule", type: NzFormModule }, { kind: "component", type: i2.NzFormTextComponent, selector: "nz-form-text", exportAs: ["nzFormText"] }, { kind: "ngmodule", type: NzOutletModule }, { kind: "directive", type: i3$1.NzStringTemplateOutletDirective, selector: "[nzStringTemplateOutlet]", inputs: ["nzStringTemplateOutletContext", "nzStringTemplateOutlet"], exportAs: ["nzStringTemplateOutlet"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TextWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzFormModule,
                        NzOutletModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-form-text\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\">\n    <ng-container *nzStringTemplateOutlet=\"schema.content | template\">{{ schema.content }}</ng-container>\n  </nz-form-text>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class TextareaWidget extends AbstractTextControlWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TextareaWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: TextareaWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"schema.autocomplete as autocomplete; else noAutocompleteTemplate\">\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <textarea\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <textarea\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-template>\n\n      <nz-autocomplete\n        #autocompleteComponent\n        [compareWith]=\"helper.autocomplete.compare | invoke: autocomplete\"\n        [nzBackfill]=\"autocomplete.backfill\"\n        [nzDataSource]=\"autocomplete.options\"\n        [nzWidth]=\"autocomplete.width\"></nz-autocomplete>\n    </ng-container>\n\n    <ng-template #noAutocompleteTemplate>\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <textarea\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <textarea\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-template>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzInputModule }, { kind: "directive", type: i2$5.NzInputDirective, selector: "input[nz-input],textarea[nz-input]", inputs: ["nzBorderless", "nzSize", "nzStepperless", "nzStatus", "disabled"], exportAs: ["nzInput"] }, { kind: "directive", type: i2$5.NzAutosizeDirective, selector: "textarea[nzAutosize]", inputs: ["nzAutosize"], exportAs: ["nzAutosize"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "ngmodule", type: NzAutocompleteModule }, { kind: "component", type: i4$1.NzAutocompleteComponent, selector: "nz-autocomplete", inputs: ["nzWidth", "nzOverlayClassName", "nzOverlayStyle", "nzDefaultActiveFirstOption", "nzBackfill", "compareWith", "nzDataSource"], outputs: ["selectionChange"], exportAs: ["nzAutocomplete"] }, { kind: "directive", type: i4$1.NzAutocompleteTriggerDirective, selector: "input[nzAutocomplete], textarea[nzAutocomplete]", inputs: ["nzAutocomplete"], exportAs: ["nzAutocompleteTrigger"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TextareaWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzInputModule,
                        FluentGridModule,
                        NzAutocompleteModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"schema.autocomplete as autocomplete; else noAutocompleteTemplate\">\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <textarea\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <textarea\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [nzAutocomplete]=\"autocompleteComponent\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-template>\n\n      <nz-autocomplete\n        #autocompleteComponent\n        [compareWith]=\"helper.autocomplete.compare | invoke: autocomplete\"\n        [nzBackfill]=\"autocomplete.backfill\"\n        [nzDataSource]=\"autocomplete.options\"\n        [nzWidth]=\"autocomplete.width\"></nz-autocomplete>\n    </ng-container>\n\n    <ng-template #noAutocompleteTemplate>\n      <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n        <textarea\n          *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n          fluentCol\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [span]=\"schema.col | col: 'span'\"\n          [flex]=\"schema.col | col: 'flex'\"\n          [offset]=\"schema.col | col: 'offset'\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-container>\n\n      <ng-template #standardTemplate>\n        <textarea\n          nz-input\n          [attr.id]=\"schema.id\"\n          [attr.name]=\"schema.key\"\n          [attr.maxlength]=\"helper.length.max | invoke: schema.length\"\n          [attr.minlength]=\"helper.length.min | invoke: schema.length\"\n          [fluentBinding]=\"{ schema, control, model }\"\n          [formControl]=\"control\"\n          [ngClass]=\"schema.class\"\n          [ngStyle]=\"schema.style\"\n          [nzAutosize]=\"schema.autosize ?? {}\"\n          [placeholder]=\"schema.placeholder ?? ''\"\n          [rows]=\"schema.rows\"\n          [autofocus]=\"schema.autofocus\"\n          [readonly]=\"schema.readonly | reactive: model : schema : control\"\n          [nzSize]=\"schema.size!\"\n          [nzBorderless]=\"schema.borderless\"></textarea>\n      </ng-template>\n    </ng-template>\n  </ng-container>\n</ng-template>\n" }]
        }] });

/**
 * @internal
 */
class TimeWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TimeWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: TimeWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-time-picker\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzId]=\"schema.id!\"\n        [nzAllowEmpty]=\"schema.clearable\"\n        [nzFormat]=\"schema.format ?? 'HH:mm:ss'\"\n        [nzHourStep]=\"schema.step?.hour!\"\n        [nzMinuteStep]=\"schema.step?.minute!\"\n        [nzSecondStep]=\"schema.step?.second!\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'clock-circle'\">\n      </nz-time-picker>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-time-picker\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzAllowEmpty]=\"schema.clearable\"\n        [nzFormat]=\"schema.format ?? 'HH:mm:ss'\"\n        [nzId]=\"schema.id!\"\n        [nzHourStep]=\"schema.step?.hour!\"\n        [nzMinuteStep]=\"schema.step?.minute!\"\n        [nzSecondStep]=\"schema.step?.second!\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'clock-circle'\">\n      </nz-time-picker>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-time-picker{width:100%}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzTimePickerModule }, { kind: "component", type: i2$a.NzTimePickerComponent, selector: "nz-time-picker", inputs: ["nzId", "nzSize", "nzStatus", "nzHourStep", "nzMinuteStep", "nzSecondStep", "nzClearText", "nzNowText", "nzOkText", "nzPopupClassName", "nzPlaceHolder", "nzAddOn", "nzDefaultOpenValue", "nzDisabledHours", "nzDisabledMinutes", "nzDisabledSeconds", "nzFormat", "nzOpen", "nzUse12Hours", "nzSuffixIcon", "nzHideDisabledOptions", "nzAllowEmpty", "nzDisabled", "nzAutoFocus", "nzBackdrop", "nzBorderless", "nzInputReadOnly"], outputs: ["nzOpenChange"], exportAs: ["nzTimePicker"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TimeWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzTimePickerModule,
                        FluentGridModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-time-picker\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzId]=\"schema.id!\"\n        [nzAllowEmpty]=\"schema.clearable\"\n        [nzFormat]=\"schema.format ?? 'HH:mm:ss'\"\n        [nzHourStep]=\"schema.step?.hour!\"\n        [nzMinuteStep]=\"schema.step?.minute!\"\n        [nzSecondStep]=\"schema.step?.second!\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'clock-circle'\">\n      </nz-time-picker>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-time-picker\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzAllowEmpty]=\"schema.clearable\"\n        [nzFormat]=\"schema.format ?? 'HH:mm:ss'\"\n        [nzId]=\"schema.id!\"\n        [nzHourStep]=\"schema.step?.hour!\"\n        [nzMinuteStep]=\"schema.step?.minute!\"\n        [nzSecondStep]=\"schema.step?.second!\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzAutoFocus]=\"schema.autofocus\"\n        [nzSize]=\"schema.size!\"\n        [nzBorderless]=\"schema.borderless\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzInputReadOnly]=\"schema.readonly | reactive: model : schema : control\"\n        [nzSuffixIcon]=\"schema.suffixIcon | template: 'clock-circle'\">\n      </nz-time-picker>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-time-picker{width:100%}\n"] }]
        }] });

/**
 * @internal
 */
class ToggleWidget extends AbstractWidget {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ToggleWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: ToggleWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-switch\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzId]=\"schema.id!\"\n    [nzCheckedChildren]=\"(schema.placeholder?.[0] | template)!\"\n    [nzUnCheckedChildren]=\"(schema.placeholder?.[1] | template)!\"\n    [nzSize]=\"schema.size!\">\n  </nz-switch>\n</ng-template>\n", styles: ["nz-switch{width:100%}\n"], dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzSwitchModule }, { kind: "component", type: i2$b.NzSwitchComponent, selector: "nz-switch", inputs: ["nzLoading", "nzDisabled", "nzControl", "nzCheckedChildren", "nzUnCheckedChildren", "nzSize", "nzId"], exportAs: ["nzSwitch"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentTemplatePipe, name: "template" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: ToggleWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzSwitchModule,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentTemplatePipe
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <nz-switch\n    #component\n    [fluentBinding]=\"{ component, schema, control, model }\"\n    [formControl]=\"control\"\n    [ngClass]=\"schema.class\"\n    [ngStyle]=\"schema.style\"\n    [nzId]=\"schema.id!\"\n    [nzCheckedChildren]=\"(schema.placeholder?.[0] | template)!\"\n    [nzUnCheckedChildren]=\"(schema.placeholder?.[1] | template)!\"\n    [nzSize]=\"schema.size!\">\n  </nz-switch>\n</ng-template>\n", styles: ["nz-switch{width:100%}\n"] }]
        }] });

/**
 * @internal
 */
class TreeSelectWidget extends AbstractWidget {
    constructor() {
        super(...arguments);
        this.InputGroup = NzFormNoStatusService;
        this.helper = {
            checkable: (checkable) => isBoolean(checkable) ? checkable : !isUndefined(checkable?.strict),
            checkStrictly: (checkable) => isBoolean(checkable) || !checkable?.strict ? false : checkable.strict,
            showExpand: (expandIcon) => isUndefined(expandIcon) ? true : !!expandIcon,
            expandedIcon: (expandIcon) => isBoolean(expandIcon) ? undefined : expandIcon
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TreeSelectWidget, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: TreeSelectWidget, isStandalone: true, selector: "ng-component", usesInheritance: true, ngImport: i0, template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-tree-select\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzId]=\"schema.id!\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzShowIcon]=\"schema.icon\"\n        [nzShowSearch]=\"schema.searchable\"\n        [nzSize]=\"schema.size!\"\n        [nzCheckable]=\"helper.checkable | invoke: schema.checkable\"\n        [nzCheckStrictly]=\"helper.checkStrictly | invoke: schema.checkable\"\n        [nzShowExpand]=\"helper.showExpand | invoke: schema.expandIcon\"\n        [nzExpandedIcon]=\"helper.expandedIcon | invoke: schema.expandIcon\"\n        [nzShowLine]=\"schema.line\"\n        [nzAsyncData]=\"schema.async\"\n        [nzNodes]=\"schema.options | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzDefaultExpandAll]=\"schema.expandAll\"\n        [nzExpandedKeys]=\"schema.expandedKeys!\"\n        [nzMultiple]=\"schema.multiple\"></nz-tree-select>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-tree-select\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzId]=\"schema.id!\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzShowIcon]=\"schema.icon\"\n        [nzShowSearch]=\"schema.searchable\"\n        [nzSize]=\"schema.size!\"\n        [nzCheckable]=\"helper.checkable | invoke: schema.checkable\"\n        [nzCheckStrictly]=\"helper.checkStrictly | invoke: schema.checkable\"\n        [nzShowExpand]=\"helper.showExpand | invoke: schema.expandIcon\"\n        [nzExpandedIcon]=\"helper.expandedIcon | invoke: schema.expandIcon\"\n        [nzShowLine]=\"schema.line\"\n        [nzAsyncData]=\"schema.async\"\n        [nzNodes]=\"schema.options | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzDefaultExpandAll]=\"schema.expandAll\"\n        [nzExpandedKeys]=\"schema.expandedKeys!\"\n        [nzMultiple]=\"schema.multiple\"></nz-tree-select>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-tree-select{width:100%}\n"], dependencies: [{ kind: "directive", type: NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i1$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i1$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "ngmodule", type: NzTreeSelectModule }, { kind: "component", type: i2$c.NzTreeSelectComponent, selector: "nz-tree-select", inputs: ["nzId", "nzAllowClear", "nzShowExpand", "nzShowLine", "nzDropdownMatchSelectWidth", "nzCheckable", "nzHideUnMatched", "nzShowIcon", "nzShowSearch", "nzDisabled", "nzAsyncData", "nzMultiple", "nzDefaultExpandAll", "nzCheckStrictly", "nzVirtualItemSize", "nzVirtualMaxBufferPx", "nzVirtualMinBufferPx", "nzVirtualHeight", "nzExpandedIcon", "nzNotFoundContent", "nzNodes", "nzOpen", "nzSize", "nzPlaceHolder", "nzDropdownStyle", "nzDropdownClassName", "nzBackdrop", "nzStatus", "nzPlacement", "nzExpandedKeys", "nzDisplayWith", "nzMaxTagCount", "nzMaxTagPlaceholder", "nzTreeTemplate"], outputs: ["nzOpenChange", "nzCleared", "nzRemoved", "nzExpandChange", "nzTreeClick", "nzTreeCheckBoxChange"], exportAs: ["nzTreeSelect"] }, { kind: "ngmodule", type: FluentGridModule }, { kind: "directive", type: FluentColDirective, selector: "fluent-col,[fluentCol]", inputs: ["span", "flex", "offset"], exportAs: ["fluentCol"] }, { kind: "directive", type: FluentInjectDirective, selector: "[fluentInject]", inputs: ["fluentInject", "fluentInjectDefault", "fluentInjectHost", "fluentInjectSelf", "fluentInjectSkipSelf", "fluentInjectOptional"] }, { kind: "directive", type: FluentBindingDirective, selector: "[fluentBinding]", inputs: ["fluentBinding"] }, { kind: "directive", type: FluentContextGuardDirective, selector: "ng-template[fluentContextGuard]", inputs: ["fluentContextGuard"] }, { kind: "pipe", type: FluentReactivePipe, name: "reactive" }, { kind: "pipe", type: FluentColumnPipe, name: "col" }, { kind: "pipe", type: InvokePipe, name: "invoke" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: TreeSelectWidget, decorators: [{
            type: Component,
            args: [{ standalone: true, imports: [
                        NgIf,
                        NgClass,
                        NgStyle,
                        ReactiveFormsModule,
                        NzTreeSelectModule,
                        FluentGridModule,
                        FluentInjectDirective,
                        FluentBindingDirective,
                        FluentContextGuardDirective,
                        FluentReactivePipe,
                        FluentColumnPipe,
                        InvokePipe,
                    ], template: "<ng-template let-control=\"control\" let-schema=\"schema\" let-model=\"model\" [fluentContextGuard]=\"contextGuard\">\n  <ng-container *fluentInject=\"InputGroup as inputGroup; optional: true\">\n    <ng-container *ngIf=\"inputGroup; else standardTemplate\">\n      <nz-tree-select\n        *ngIf=\"!(schema.hidden | reactive: model : schema : control)\"\n        #component\n        fluentCol\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [span]=\"schema.col | col: 'span'\"\n        [flex]=\"schema.col | col: 'flex'\"\n        [offset]=\"schema.col | col: 'offset'\"\n        [nzId]=\"schema.id!\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzShowIcon]=\"schema.icon\"\n        [nzShowSearch]=\"schema.searchable\"\n        [nzSize]=\"schema.size!\"\n        [nzCheckable]=\"helper.checkable | invoke: schema.checkable\"\n        [nzCheckStrictly]=\"helper.checkStrictly | invoke: schema.checkable\"\n        [nzShowExpand]=\"helper.showExpand | invoke: schema.expandIcon\"\n        [nzExpandedIcon]=\"helper.expandedIcon | invoke: schema.expandIcon\"\n        [nzShowLine]=\"schema.line\"\n        [nzAsyncData]=\"schema.async\"\n        [nzNodes]=\"schema.options | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzDefaultExpandAll]=\"schema.expandAll\"\n        [nzExpandedKeys]=\"schema.expandedKeys!\"\n        [nzMultiple]=\"schema.multiple\"></nz-tree-select>\n    </ng-container>\n\n    <ng-template #standardTemplate>\n      <nz-tree-select\n        #component\n        [fluentBinding]=\"{ component, schema, control, model }\"\n        [formControl]=\"control\"\n        [ngClass]=\"schema.class\"\n        [ngStyle]=\"schema.style\"\n        [nzId]=\"schema.id!\"\n        [nzAllowClear]=\"schema.clearable ?? true\"\n        [nzBackdrop]=\"schema.backdrop!\"\n        [nzShowIcon]=\"schema.icon\"\n        [nzShowSearch]=\"schema.searchable\"\n        [nzSize]=\"schema.size!\"\n        [nzCheckable]=\"helper.checkable | invoke: schema.checkable\"\n        [nzCheckStrictly]=\"helper.checkStrictly | invoke: schema.checkable\"\n        [nzShowExpand]=\"helper.showExpand | invoke: schema.expandIcon\"\n        [nzExpandedIcon]=\"helper.expandedIcon | invoke: schema.expandIcon\"\n        [nzShowLine]=\"schema.line\"\n        [nzAsyncData]=\"schema.async\"\n        [nzNodes]=\"schema.options | reactive: model : schema : control\"\n        [nzPlaceHolder]=\"schema.placeholder!\"\n        [nzDefaultExpandAll]=\"schema.expandAll\"\n        [nzExpandedKeys]=\"schema.expandedKeys!\"\n        [nzMultiple]=\"schema.multiple\"></nz-tree-select>\n    </ng-template>\n  </ng-container>\n</ng-template>\n", styles: ["nz-tree-select{width:100%}\n"] }]
        }] });

function withWidgets(features) {
    const flattenedFeatures = features.flat().concat(useRowWidget() // 添加内置 widget
    );
    return makeFluentFeature(0 /* FluentFormFeatureKind.Widget */, [
        {
            provide: WIDGET_MAP,
            useFactory: () => {
                const map = new Map(flattenedFeatures.filter(feature => feature.widget).map(feature => [
                    feature.kind,
                    feature.widget
                ]));
                return map;
            }
        },
        {
            provide: SCHEMA_MAP,
            useFactory: () => {
                const map = new Map(flattenedFeatures.map(feature => [
                    feature.kind,
                    feature
                ]));
                // 添加内置的 schema
                map.set(SchemaKind.Headless, { type: SchemaType.Control });
                map.set(SchemaKind.Template, { type: SchemaType.Component });
                return map;
            }
        },
        // 组件内置的 patcher
        flattenedFeatures.filter(feature => feature.patch).map(feature => provideSchemaPatcher({
            selector: feature.kind,
            patch: feature.patch
        }))
    ]);
}
function withAllWidgets() {
    return withWidgets([
        useInputWidget(),
        useTextareaWidget(),
        useNumberWidget(),
        useDateWidget(),
        useDateRangeWidget(),
        useTimeWidget(),
        useToggleWidget(),
        useSelectWidget(),
        useCascaderWidget(),
        useTreeSelectWidget(),
        useSliderWidget(),
        useRadioGroupWidget(),
        useCheckboxWidget(),
        useCheckboxGroupWidget(),
        useRateWidget(),
        useHeadingWidget(),
        useInputGroupWidget(),
        useNumberGroupWidget(),
        useTextWidget(),
        useButtonWidget(),
        useAlertWidget(),
        useStepsWidget(),
        useTabsWidget(),
        useFormGroupWidget(),
        useFormArrayWidget(),
    ]);
}
function validatorsOfTextControl(schema) {
    const validators = [];
    if (schema.length) {
        if (isNumber(schema.length)) {
            validators.push(Validators.minLength(schema.length), Validators.maxLength(schema.length));
        }
        else {
            const { min, max } = schema.length;
            min && validators.push(Validators.minLength(min));
            max && validators.push(Validators.maxLength(max));
        }
    }
    return validators;
}
function useInputWidget() {
    return {
        kind: SchemaKind.Input,
        type: SchemaType.Control,
        widget: InputWidget,
        validators: schema => {
            const validators = validatorsOfTextControl(schema);
            if (schema.type === 'email') {
                validators.push(Validators.email);
            }
            return validators;
        }
    };
}
function useTextareaWidget() {
    return {
        kind: SchemaKind.Textarea,
        type: SchemaType.Control,
        widget: TextareaWidget,
        validators: validatorsOfTextControl
    };
}
function useNumberWidget() {
    return {
        kind: SchemaKind.Number,
        type: SchemaType.Control,
        widget: NumberWidget
    };
}
function useDateWidget() {
    return {
        kind: SchemaKind.Date,
        type: SchemaType.Control,
        widget: DateWidget,
        patch: schema => {
            schema.mapper ??= {
                parser: (value) => value ? new Date(value) : null,
                formatter: value => {
                    if (!value)
                        return null;
                    return schema.time ? value.getTime() : new Date(value).setHours(0, 0, 0, 0);
                }
            };
            return schema;
        }
    };
}
function useDateRangeWidget() {
    return {
        kind: SchemaKind.DateRange,
        type: SchemaType.Control,
        widget: DateRangeWidget,
        patch: schema => {
            schema.mapper ??= {
                parser: (value) => value?.map(o => new Date(o)) ?? null,
                formatter: value => {
                    if (!value)
                        return null;
                    return value.map(date => schema.time ? date.getTime() : new Date(date).setHours(0, 0, 0, 0));
                }
            };
            return schema;
        }
    };
}
function useTimeWidget() {
    return {
        kind: SchemaKind.Time,
        type: SchemaType.Control,
        widget: TimeWidget,
        patch: schema => {
            schema.mapper ??= {
                parser: (value) => value ? new Date(value) : null,
                formatter: value => value?.getTime() ?? null
            };
            return schema;
        }
    };
}
function useToggleWidget() {
    return {
        kind: SchemaKind.Toggle,
        type: SchemaType.Control,
        widget: ToggleWidget
    };
}
function useSelectWidget() {
    return {
        kind: SchemaKind.Select,
        type: SchemaType.Control,
        widget: SelectWidget
    };
}
function useCascaderWidget() {
    return {
        kind: SchemaKind.Cascader,
        type: SchemaType.Control,
        widget: CascaderWidget
    };
}
function useTreeSelectWidget() {
    return {
        kind: SchemaKind.TreeSelect,
        type: SchemaType.Control,
        widget: TreeSelectWidget
    };
}
function useSliderWidget() {
    return {
        kind: SchemaKind.Slider,
        type: SchemaType.Control,
        widget: SilderWidget
    };
}
function useRadioGroupWidget() {
    return {
        kind: SchemaKind.RadioGroup,
        type: SchemaType.Control,
        widget: RadioGroupWidget
    };
}
function useCheckboxWidget() {
    return {
        kind: SchemaKind.Checkbox,
        type: SchemaType.Control,
        widget: CheckboxWidget
    };
}
function useCheckboxGroupWidget() {
    return {
        kind: SchemaKind.CheckboxGroup,
        type: SchemaType.Control,
        widget: CheckboxGroupWidget,
        patch: schema => {
            const labelProperty = schema.config?.labelProperty ?? 'label';
            const valueProperty = schema.config?.valueProperty ?? 'value';
            const options = schema.options;
            schema.mapper ??= {
                parser: value => options.map(option => ({
                    label: option[labelProperty],
                    value: option[valueProperty],
                    checked: !!value?.includes(option[valueProperty])
                })),
                formatter: value => value?.filter(o => o.checked).map(o => o.value)
            };
            return schema;
        }
    };
}
function useRateWidget() {
    return {
        kind: SchemaKind.Rate,
        type: SchemaType.Control,
        widget: RateWidget
    };
}
function useTextWidget() {
    return {
        kind: SchemaKind.Text,
        type: SchemaType.Component,
        widget: TextWidget
    };
}
function useHeadingWidget() {
    return {
        kind: SchemaKind.Heading,
        type: SchemaType.Component,
        widget: HeadingWidget,
        patch: schema => {
            schema.col ??= 12;
            return schema;
        },
    };
}
function useInputGroupWidget() {
    return {
        kind: SchemaKind.InputGroup,
        type: SchemaType.ControlWrapper,
        widget: InputGroupWidget
    };
}
function useNumberGroupWidget() {
    return {
        kind: SchemaKind.NumberGroup,
        type: SchemaType.ControlWrapper,
        widget: NumberGroupWidget
    };
}
function useAlertWidget() {
    return {
        kind: SchemaKind.Alert,
        type: SchemaType.Component,
        widget: AlertWidget,
        patch: schema => {
            schema.col ??= 12;
            return schema;
        },
    };
}
function useButtonWidget() {
    return [
        {
            kind: SchemaKind.Button,
            type: SchemaType.Component,
            widget: ButtonWidget,
            patch: schema => {
                if (schema.variants?.block) {
                    schema.col ??= 12;
                }
                return schema;
            }
        },
        {
            kind: SchemaKind.ButtonGroup,
            type: SchemaType.ComponentWrapper,
            widget: ButtonGroupWidget
        }
    ];
}
function useStepsWidget() {
    return [
        {
            kind: SchemaKind.Steps,
            type: SchemaType.ComponentContainer,
            widget: StepsWidget
        },
        {
            kind: SchemaKind.Step,
            type: SchemaType.ComponentContainer,
        }
    ];
}
function useTabsWidget() {
    return [
        {
            kind: SchemaKind.Tabs,
            type: SchemaType.ComponentContainer,
            widget: TabsWidget
        },
        {
            kind: SchemaKind.Tab,
            type: SchemaType.ComponentContainer,
        }
    ];
}
/**
 * @internal
 */
function useRowWidget() {
    return {
        kind: SchemaKind.Row,
        type: SchemaType.ComponentContainer,
        widget: RowWidget
    };
}
function useFormGroupWidget() {
    return {
        kind: SchemaKind.Group,
        type: SchemaType.ControlContainer,
        widget: FormGroupWidget,
        patch: schema => {
            schema.layout ??= 'vertical';
            schema.gap ??= { xs: 1, sm: 2, md: 3, lg: 4, xl: 5 };
            return schema;
        }
    };
}
function useFormArrayWidget() {
    return {
        kind: SchemaKind.Array,
        type: SchemaType.ControlContainer,
        widget: FormArrayWidget
    };
}

function provideFluentForm(...features) {
    return makeEnvironmentProviders([
        features.map(feature => feature.providers)
    ]);
}

class FluentFormModule {
    static forRoot(...features) {
        return {
            ngModule: FluentFormModule,
            providers: [
                provideFluentForm(...features)
            ]
        };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: FluentFormModule, imports: [FluentFormComponent,
            FluentTemplateDirective], exports: [FluentFormComponent,
            FluentTemplateDirective] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormModule, imports: [FluentFormComponent] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FluentFormModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        FluentFormComponent,
                        FluentTemplateDirective,
                    ],
                    exports: [
                        FluentFormComponent,
                        FluentTemplateDirective,
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-fluent-form
 */

/**
 * Generated bundle index. Do not edit.
 */

export { FluentBindingDirective, FluentColDirective, FluentContextDirective, FluentContextGuardDirective, FluentFormComponent, FluentFormDirective, FluentFormItemOutletComponent, FluentFormLayoutModule, FluentFormModule, FluentGridModule, FluentInjectDirective, FluentLifeCycleDirective, FluentOutletDirective, FluentParentRowDirective, FluentRowDirective, FluentTemplateDirective, FluentVarDirective, FluentWithInjectorDirective, FormUtil, ModelUtil, SCHEMA_PATCHERS, SchemaKind, SchemaType, SchemaUtil, ValueUtil, alert, array, button, buttonGroup, cascader, checkbox, checkboxGroup, composeBuilder, date, dateRange, datetime, form, getChildControl, getCurrentSchema, group, heading1, heading2, heading3, heading4, heading5, heading6, headless, input, inputGroup, isArray, isBoolean, isBuilder, isFunction, isNumber, isObject, isString, isUndefined, number, numberGroup, password, provideFluentForm, provideSchemaPatcher, radioGroup, rate, row, select, slider, step, steps, tab, tabs, template, text, textarea, time, toggle, treeSelect, useAlertWidget, useButtonWidget, useCascaderWidget, useCheckboxGroupWidget, useCheckboxWidget, useDateRangeWidget, useDateWidget, useFormArrayWidget, useFormGroupWidget, useHeadingWidget, useInputGroupWidget, useInputWidget, useNumberGroupWidget, useNumberWidget, useRadioGroupWidget, useRateWidget, useSelectWidget, useSliderWidget, useStepsWidget, useTabsWidget, useTextWidget, useTextareaWidget, useTimeWidget, useToggleWidget, useTreeSelectWidget, withAllWidgets, withSchemaPatchers, withStaticExpression, withWidgets };
//# sourceMappingURL=ngx-fluent-form.mjs.map
